/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(O){for(var t=[],_=0,D=O.length;_<D;_++)t[_]=ie[O[_]];return t};const We=this,Ce=typeof global=="object"?global:{};var fe;(function(O){O.global=We;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=t})(fe||(fe={}));var fe;(function(O){class t{constructor(h,E,d){this.type=h,this.detail=E,this.timestamp=d}}O.LoaderEvent=t;class _{constructor(h){this._events=[new t(1,"",h)]}record(h,E){this._events.push(new t(h,E,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=_;class D{record(h,E){}getEvents(){return[]}}D.INSTANCE=new D,O.NullLoaderEventRecorder=D})(fe||(fe={}));var fe;(function(O){class t{static fileUriToFilePath(D,r){if(r=decodeURI(r).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(D,r){return D.length>=r.length&&D.substr(0,r.length)===r}static endsWith(D,r){return D.length>=r.length&&D.substr(D.length-r.length)===r}static containsQueryString(D){return/^[^\#]*\?/gi.test(D)}static isAbsolutePath(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)}static forEachProperty(D,r){if(D){let h;for(h in D)D.hasOwnProperty(h)&&r(h,D[h])}}static isEmpty(D){let r=!0;return t.forEachProperty(D,()=>{r=!1}),r}static recursiveClone(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;let r=Array.isArray(D)?[]:{};return t.forEachProperty(D,(h,E)=>{E&&typeof E=="object"?r[h]=t.recursiveClone(E):r[h]=E}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(D){return t.startsWith(D,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,O.Utilities=t})(fe||(fe={}));var fe;(function(O){function t(r){if(r instanceof Error)return r;const h=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(h.stack=r.stack),h}O.ensureError=t;class _{static validateConfigurationOptions(h){function E(d){if(d.phase==="loading"){console.error('Loading "'+d.moduleId+'" failed'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}if(d.phase==="factory"){console.error('The factory function of "'+d.moduleId+'" has thrown an exception'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}}if(h=h||{},typeof h.baseUrl!="string"&&(h.baseUrl=""),typeof h.isBuild!="boolean"&&(h.isBuild=!1),typeof h.paths!="object"&&(h.paths={}),typeof h.config!="object"&&(h.config={}),typeof h.catchError>"u"&&(h.catchError=!1),typeof h.recordStats>"u"&&(h.recordStats=!1),typeof h.urlArgs!="string"&&(h.urlArgs=""),typeof h.onError!="function"&&(h.onError=E),Array.isArray(h.ignoreDuplicateModules)||(h.ignoreDuplicateModules=[]),h.baseUrl.length>0&&(O.Utilities.endsWith(h.baseUrl,"/")||(h.baseUrl+="/")),typeof h.cspNonce!="string"&&(h.cspNonce=""),typeof h.preferScriptTags>"u"&&(h.preferScriptTags=!1),h.nodeCachedData&&typeof h.nodeCachedData=="object"&&(typeof h.nodeCachedData.seed!="string"&&(h.nodeCachedData.seed="seed"),(typeof h.nodeCachedData.writeDelay!="number"||h.nodeCachedData.writeDelay<0)&&(h.nodeCachedData.writeDelay=1e3*7),!h.nodeCachedData.path||typeof h.nodeCachedData.path!="string")){const d=t(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",h.onError(d),h.nodeCachedData=void 0}return h}static mergeConfigurationOptions(h=null,E=null){let d=O.Utilities.recursiveClone(E||{});return O.Utilities.forEachProperty(h,(l,s)=>{l==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules<"u"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(s):l==="paths"&&typeof d.paths<"u"?O.Utilities.forEachProperty(s,(g,A)=>d.paths[g]=A):l==="config"&&typeof d.config<"u"?O.Utilities.forEachProperty(s,(g,A)=>d.config[g]=A):d[l]=O.Utilities.recursiveClone(s)}),_.validateConfigurationOptions(d)}}O.ConfigurationOptionsUtil=_;class D{constructor(h,E){if(this._env=h,this.options=_.mergeConfigurationOptions(E),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let d=this.options.nodeRequire.main.filename,l=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let h=0;h<this.options.ignoreDuplicateModules.length;h++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[h]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(h,E)=>{Array.isArray(E)?this.sortedPathsRules.push({from:h,to:E}):this.sortedPathsRules.push({from:h,to:[E]})}),this.sortedPathsRules.sort((h,E)=>E.from.length-h.from.length)}cloneAndMerge(h){return new D(this._env,_.mergeConfigurationOptions(h,this.options))}getOptionsLiteral(){return this.options}_applyPaths(h){let E;for(let d=0,l=this.sortedPathsRules.length;d<l;d++)if(E=this.sortedPathsRules[d],O.Utilities.startsWith(h,E.from)){let s=[];for(let g=0,A=E.to.length;g<A;g++)s.push(E.to[g]+h.substr(E.from.length));return s}return[h]}_addUrlArgsToUrl(h){return O.Utilities.containsQueryString(h)?h+"&"+this.options.urlArgs:h+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(h){return this.options.urlArgs?this._addUrlArgsToUrl(h):h}_addUrlArgsIfNecessaryToUrls(h){if(this.options.urlArgs)for(let E=0,d=h.length;E<d;E++)h[E]=this._addUrlArgsToUrl(h[E]);return h}moduleIdToPaths(h){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(h))return this.isBuild()?["empty:"]:["node|"+h];let E=h,d;if(!O.Utilities.endsWith(E,".js")&&!O.Utilities.isAbsolutePath(E)){d=this._applyPaths(E);for(let l=0,s=d.length;l<s;l++)this.isBuild()&&d[l]==="empty:"||(O.Utilities.isAbsolutePath(d[l])||(d[l]=this.options.baseUrl+d[l]),!O.Utilities.endsWith(d[l],".js")&&!O.Utilities.containsQueryString(d[l])&&(d[l]=d[l]+".js"))}else!O.Utilities.endsWith(E,".js")&&!O.Utilities.containsQueryString(E)&&(E=E+".js"),d=[E];return this._addUrlArgsIfNecessaryToUrls(d)}requireToUrl(h){let E=h;return O.Utilities.isAbsolutePath(E)||(E=this._applyPaths(E)[0],O.Utilities.isAbsolutePath(E)||(E=this.options.baseUrl+E)),this._addUrlArgsIfNecessaryToUrl(E)}isBuild(){return this.options.isBuild}shouldInvokeFactory(h){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(h)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[h])}isDuplicateMessageIgnoredFor(h){return this.ignoreDuplicateModulesMap.hasOwnProperty(h)}getConfigForModule(h){if(this.options.config)return this.options.config[h]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(h){this.options.onError(h)}}O.Configuration=D})(fe||(fe={}));var fe;(function(O){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,g,A,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new _:this._scriptLoader=new h(this._env)}else this._env.isNode?this._scriptLoader=new h(this._env):this._scriptLoader=new _;let $={callback:A,errorback:b};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push($);return}this._callbackMap[g]=[$],this._scriptLoader.load(s,g,()=>this.triggerCallback(g),e=>this.triggerErrorback(g,e))}triggerCallback(s){let g=this._callbackMap[s];delete this._callbackMap[s];for(let A=0;A<g.length;A++)g[A].callback()}triggerErrorback(s,g){let A=this._callbackMap[s];delete this._callbackMap[s];for(let b=0;b<A.length;b++)A[b].errorback(g)}}class _{attachListeners(s,g,A){let b=()=>{s.removeEventListener("load",$),s.removeEventListener("error",e)},$=v=>{b(),g()},e=v=>{b(),A(v)};s.addEventListener("load",$),s.addEventListener("error",e)}load(s,g,A,b){if(/^node\|/.test(g)){let $=s.getConfig().getOptionsLiteral(),e=E(s.getRecorder(),$.nodeRequire||O.global.nodeRequire),v=g.split("|"),R=null;try{R=e(v[1])}catch(L){b(L);return}s.enqueueDefineAnonymousModule([],()=>R),A()}else{let $=document.createElement("script");$.setAttribute("async","async"),$.setAttribute("type","text/javascript"),this.attachListeners($,A,b);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(g=e.createScriptURL(g)),$.setAttribute("src",g);const{cspNonce:v}=s.getConfig().getOptionsLiteral();v&&$.setAttribute("nonce",v),document.getElementsByTagName("head")[0].appendChild($)}}}function D(l){const{trustedTypesPolicy:s}=l.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=D(s)),this._cachedCanUseEval}load(s,g,A,b){if(/^node\|/.test(g)){const $=s.getConfig().getOptionsLiteral(),e=E(s.getRecorder(),$.nodeRequire||O.global.nodeRequire),v=g.split("|");let R=null;try{R=e(v[1])}catch(L){b(L);return}s.enqueueDefineAnonymousModule([],function(){return R}),A()}else{const{trustedTypesPolicy:$}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(g).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${g}`,($?self.eval($.createScript("",v)):new Function(v)).call(self),A()}).then(void 0,b);return}try{$&&(g=$.createScriptURL(g)),importScripts(g),A()}catch(v){b(v)}}}}class h{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,g){const{nodeCachedData:A}=g.getConfig().getOptionsLiteral();if(!A||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,$=s("module");function e(v){const R=v.constructor;let L=function(c){try{return v.require(c)}finally{}};return L.resolve=function(c,f){return R._resolveFilename(c,v,!1,f)},L.resolve.paths=function(c){return R._resolveLookupPaths(c,v)},L.main=process.mainModule,L.extensions=R._extensions,L.cache=R._cache,L}$.prototype._compile=function(v,R){const L=$.wrap(v.replace(/^#!.*/,"")),o=g.getRecorder(),c=b._getCachedDataPath(A,R),f={filename:R};let u;try{const p=b._fs.readFileSync(c);u=p.slice(0,16),f.cachedData=p.slice(16),o.record(60,c)}catch{o.record(61,c)}const i=new b._vm.Script(L,f),a=i.runInThisContext(f),N=b._path.dirname(R),m=e(this),w=[this.exports,m,this,R,N,process,Ce,Buffer],M=a.apply(this.exports,w);return b._handleCachedData(i,L,c,!f.cachedData,g),b._verifyCachedData(i,L,c,u,g),M}}load(s,g,A,b){const $=s.getConfig().getOptionsLiteral(),e=E(s.getRecorder(),$.nodeRequire||O.global.nodeRequire),v=$.nodeInstrumenter||function(L){return L};this._init(e),this._initNodeRequire(e,s);let R=s.getRecorder();if(/^node\|/.test(g)){let L=g.split("|"),o=null;try{o=e(L[1])}catch(c){b(c);return}s.enqueueDefineAnonymousModule([],()=>o),A()}else{g=O.Utilities.fileUriToFilePath(this._env.isWindows,g);const L=this._path.normalize(g),o=this._getElectronRendererScriptPathOrUri(L),c=!!$.nodeCachedData,f=c?this._getCachedDataPath($.nodeCachedData,g):void 0;this._readSourceAndCachedData(L,f,R,(u,i,a,N)=>{if(u){b(u);return}let m;i.charCodeAt(0)===h._BOM?m=h._PREFIX+i.substring(1)+h._SUFFIX:m=h._PREFIX+i+h._SUFFIX,m=v(m,L);const w={filename:o,cachedData:a},M=this._createAndEvalScript(s,m,w,A,b);this._handleCachedData(M,m,f,c&&!a,s),this._verifyCachedData(M,m,f,N,s)})}}_createAndEvalScript(s,g,A,b,$){const e=s.getRecorder();e.record(31,A.filename);const v=new this._vm.Script(g,A),R=v.runInThisContext(A),L=s.getGlobalAMDDefineFunc();let o=!1;const c=function(){return o=!0,L.apply(null,arguments)};return c.amd=L.amd,R.call(O.global,s.getGlobalAMDRequireFunc(),c,A.filename,this._path.dirname(A.filename)),e.record(32,A.filename),o?b():$(new Error(`Didn't receive define call in ${A.filename}!`)),v}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let g=s.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,g){const A=this._crypto.createHash("md5").update(g,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(g).replace(/\.js$/,"");return this._path.join(s.path,`${b}-${A}.code`)}_handleCachedData(s,g,A,b,$){s.cachedDataRejected?this._fs.unlink(A,e=>{$.getRecorder().record(62,A),this._createAndWriteCachedData(s,g,A,$),e&&$.getConfig().onError(e)}):b&&this._createAndWriteCachedData(s,g,A,$)}_createAndWriteCachedData(s,g,A,b){let $=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,v=0,R;const L=()=>{setTimeout(()=>{R||(R=this._crypto.createHash("md5").update(g,"utf8").digest());const o=s.createCachedData();if(!(o.length===0||o.length===e||v>=5)){if(o.length<e){L();return}e=o.length,this._fs.writeFile(A,Buffer.concat([R,o]),c=>{c&&b.getConfig().onError(c),b.getRecorder().record(63,A),L()})}},$*Math.pow(4,v++))};L()}_readSourceAndCachedData(s,g,A,b){if(!g)this._fs.readFile(s,{encoding:"utf8"},b);else{let $,e,v,R=2;const L=o=>{o?b(o):--R===0&&b(void 0,$,e,v)};this._fs.readFile(s,{encoding:"utf8"},(o,c)=>{$=c,L(o)}),this._fs.readFile(g,(o,c)=>{!o&&c&&c.length>0?(v=c.slice(0,16),e=c.slice(16),A.record(60,g)):A.record(61,g),L()})}}_verifyCachedData(s,g,A,b,$){b&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(g,"utf8").digest();b.equals(e)||($.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${A}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(A,v=>{v&&$.getConfig().onError(v)}))},Math.ceil(5e3*(1+Math.random()))))}}h._BOM=65279,h._PREFIX="(function (require, define, __filename, __dirname) { ",h._SUFFIX=`
});`;function E(l,s){if(s.__$__isRecorded)return s;const g=function(b){l.record(33,b);try{return s(b)}finally{l.record(34,b)}};return g.__$__isRecorded=!0,g}O.ensureRecordedNodeRequire=E;function d(l){return new t(l)}O.createScriptLoader=d})(fe||(fe={}));var fe;(function(O){class t{constructor(l){let s=l.lastIndexOf("/");s!==-1?this.fromModulePath=l.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(l){let s=l,g;for(g=/\/\.\//;g.test(s);)s=s.replace(g,"/");for(s=s.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(s);)s=s.replace(g,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(l){let s=l;return O.Utilities.isAbsolutePath(s)||(O.Utilities.startsWith(s,"./")||O.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),O.ModuleIdResolver=t;class _{constructor(l,s,g,A,b,$){this.id=l,this.strId=s,this.dependencies=g,this._callback=A,this._errorback=b,this.moduleIdResolver=$,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,s){try{return{returnedValue:l.apply(O.global,s),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(l,s,g,A){return l.shouldInvokeFactory(s)?l.shouldCatchError()?this._safeInvokeFunction(g,A):{returnedValue:g.apply(O.global,A),producedError:null}:{returnedValue:null,producedError:null}}complete(l,s,g,A){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let $=_._invokeFactory(s,this.strId,this._callback,g);b=$.producedError,l.record(22,this.strId),!b&&typeof $.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=$.returnedValue)}else this.exports=this._callback;if(b){let $=O.ensureError(b);$.phase="factory",$.moduleId=this.strId,$.neededBy=A(this.id),this.error=$,s.onError($)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}O.Module=_;class D{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let s=this._strModuleIdToIntModuleId.get(l);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(l,s),this._intModuleIdToStrModuleId[s]=l),s}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class r{constructor(l){this.id=l}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),O.RegularDependency=r;class h{constructor(l,s,g){this.id=l,this.pluginId=s,this.pluginParam=g}}O.PluginDependency=h;class E{constructor(l,s,g,A,b=0){this._env=l,this._scriptLoader=s,this._loaderAvailableTimestamp=b,this._defineFunc=g,this._requireFunc=A,this._moduleIdProvider=new D,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new E(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,s){let g=$=>$.replace(/\\/g,"/"),A=g(l),b=s.split(/\n/);for(let $=0;$<b.length;$++){let e=b[$].match(/(.*):(\d+):(\d+)\)?$/);if(e){let v=e[1],R=e[2],L=e[3],o=Math.max(v.lastIndexOf(" ")+1,v.lastIndexOf("(")+1);if(v=v.substr(o),v=g(v),v===A){let c={line:parseInt(R,10),col:parseInt(L,10)};return c.line===1&&(c.col-=53),c}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],s=0;for(let g=0,A=this._modules2.length;g<A;g++){let b=this._modules2[g];if(!b)continue;let $=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,v=this._buildInfoDependencies[b.id];l[s++]={id:b.strId,path:$,defineLocation:$&&e?E._findRelevantLocationInStack($,e):null,dependencies:v,shim:null,exports:b.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:l,callback:s}}defineModule(l,s,g,A,b,$=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let v=new _(e,l,this._normalizeDependencies(s,$),g,A,$);this._modules2[e]=v,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(v.dependencies||[]).map(R=>this._moduleIdProvider.getStrModuleId(R.id))),this._resolve(v)}_normalizeDependency(l,s){if(l==="exports")return r.EXPORTS;if(l==="module")return r.MODULE;if(l==="require")return r.REQUIRE;let g=l.indexOf("!");if(g>=0){let A=s.resolveModule(l.substr(0,g)),b=s.resolveModule(l.substr(g+1)),$=this._moduleIdProvider.getModuleId(A+"!"+b),e=this._moduleIdProvider.getModuleId(A);return new h($,e,b)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(l)))}_normalizeDependencies(l,s){let g=[],A=0;for(let b=0,$=l.length;b<$;b++)g[A++]=this._normalizeDependency(l[b],s);return g}_relativeRequire(l,s,g,A){if(typeof s=="string")return this.synchronousRequire(s,l);this.defineModule(O.Utilities.generateAnonymousModule(),s,g,A,null,l)}synchronousRequire(l,s=new t(l)){let g=this._normalizeDependency(l,s),A=this._modules2[g.id];if(!A)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!A.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(A.error)throw A.error;return A.exports}configure(l,s){let g=this._config.shouldRecordStats();s?this._config=new O.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),s.dependencies,s.callback,null,s.stack)}}_createLoadError(l,s){let g=this._moduleIdProvider.getStrModuleId(l),A=(this._inverseDependencies2[l]||[]).map($=>this._moduleIdProvider.getStrModuleId($));const b=O.ensureError(s);return b.phase="loading",b.moduleId=g,b.neededBy=A,b}_onLoadError(l,s){const g=this._createLoadError(l,s);this._modules2[l]||(this._modules2[l]=new _(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let A=[];for(let e=0,v=this._moduleIdProvider.getMaxModuleId();e<v;e++)A[e]=!1;let b=!1,$=[];for($.push(l),A[l]=!0;$.length>0;){let e=$.shift(),v=this._modules2[e];v&&(b=v.onDependencyError(g)||b);let R=this._inverseDependencies2[e];if(R)for(let L=0,o=R.length;L<o;L++){let c=R[L];A[c]||($.push(c),A[c]=!0)}}b||this._config.onError(g)}_hasDependencyPath(l,s){let g=this._modules2[l];if(!g)return!1;let A=[];for(let $=0,e=this._moduleIdProvider.getMaxModuleId();$<e;$++)A[$]=!1;let b=[];for(b.push(g),A[l]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let v=0,R=e.length;v<R;v++){let L=e[v];if(L.id===s)return!0;let o=this._modules2[L.id];o&&!A[L.id]&&(A[L.id]=!0,b.push(o))}}return!1}_findCyclePath(l,s,g){if(l===s||g===50)return[l];let A=this._modules2[l];if(!A)return null;let b=A.dependencies;if(b)for(let $=0,e=b.length;$<e;$++){let v=this._findCyclePath(b[$].id,s,g+1);if(v!==null)return v.push(l),v}return null}_createRequire(l){let s=(g,A,b)=>this._relativeRequire(l,g,A,b);return s.toUrl=g=>this._config.requireToUrl(l.resolveModule(g)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(g,A=!1)=>{this.configure(g,A)},s.__$__nodeRequire=O.global.nodeRequire,s}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let s=this._moduleIdProvider.getStrModuleId(l),g=this._config.moduleIdToPaths(s),A=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||A.test(s))&&g.push("node|"+s);let b=-1,$=e=>{if(b++,b>=g.length)this._onLoadError(l,e);else{let v=g[b],R=this.getRecorder();if(this._config.isBuild()&&v==="empty:"){this._buildInfoPath[l]=v,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}R.record(10,v),this._scriptLoader.load(this,v,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=v),R.record(11,v),this._onLoad(l)},L=>{R.record(12,v),$(L)})}};$(null)}_loadPluginDependency(l,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let g=A=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],A,null,null)};g.error=A=>{this._config.onError(this._createLoadError(s.id,A))},l.load(s.pluginParam,this._createRequire(t.ROOT),g,this._config.getOptionsLiteral())}_resolve(l){let s=l.dependencies;if(s)for(let g=0,A=s.length;g<A;g++){let b=s[g];if(b===r.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(b===r.MODULE){l.unresolvedDependenciesCount--;continue}if(b===r.REQUIRE){l.unresolvedDependenciesCount--;continue}let $=this._modules2[b.id];if($&&$.isComplete()){if($.error){l.onDependencyError($.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,l.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(v=>this._moduleIdProvider.getStrModuleId(v)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(l.id),b instanceof h){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let v=this._inversePluginDependencies2.get(b.pluginId);v||(v=[],this._inversePluginDependencies2.set(b.pluginId,v)),v.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let s=this.getRecorder();if(l.isComplete())return;let g=l.dependencies,A=[];if(g)for(let v=0,R=g.length;v<R;v++){let L=g[v];if(L===r.EXPORTS){A[v]=l.exports;continue}if(L===r.MODULE){A[v]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(L===r.REQUIRE){A[v]=this._createRequire(l.moduleIdResolver);continue}let o=this._modules2[L.id];if(o){A[v]=o.exports;continue}A[v]=null}const b=v=>(this._inverseDependencies2[v]||[]).map(R=>this._moduleIdProvider.getStrModuleId(R));l.complete(s,this._config,A,b);let $=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,$)for(let v=0,R=$.length;v<R;v++){let L=$[v],o=this._modules2[L];o.unresolvedDependenciesCount--,o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let v=0,R=e.length;v<R;v++)this._loadPluginDependency(l.exports,e[v])}}}O.ModuleManager=E})(fe||(fe={}));var te,fe;(function(O){const t=new O.Environment;let _=null;const D=function(d,l,s){typeof d!="string"&&(s=l,l=d,d=null),(typeof l!="object"||!Array.isArray(l))&&(s=l,l=null),l||(l=["require","exports","module"]),d?_.defineModule(d,l,s,null,null):_.enqueueDefineAnonymousModule(l,s)};D.amd={jQuery:!0};const r=function(d,l=!1){_.configure(d,l)},h=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return _.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){_.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};h.config=r,h.getConfig=function(){return _.getConfig().getOptionsLiteral()},h.reset=function(){_=_.reset()},h.getBuildInfo=function(){return _.getBuildInfo()},h.getStats=function(){return _.getLoaderEvents()},h.define=D;function E(){if(typeof O.global.require<"u"||typeof require<"u"){const d=O.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){const l=O.ensureRecordedNodeRequire(_.getRecorder(),d);O.global.nodeRequire=l,h.nodeRequire=l,h.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=h:(t.isElectronRenderer||(O.global.define=D),O.global.require=h)}O.init=E,(typeof O.global.define!="function"||!O.global.define.amd)&&(_=new O.ModuleManager(t,O.createScriptLoader(t),D,h,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&h.config(O.global.require),te=function(){return D.apply(null,arguments)},te.amd=D.amd,typeof doNotInitLoader>"u"&&E())})(fe||(fe={})),te(ie[69],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function _(d,l,s,g){if(g=g||{},(g["vs/css"]||{}).disabled){s({});return}const b=l.toUrl(d+".css");D(d,b,()=>{s({})},$=>{typeof s.error=="function"&&s.error("Could not find "+b+".")})}t.load=_;function D(d,l,s,g){if(r(d,l)){s();return}h(d,l,s,g)}function r(d,l){const s=document.getElementsByTagName("link");for(let g=0,A=s.length;g<A;g++){const b=s[g].getAttribute("data-name"),$=s[g].getAttribute("href");if(b===d||$===l)return!0}return!1}function h(d,l,s,g){const A=document.createElement("link");A.setAttribute("rel","stylesheet"),A.setAttribute("type","text/css"),A.setAttribute("data-name",d),E(d,A,s,g),A.setAttribute("href",l),(document.head||document.getElementsByTagName("head")[0]).appendChild(A)}function E(d,l,s,g){const A=()=>{l.removeEventListener("load",b),l.removeEventListener("error",$)},b=e=>{A(),s()},$=e=>{A(),g(e)};l.addEventListener("load",b),l.addEventListener("error",$)}}),te("vs/nls",["require","exports"],function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let _=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const D="i-default";function r(R,L){let o;return L.length===0?o=R:o=R.replace(/\{(\d+)\}/g,(c,f)=>{const u=f[0],i=L[u];let a=c;return typeof i=="string"?a=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(a=String(i)),a}),_&&(o="\uFF3B"+o.replace(/[aouei]/g,"$&$&")+"\uFF3D"),o}function h(R,L){let o=R[L];return o||(o=R["*"],o)?o:null}function E(R){return R.charAt(R.length-1)==="/"?R:R+"/"}async function d(R,L,o){const c=E(R)+E(L)+"vscode/"+E(o),f=await fetch(c);if(f.ok)return await f.json();throw new Error(`${f.status} - ${f.statusText}`)}function l(R){return function(L,o){const c=Array.prototype.slice.call(arguments,2);return r(R[L],c)}}function s(R){return(L,o,...c)=>({value:r(R[L],c),original:r(o,c)})}function g(R,L,...o){return r(L,o)}t.localize=g;function A(R,L,...o){const c=r(L,o);return{value:c,original:c}}t.localize2=A;function b(R){}t.getConfiguredDefaultLocale=b;function $(R){_=R}t.setPseudoTranslation=$;function e(R,L){return{localize:l(L[R]),localize2:s(L[R]),getConfiguredDefaultLocale:L.getConfiguredDefaultLocale??(o=>{})}}t.create=e;function v(R,L,o,c){const f=c["vs/nls"]??{};if(!R||R.length===0)return o({localize:g,localize2:A,getConfiguredDefaultLocale:()=>f.availableLanguages?.["*"]});const u=f.availableLanguages?h(f.availableLanguages,R):null,i=u===null||u===D;let a=".nls";i||(a=a+"."+u);const N=m=>{Array.isArray(m)?(m.localize=l(m),m.localize2=s(m)):(m.localize=l(m[R]),m.localize2=s(m[R])),m.getConfiguredDefaultLocale=()=>f.availableLanguages?.["*"],o(m)};typeof f.loadBundle=="function"?f.loadBundle(R,u,(m,w)=>{m?L([R+".nls"],N):N(w)}):f.translationServiceUrl&&!i?(async()=>{try{const m=await d(f.translationServiceUrl,u,R);return N(m)}catch(m){if(!u.includes("-"))return console.error(m),L([R+".nls"],N);try{const w=u.split("-")[0],M=await d(f.translationServiceUrl,w,R);return f.availableLanguages??={},f.availableLanguages["*"]=w,N(M)}catch(w){return console.error(w),L([R+".nls"],N)}}})():L([R+a],N,m=>{if(a===".nls"){console.error("Failed trying to load default language strings",m);return}console.error(`Failed to load message bundle for language ${u}. Falling back to the default language:`,m),L([R+".nls"],N)})}t.load=v}),function(){const O=globalThis.MonacoEnvironment,t=O&&O.baseUrl?O.baseUrl:"../../../";function _(g,A){if(O?.createTrustedTypesPolicy)try{return O.createTrustedTypesPolicy(g,A)}catch(b){console.warn(b);return}try{return self.trustedTypes?.createPolicy(g,A)}catch(b){console.warn(b);return}}const D=_("amdLoader",{createScriptURL:g=>g,createScript:(g,...A)=>{const b=A.slice(0,-1).join(","),$=A.pop().toString();return`(function anonymous(${b}) { ${$}
})`}});function r(){try{return(D?globalThis.eval(D.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function h(){return new Promise((g,A)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return g();const b=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(b).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${b}`,(D?globalThis.eval(D.createScript("",e)):new Function(e)).call(globalThis),g()}).then(void 0,A);return}D?importScripts(D.createScriptURL(b)):importScripts(b),g()})}function E(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function d(g){h().then(()=>{E(),require([g],function(A){setTimeout(function(){const b=A.create(($,e)=>{globalThis.postMessage($,e)},null);for(globalThis.onmessage=$=>b.onmessage($.data,$.ports);s.length>0;){const $=s.shift();b.onmessage($.data,$.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&E();let l=!0;const s=[];globalThis.onmessage=g=>{if(!l){s.push(g);return}l=!1,d(g.data)}}(),te(ie[9],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=void 0;function _(v,R,L){const o=D(v,R);if(o!==-1)return v[o]}t.$eb=_;function D(v,R,L=v.length-1){for(let o=L;o>=0;o--){const c=v[o];if(R(c))return o}return-1}t.$fb=D;function r(v,R){const L=h(v,R);return L===-1?void 0:v[L]}t.$gb=r;function h(v,R,L=0,o=v.length){let c=L,f=o;for(;c<f;){const u=Math.floor((c+f)/2);R(v[u])?c=u+1:f=u}return c-1}t.$hb=h;function E(v,R){const L=d(v,R);return L===v.length?void 0:v[L]}t.$ib=E;function d(v,R,L=0,o=v.length){let c=L,f=o;for(;c<f;){const u=Math.floor((c+f)/2);R(v[u])?f=u:c=u+1}return c}t.$jb=d;function l(v,R,L=0,o=v.length){const c=d(v,R,L,o);return c===v.length?-1:c}t.$kb=l;class s{static{this.assertInvariants=!1}constructor(R){this.e=R,this.c=0}findLastMonotonous(R){if(s.assertInvariants){if(this.d){for(const o of this.e)if(this.d(o)&&!R(o))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=R}const L=h(this.e,R,this.c);return this.c=L+1,L===-1?void 0:this.e[L]}}t.$lb=s;function g(v,R){if(v.length===0)return;let L=v[0];for(let o=1;o<v.length;o++){const c=v[o];R(c,L)>0&&(L=c)}return L}t.$mb=g;function A(v,R){if(v.length===0)return;let L=v[0];for(let o=1;o<v.length;o++){const c=v[o];R(c,L)>=0&&(L=c)}return L}t.$nb=A;function b(v,R){return g(v,(L,o)=>-R(L,o))}t.$ob=b;function $(v,R){if(v.length===0)return-1;let L=0;for(let o=1;o<v.length;o++){const c=v[o];R(c,v[L])>0&&(L=o)}return L}t.$pb=$;function e(v,R){for(const L of v){const o=R(L);if(o!==void 0)return o}}t.$qb=e}),te(ie[34],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M=t.$L=t.$K=t.$J=void 0;function _(E,d){const l=Object.create(null);for(const s of E){const g=d(s);let A=l[g];A||(A=l[g]=[]),A.push(s)}return l}t.$J=_;function D(E,d){const l=[],s=[];for(const g of E)d.has(g)||l.push(g);for(const g of d)E.has(g)||s.push(g);return{removed:l,added:s}}t.$K=D;function r(E,d){const l=[],s=[];for(const[g,A]of E)d.has(g)||l.push(A);for(const[g,A]of d)E.has(g)||s.push(A);return{removed:l,added:s}}t.$L=r;function h(E,d){const l=new Set;for(const s of d)E.has(s)&&l.add(s);return l}t.$M=h}),te(ie[35],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ss=t.$Rs=t.$Qs=t.$Ps=void 0;function _(d,l){const s=Math.pow(10,l);return Math.round(d*s)/s}class D{constructor(l,s,g,A=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=_(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.r===s.r&&l.g===s.g&&l.b===s.b&&l.a===s.a}}t.$Ps=D;class r{constructor(l,s,g,A){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=_(Math.max(Math.min(1,s),0),3),this.l=_(Math.max(Math.min(1,g),0),3),this.a=_(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.l===s.l&&l.a===s.a}static fromRGBA(l){const s=l.r/255,g=l.g/255,A=l.b/255,b=l.a,$=Math.max(s,g,A),e=Math.min(s,g,A);let v=0,R=0;const L=(e+$)/2,o=$-e;if(o>0){switch(R=Math.min(L<=.5?o/(2*L):o/(2-2*L),1),$){case s:v=(g-A)/o+(g<A?6:0);break;case g:v=(A-s)/o+2;break;case A:v=(s-g)/o+4;break}v*=60,v=Math.round(v)}return new r(v,R,L,b)}static i(l,s,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?l+(s-l)*6*g:g<1/2?s:g<2/3?l+(s-l)*(2/3-g)*6:l}static toRGBA(l){const s=l.h/360,{s:g,l:A,a:b}=l;let $,e,v;if(g===0)$=e=v=A;else{const R=A<.5?A*(1+g):A+g-A*g,L=2*A-R;$=r.i(L,R,s+1/3),e=r.i(L,R,s),v=r.i(L,R,s-1/3)}return new D(Math.round($*255),Math.round(e*255),Math.round(v*255),b)}}t.$Qs=r;class h{constructor(l,s,g,A){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=_(Math.max(Math.min(1,s),0),3),this.v=_(Math.max(Math.min(1,g),0),3),this.a=_(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.v===s.v&&l.a===s.a}static fromRGBA(l){const s=l.r/255,g=l.g/255,A=l.b/255,b=Math.max(s,g,A),$=Math.min(s,g,A),e=b-$,v=b===0?0:e/b;let R;return e===0?R=0:b===s?R=((g-A)/e%6+6)%6:b===g?R=(A-s)/e+2:R=(s-g)/e+4,new h(Math.round(R*60),v,b,l.a)}static toRGBA(l){const{h:s,s:g,v:A,a:b}=l,$=A*g,e=$*(1-Math.abs(s/60%2-1)),v=A-$;let[R,L,o]=[0,0,0];return s<60?(R=$,L=e):s<120?(R=e,L=$):s<180?(L=$,o=e):s<240?(L=e,o=$):s<300?(R=e,o=$):s<=360&&(R=$,o=e),R=Math.round((R+v)*255),L=Math.round((L+v)*255),o=Math.round((o+v)*255),new D(R,L,o,b)}}t.$Rs=h;class E{static fromHex(l){return E.Format.CSS.parseHex(l)||E.red}static equals(l,s){return!l&&!s?!0:!l||!s?!1:l.equals(s)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:h.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof D)this.rgba=l;else if(l instanceof r)this.i=l,this.rgba=r.toRGBA(l);else if(l instanceof h)this.j=l,this.rgba=h.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&D.equals(this.rgba,l.rgba)&&r.equals(this.hsla,l.hsla)&&h.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=E.k(this.rgba.r),s=E.k(this.rgba.g),g=E.k(this.rgba.b),A=.2126*l+.7152*s+.0722*g;return _(A,4)}static k(l){const s=l/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s>g?(s+.05)/(g+.05):(g+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s>g}isDarkerThan(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s<g}lighten(l){return new E(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new E(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:s,g,b:A,a:b}=this.rgba;return new E(new D(s,g,A,b*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new E(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const s=l.rgba,g=this.rgba.a,A=s.a,b=g+A*(1-g);if(b<1e-6)return E.transparent;const $=this.rgba.r*g/b+s.r*A*(1-g)/b,e=this.rgba.g*g/b+s.g*A*(1-g)/b,v=this.rgba.b*g/b+s.b*A*(1-g)/b;return new E(new D($,e,v,b))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:s,g,b:A,a:b}=this.rgba;return new E(new D(l.rgba.r-b*(l.rgba.r-s),l.rgba.g-b*(l.rgba.g-g),l.rgba.b-b*(l.rgba.b-A),1))}flatten(...l){const s=l.reduceRight((g,A)=>E.o(A,g));return E.o(this,s)}static o(l,s){const g=1-l.rgba.a;return new E(new D(g*s.rgba.r+l.rgba.a*l.rgba.r,g*s.rgba.g+l.rgba.a*l.rgba.g,g*s.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=E.Format.CSS.format(this)),this.u}static getLighterColor(l,s,g){if(l.isLighterThan(s))return l;g=g||.5;const A=l.getRelativeLuminance(),b=s.getRelativeLuminance();return g=g*(b-A)/b,l.lighten(g)}static getDarkerColor(l,s,g){if(l.isDarkerThan(s))return l;g=g||.5;const A=l.getRelativeLuminance(),b=s.getRelativeLuminance();return g=g*(A-b)/A,l.darken(g)}static{this.white=new E(new D(255,255,255,1))}static{this.black=new E(new D(0,0,0,1))}static{this.red=new E(new D(255,0,0,1))}static{this.blue=new E(new D(0,0,255,1))}static{this.green=new E(new D(0,255,0,1))}static{this.cyan=new E(new D(0,255,255,1))}static{this.lightgrey=new E(new D(211,211,211,1))}static{this.transparent=new E(new D(0,0,0,0))}}t.$Ss=E,function(d){let l;(function(s){let g;(function(A){function b(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:d.Format.CSS.formatRGBA(i)}A.formatRGB=b;function $(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}A.formatRGBA=$;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:d.Format.CSS.formatHSLA(i)}A.formatHSL=e;function v(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}A.formatHSLA=v;function R(i){const a=i.toString(16);return a.length!==2?"0"+a:a}function L(i){return`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}`}A.formatHex=L;function o(i,a=!1){return a&&i.rgba.a===1?d.Format.CSS.formatHex(i):`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}${R(Math.round(i.rgba.a*255))}`}A.formatHexA=o;function c(i){return i.isOpaque()?d.Format.CSS.formatHex(i):d.Format.CSS.formatRGBA(i)}A.format=c;function f(i){const a=i.length;if(a===0||i.charCodeAt(0)!==35)return null;if(a===7){const N=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),m=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),w=16*u(i.charCodeAt(5))+u(i.charCodeAt(6));return new d(new D(N,m,w,1))}if(a===9){const N=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),m=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),w=16*u(i.charCodeAt(5))+u(i.charCodeAt(6)),M=16*u(i.charCodeAt(7))+u(i.charCodeAt(8));return new d(new D(N,m,w,M/255))}if(a===4){const N=u(i.charCodeAt(1)),m=u(i.charCodeAt(2)),w=u(i.charCodeAt(3));return new d(new D(16*N+N,16*m+m,16*w+w))}if(a===5){const N=u(i.charCodeAt(1)),m=u(i.charCodeAt(2)),w=u(i.charCodeAt(3)),M=u(i.charCodeAt(4));return new d(new D(16*N+N,16*m+m,16*w+w,(16*M+M)/255))}return null}A.parseHex=f;function u(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=s.CSS||(s.CSS={}))})(l=d.Format||(d.Format={}))}(E||(t.$Ss=E={}))}),te(ie[36],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rs=void 0;class _{constructor(r,h,E,d){this.originalStart=r,this.originalLength=h,this.modifiedStart=E,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$rs=_}),te(ie[3],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.setUnexpectedErrorHandler=t.$W=t.$V=void 0;class _{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?c.isErrorNoTelemetry(i)?new c(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(a=>{a(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}t.$V=_,t.$W=new _;function D(u){t.$W.setUnexpectedErrorHandler(u)}t.setUnexpectedErrorHandler=D;function r(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.$Y=r;function h(u){s(u)||t.$W.onUnexpectedError(u)}t.$Z=h;function E(u){s(u)||t.$W.onUnexpectedExternalError(u)}t.$1=E;function d(u){if(u instanceof Error){const{name:i,message:a}=u,N=u.stacktrace||u.stack;return{$isError:!0,name:i,message:a,stack:N,noTelemetry:c.isErrorNoTelemetry(u)}}return u}t.$2=d;const l="Canceled";function s(u){return u instanceof g?!0:u instanceof Error&&u.name===l&&u.message===l}t.$3=s;class g extends Error{constructor(){super(l),this.name=this.message}}t.$4=g;function A(){const u=new Error(l);return u.name=u.message,u}t.$5=A;function b(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}t.$6=b;function $(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}t.$7=$;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$8=e;function v(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}t.$9=v;class R extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.$0=R;class L extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.$$=L;class o extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=o;class c extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof c)return i;const a=new c;return a.message=i.message,a.stack=i.stack,a}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.$ab=c;class f extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}t.$bb=f}),te(ie[6],re([0,1,3,9]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.CompareResult=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.top=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=void 0;function r(U,W=0){return U[U.length-(1+W)]}t.$rb=r;function h(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.$sb=h;function E(U,W,V=(Z,ee)=>Z===ee){if(U===W)return!0;if(!U||!W||U.length!==W.length)return!1;for(let Z=0,ee=U.length;Z<ee;Z++)if(!V(U[Z],W[Z]))return!1;return!0}t.$tb=E;function d(U,W){const V=U.length-1;W<V&&(U[W]=U[V]),U.pop()}t.$ub=d;function l(U,W,V){return s(U.length,Z=>V(U[Z],W))}t.$vb=l;function s(U,W){let V=0,Z=U-1;for(;V<=Z;){const ee=(V+Z)/2|0,G=W(ee);if(G<0)V=ee+1;else if(G>0)Z=ee-1;else return ee}return-(V+1)}t.$wb=s;function g(U,W,V){if(U=U|0,U>=W.length)throw new TypeError("invalid index");const Z=W[Math.floor(W.length*Math.random())],ee=[],G=[],Y=[];for(const Q of W){const K=V(Q,Z);K<0?ee.push(Q):K>0?G.push(Q):Y.push(Q)}return U<ee.length?g(U,ee,V):U<ee.length+Y.length?Y[0]:g(U-(ee.length+Y.length),G,V)}t.$xb=g;function A(U,W){const V=[];let Z;for(const ee of U.slice(0).sort(W))!Z||W(Z[0],ee)!==0?(Z=[ee],V.push(Z)):Z.push(ee);return V}t.$yb=A;function*b(U,W){let V,Z;for(const ee of U)Z!==void 0&&W(Z,ee)?V.push(ee):(V&&(yield V),V=[ee]),Z=ee;V&&(yield V)}t.$zb=b;function $(U,W){for(let V=0;V<=U.length;V++)W(V===0?void 0:U[V-1],V===U.length?void 0:U[V])}t.$Ab=$;function e(U,W){for(let V=0;V<U.length;V++)W(V===0?void 0:U[V-1],U[V],V+1===U.length?void 0:U[V+1])}t.$Bb=e;function v(U,W,V){const Z=[];function ee(Q,K,se){if(K===0&&se.length===0)return;const le=Z[Z.length-1];le&&le.start+le.deleteCount===Q?(le.deleteCount+=K,le.toInsert.push(...se)):Z.push({start:Q,deleteCount:K,toInsert:se})}let G=0,Y=0;for(;;){if(G===U.length){ee(G,0,W.slice(Y));break}if(Y===W.length){ee(G,U.length-G,[]);break}const Q=U[G],K=W[Y],se=V(Q,K);se===0?(G+=1,Y+=1):se<0?(ee(G,1,[]),G+=1):se>0&&(ee(G,0,[K]),Y+=1)}return Z}t.$Cb=v;function R(U,W,V){const Z=v(U,W,V),ee=[],G=[];for(const Y of Z)ee.push(...U.slice(Y.start,Y.start+Y.deleteCount)),G.push(...Y.toInsert);return{removed:ee,added:G}}t.$Db=R;function L(U,W,V){if(V===0)return[];const Z=U.slice(0,V).sort(W);return c(U,W,Z,V,U.length),Z}t.top=L;function o(U,W,V,Z,ee){return V===0?Promise.resolve([]):new Promise((G,Y)=>{(async()=>{const Q=U.length,K=U.slice(0,V).sort(W);for(let se=V,le=Math.min(V+Z,Q);se<Q;se=le,le=Math.min(le+Z,Q)){if(se>V&&await new Promise(oe=>setTimeout(oe)),ee&&ee.isCancellationRequested)throw new _.$4;c(U,W,K,se,le)}return K})().then(G,Y)})}t.$Fb=o;function c(U,W,V,Z,ee){for(const G=V.length;Z<ee;Z++){const Y=U[Z];if(W(Y,V[G-1])<0){V.pop();const Q=(0,D.$jb)(V,K=>W(Y,K)<0);V.splice(Q,0,Y)}}}function f(U){return U.filter(W=>!!W)}t.$Gb=f;function u(U){let W=0;for(let V=0;V<U.length;V++)U[V]&&(U[W]=U[V],W+=1);U.length=W}t.$Hb=u;function i(U,W,V){U.splice(V,0,U.splice(W,1)[0])}t.$Ib=i;function a(U){return!Array.isArray(U)||U.length===0}t.$Jb=a;function N(U){return Array.isArray(U)&&U.length>0}t.$Kb=N;function m(U,W=V=>V){const V=new Set;return U.filter(Z=>{const ee=W(Z);return V.has(ee)?!1:(V.add(ee),!0)})}t.$Lb=m;function w(U){const W=new Set;return V=>{const Z=U(V);return W.has(Z)?!1:(W.add(Z),!0)}}t.$Mb=w;function M(U,W){return U.length>0?U[0]:W}t.$Nb=M;function p(U,W){return U.length>0?U[U.length-1]:W}t.$Ob=p;function y(U,W,V=(Z,ee)=>Z===ee){let Z=0;for(let ee=0,G=Math.min(U.length,W.length);ee<G&&V(U[ee],W[ee]);ee++)Z++;return Z}t.$Pb=y;function k(U){return[].concat(...U)}t.$Qb=k;function P(U,W){let V=typeof W=="number"?U:0;typeof W=="number"?V=U:(V=0,W=U);const Z=[];if(V<=W)for(let ee=V;ee<W;ee++)Z.push(ee);else for(let ee=V;ee>W;ee--)Z.push(ee);return Z}t.$Rb=P;function F(U,W,V){return U.reduce((Z,ee)=>(Z[W(ee)]=V?V(ee):ee,Z),Object.create(null))}t.$Sb=F;function I(U,W){return U.push(W),()=>q(U,W)}t.$Tb=I;function q(U,W){const V=U.indexOf(W);if(V>-1)return U.splice(V,1),W}t.$Ub=q;function C(U,W,V){const Z=U.slice(0,W),ee=U.slice(W);return Z.concat(V,ee)}t.$Vb=C;function T(U,W){let V;if(typeof W=="number"){let Z=W;V=()=>{const ee=Math.sin(Z++)*179426549;return ee-Math.floor(ee)}}else V=Math.random;for(let Z=U.length-1;Z>0;Z-=1){const ee=Math.floor(V()*(Z+1)),G=U[Z];U[Z]=U[ee],U[ee]=G}}t.$Wb=T;function j(U,W){const V=U.indexOf(W);V>-1&&(U.splice(V,1),U.unshift(W))}t.$Xb=j;function z(U,W){const V=U.indexOf(W);V>-1&&(U.splice(V,1),U.push(W))}t.$Yb=z;function x(U,W){for(const V of W)U.push(V)}t.$Zb=x;function X(U,W){return Array.isArray(U)?U.map(W):W(U)}t.$1b=X;function n(U){return Array.isArray(U)?U:[U]}t.$2b=n;function ne(U){return U[Math.floor(Math.random()*U.length)]}t.$3b=ne;function ce(U,W,V){const Z=Le(U,W),ee=U.length,G=V.length;U.length=ee+G;for(let Y=ee-1;Y>=Z;Y--)U[Y+G]=U[Y];for(let Y=0;Y<G;Y++)U[Y+Z]=V[Y]}t.$4b=ce;function ge(U,W,V,Z){const ee=Le(U,W);let G=U.splice(ee,V);return G===void 0&&(G=[]),ce(U,ee,Z),G}t.$5b=ge;function Le(U,W){return W<0?Math.max(W+U.length,0):Math.min(W,U.length)}var ve;(function(U){function W(G){return G<0}U.isLessThan=W;function V(G){return G<=0}U.isLessThanOrEqual=V;function Z(G){return G>0}U.isGreaterThan=Z;function ee(G){return G===0}U.isNeitherLessOrGreaterThan=ee,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(ve||(t.CompareResult=ve={}));function $e(U,W){return(V,Z)=>W(U(V),U(Z))}t.$6b=$e;function Ne(...U){return(W,V)=>{for(const Z of U){const ee=Z(W,V);if(!ve.isNeitherLessOrGreaterThan(ee))return ee}return ve.neitherLessOrGreaterThan}}t.$7b=Ne;const _e=(U,W)=>U-W;t.$8b=_e;const Te=(U,W)=>(0,t.$8b)(U?1:0,W?1:0);t.$9b=Te;function Se(U){return(W,V)=>-U(W,V)}t.$0b=Se;class Ie{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let V=this.c;for(;V<this.g.length&&W(this.g[V]);)V++;const Z=V===this.c?null:this.g.slice(this.c,V);return this.c=V,Z}takeFromEndWhile(W){let V=this.d;for(;V>=0&&W(this.g[V]);)V--;const Z=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,Z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const V=this.g.slice(this.c,this.c+W);return this.c+=W,V}}t.$$b=Ie;class Me{static{this.empty=new Me(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(V=>(W(V),!0))}toArray(){const W=[];return this.iterate(V=>(W.push(V),!0)),W}filter(W){return new Me(V=>this.iterate(Z=>W(Z)?V(Z):!0))}map(W){return new Me(V=>this.iterate(Z=>V(W(Z))))}some(W){let V=!1;return this.iterate(Z=>(V=W(Z),!V)),V}findFirst(W){let V;return this.iterate(Z=>W(Z)?(V=Z,!1):!0),V}findLast(W){let V;return this.iterate(Z=>(W(Z)&&(V=Z),!0)),V}findLastMaxBy(W){let V,Z=!0;return this.iterate(ee=>((Z||ve.isGreaterThan(W(ee,V)))&&(Z=!1,V=ee),!0)),V}}t.$_b=Me}),te(ie[13],re([0,1,3]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=t.$5c=t.$4c=t.$3c=t.ok=void 0;function D(l,s){if(!l)throw new Error(s?`Assertion failed (${s})`:"Assertion Failed")}t.ok=D;function r(l,s="Unreachable"){throw new Error(s)}t.$3c=r;function h(l){if(!l)throw new _.$bb("Assertion Failed")}t.$4c=h;function E(l){if(!l()){debugger;l(),(0,_.$Z)(new _.$bb("Assertion Failed"))}}t.$5c=E;function d(l,s){let g=0;for(;g<l.length-1;){const A=l[g],b=l[g+1];if(!s(A,b))return!1;g++}return!0}t.$6c=d}),te(ie[19],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function _(D){const r=this;let h=!1,E;return function(){return h||(h=!0,E=D.apply(r,arguments)),E}}t.$cb=_}),te(ie[20],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var _;(function(D){function r(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}D.is=r;const h=Object.freeze([]);function E(){return h}D.empty=E;function*d(u){yield u}D.single=d;function l(u){return r(u)?u:d(u)}D.wrap=l;function s(u){return u||h}D.from=s;function*g(u){for(let i=u.length-1;i>=0;i--)yield u[i]}D.reverse=g;function A(u){return!u||u[Symbol.iterator]().next().done===!0}D.isEmpty=A;function b(u){return u[Symbol.iterator]().next().value}D.first=b;function $(u,i){for(const a of u)if(i(a))return!0;return!1}D.some=$;function e(u,i){for(const a of u)if(i(a))return a}D.find=e;function*v(u,i){for(const a of u)i(a)&&(yield a)}D.filter=v;function*R(u,i){let a=0;for(const N of u)yield i(N,a++)}D.map=R;function*L(...u){for(const i of u)for(const a of i)yield a}D.concat=L;function o(u,i,a){let N=a;for(const m of u)N=i(N,m);return N}D.reduce=o;function*c(u,i,a=u.length){for(i<0&&(i+=u.length),a<0?a+=u.length:a>u.length&&(a=u.length);i<a;i++)yield u[i]}D.slice=c;function f(u,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,u];const N=u[Symbol.iterator]();for(let m=0;m<i;m++){const w=N.next();if(w.done)return[a,D.empty()];a.push(w.value)}return[a,{[Symbol.iterator](){return N}}]}D.consume=f})(_||(t.Iterable=_={}))}),te(ie[37],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bq=t.KeyMod=t.KeyCodeUtils=t.$Aq=t.$zq=t.$yq=t.$xq=t.$wq=t.ScanCode=t.KeyCode=void 0;var _;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(_||(t.KeyCode=_={}));var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(D||(t.ScanCode=D={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(v,R){this._keyCodeToStr[v]=R,this._strToKeyCode[R.toLowerCase()]=v}keyCodeToStr(v){return this._keyCodeToStr[v]}strToKeyCode(v){return this._strToKeyCode[v.toLowerCase()]||0}}const h=new r,E=new r,d=new r;t.$wq=new Array(230),t.$xq={};const l=[],s=Object.create(null),g=Object.create(null);t.$yq={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>s[e]||0,toString:e=>l[e]||"None"},t.$zq=[],t.$Aq=[];for(let e=0;e<=193;e++)t.$zq[e]=-1;for(let e=0;e<=132;e++)t.$Aq[e]=-1;(function(){const e="",v=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],R=[],L=[];for(const o of v){const[c,f,u,i,a,N,m,w,M]=o;if(L[f]||(L[f]=!0,l[f]=u,s[u]=f,g[u.toLowerCase()]=f,c&&(t.$zq[f]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.$Aq[i]=f))),!R[i]){if(R[i]=!0,!a)throw new Error(`String representation missing for key code ${i} around scan code ${u}`);h.define(i,a),E.define(i,w||a),d.define(i,M||w||a)}N&&(t.$wq[N]=i),m&&(t.$xq[m]=i)}t.$Aq[3]=46})();var A;(function(e){function v(u){return h.keyCodeToStr(u)}e.toString=v;function R(u){return h.strToKeyCode(u)}e.fromString=R;function L(u){return E.keyCodeToStr(u)}e.toUserSettingsUS=L;function o(u){return d.keyCodeToStr(u)}e.toUserSettingsGeneral=o;function c(u){return E.strToKeyCode(u)||d.strToKeyCode(u)}e.fromUserSettings=c;function f(u){if(u>=98&&u<=113)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return h.keyCodeToStr(u)}e.toElectronAccelerator=f})(A||(t.KeyCodeUtils=A={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function $(e,v){const R=(v&65535)<<16>>>0;return(e|R)>>>0}t.$Bq=$}),te(ie[38],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=void 0;class _{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$U=_}),te(ie[21],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=void 0;class _{static{this.Undefined=new _(void 0)}constructor(h){this.element=h,this.next=_.Undefined,this.prev=_.Undefined}}class D{constructor(){this.a=_.Undefined,this.b=_.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===_.Undefined}clear(){let h=this.a;for(;h!==_.Undefined;){const E=h.next;h.prev=_.Undefined,h.next=_.Undefined,h=E}this.a=_.Undefined,this.b=_.Undefined,this.c=0}unshift(h){return this.d(h,!1)}push(h){return this.d(h,!0)}d(h,E){const d=new _(h);if(this.a===_.Undefined)this.a=d,this.b=d;else if(E){const s=this.b;this.b=d,d.prev=s,s.next=d}else{const s=this.a;this.a=d,d.next=s,s.prev=d}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(d))}}shift(){if(this.a!==_.Undefined){const h=this.a.element;return this.e(this.a),h}}pop(){if(this.b!==_.Undefined){const h=this.b.element;return this.e(this.b),h}}e(h){if(h.prev!==_.Undefined&&h.next!==_.Undefined){const E=h.prev;E.next=h.next,h.next.prev=E}else h.prev===_.Undefined&&h.next===_.Undefined?(this.a=_.Undefined,this.b=_.Undefined):h.next===_.Undefined?(this.b=this.b.prev,this.b.next=_.Undefined):h.prev===_.Undefined&&(this.a=this.a.next,this.a.prev=_.Undefined);this.c-=1}*[Symbol.iterator](){let h=this.a;for(;h!==_.Undefined;)yield h.element,h=h.next}}t.$1c=D}),te(ie[22],re([0,1]),function(O,t){"use strict";var _,D,r;Object.defineProperty(t,"__esModule",{value:!0}),t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.Touch=t.$Ac=t.$zc=t.$yc=t.$xc=t.$wc=void 0;function h(o,c,f){let u=o.get(c);return u===void 0&&(u=f,o.set(c,u)),u}t.$wc=h;function E(o){const c=[];return o.forEach((f,u)=>{c.push(`${u} => ${f}`)}),`Map(${o.size}) {${c.join(", ")}}`}t.$xc=E;function d(o){const c=[];return o.forEach(f=>{c.push(f)}),`Set(${o.size}) {${c.join(", ")}}`}t.$yc=d;class l{constructor(c,f){this.uri=c,this.value=f}}function s(o){return Array.isArray(o)}class g{static{this.a=c=>c.toString()}constructor(c,f){if(this[_]="ResourceMap",c instanceof g)this.b=new Map(c.b),this.c=f??g.a;else if(s(c)){this.b=new Map,this.c=f??g.a;for(const[u,i]of c)this.set(u,i)}else this.b=new Map,this.c=c??g.a}set(c,f){return this.b.set(this.c(c),new l(c,f)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,f){typeof f<"u"&&(c=c.bind(f));for(const[u,i]of this.b)c(i.value,i.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}t.$zc=g;class A{constructor(c,f){this[D]="ResourceSet",!c||typeof c=="function"?this.a=new g(c):(this.a=new g(f),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,f){this.a.forEach((u,i)=>c.call(f,i,i,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ac=A;var b;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class ${constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,f=0){const u=this.a.get(c);if(u)return f!==0&&this.j(u,f),u.value}set(c,f,u=0){let i=this.a.get(c);if(i)i.value=f,u!==0&&this.j(i,u);else{switch(i={key:c,value:f,next:void 0,previous:void 0},u){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(c,i),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const f=this.a.get(c);if(f)return this.a.delete(c),this.i(f),this.d--,f.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,f){const u=this.e;let i=this.b;for(;i;){if(f?c.bind(f)(i.value,i.key,this):c(i.value,i.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const c=this,f=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(c.e!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const a={value:u.key,done:!1};return u=u.next,a}else return{value:void 0,done:!0}}};return i}values(){const c=this,f=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(c.e!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const a={value:u.value,done:!1};return u=u.next,a}else return{value:void 0,done:!0}}};return i}entries(){const c=this,f=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(c.e!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const a={value:[u.key,u.value],done:!1};return u=u.next,a}else return{value:void 0,done:!0}}};return i}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let f=this.b,u=this.size;for(;f&&u>c;)this.a.delete(f.key),f=f.next,u--;this.b=f,this.d=u,f&&(f.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const f=c.next,u=c.previous;if(!f||!u)throw new Error("Invalid list");f.previous=u,u.next=f}c.next=void 0,c.previous=void 0,this.e++}j(c,f){if(!this.b||!this.c)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(c===this.b)return;const u=c.next,i=c.previous;c===this.c?(i.next=void 0,this.c=i):(u.previous=i,i.next=u),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(f===2){if(c===this.c)return;const u=c.next,i=c.previous;c===this.b?(u.previous=void 0,this.b=u):(u.previous=i,i.next=u),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((f,u)=>{c.push([u,f])}),c}fromJSON(c){this.clear();for(const[f,u]of c)this.set(f,u)}}t.$Bc=$;class e extends ${constructor(c,f=1){super(),this.k=c,this.l=Math.min(Math.max(0,f),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,f=2){return super.get(c,f)}peek(c){return super.get(c,0)}set(c,f){return super.set(c,f,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Cc=e;class v{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let f=this.a.get(c)||0;return f===0?!1:(f--,f===0?this.a.delete(c):this.a.set(c,f),!0)}has(c){return this.a.has(c)}}t.$Dc=v;class R{constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[f,u]of c)this.set(f,u)}clear(){this.a.clear(),this.b.clear()}set(c,f){this.a.set(c,f),this.b.set(f,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const f=this.a.get(c);return f===void 0?!1:(this.a.delete(c),this.b.delete(f),!0)}forEach(c,f){this.a.forEach((u,i)=>{c.call(f,u,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Ec=R;class L{constructor(){this.a=new Map}add(c,f){let u=this.a.get(c);u||(u=new Set,this.a.set(c,u)),u.add(f)}delete(c,f){const u=this.a.get(c);u&&(u.delete(f),u.size===0&&this.a.delete(c))}forEach(c,f){const u=this.a.get(c);u&&u.forEach(f)}get(c){const f=this.a.get(c);return f||new Set}}t.$Fc=L}),te(ie[10],re([0,1,6,34,22,19,20]),function(O,t,_,D,r,h,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=void 0;const d=!1;let l=null;class s{constructor(){this.b=new Map}static{this.a=0}c(F){let I=this.b.get(F);return I||(I={parent:null,source:null,isSingleton:!1,value:F,idx:s.a++},this.b.set(F,I)),I}trackDisposable(F){const I=this.c(F);I.source||(I.source=new Error().stack)}setParent(F,I){const q=this.c(F);q.parent=I}markAsDisposed(F){this.b.delete(F)}markAsSingleton(F){this.c(F).isSingleton=!0}f(F,I){const q=I.get(F);if(q)return q;const C=F.parent?this.f(this.c(F.parent),I):F;return I.set(F,C),C}getTrackedDisposables(){const F=new Map;return[...this.b.entries()].filter(([,q])=>q.source!==null&&!this.f(q,F).isSingleton).flatMap(([q])=>q)}computeLeakingDisposables(F=10,I){let q;if(I)q=I;else{const x=new Map,X=[...this.b.values()].filter(ne=>ne.source!==null&&!this.f(ne,x).isSingleton);if(X.length===0)return;const n=new Set(X.map(ne=>ne.value));if(q=X.filter(ne=>!(ne.parent&&n.has(ne.parent))),q.length===0)throw new Error("There are cyclic diposable chains!")}if(!q)return;function C(x){function X(ne,ce){for(;ne.length>0&&ce.some(ge=>typeof ge=="string"?ge===ne[0]:ne[0].match(ge));)ne.shift()}const n=x.source.split(`
`).map(ne=>ne.trim().replace("at ","")).filter(ne=>ne!=="");return X(n,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),n.reverse()}const T=new r.$Fc;for(const x of q){const X=C(x);for(let n=0;n<=X.length;n++)T.add(X.slice(0,n).join(`
`),x)}q.sort((0,_.$6b)(x=>x.idx,_.$8b));let j="",z=0;for(const x of q.slice(0,F)){z++;const X=C(x),n=[];for(let ne=0;ne<X.length;ne++){let ce=X[ne];ce=`(shared with ${T.get(X.slice(0,ne+1).join(`
`)).size}/${q.length} leaks) at ${ce}`;const Le=T.get(X.slice(0,ne).join(`
`)),ve=(0,D.$J)([...Le].map($e=>C($e)[ne]),$e=>$e);delete ve[X[ne]];for(const[$e,Ne]of Object.entries(ve))n.unshift(`    - stacktraces of ${Ne.length} other leaks continue with ${$e}`);n.unshift(ce)}j+=`


==================== Leaking disposable ${z}/${q.length}: ${x.value.constructor.name} ====================
${n.join(`
`)}
============================================================

`}return q.length>F&&(j+=`


... and ${q.length-F} more leaking disposables

`),{leaks:q,details:j}}}t.$Gc=s;function g(P){l=P}if(t.$Hc=g,d){const P="__is_disposable_tracked__";g(new class{trackDisposable(F){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{F[P]||console.log(I)},3e3)}setParent(F,I){if(F&&F!==i.None)try{F[P]=!0}catch{}}markAsDisposed(F){if(F&&F!==i.None)try{F[P]=!0}catch{}}markAsSingleton(F){}})}function A(P){return l?.trackDisposable(P),P}t.$Ic=A;function b(P){l?.markAsDisposed(P)}t.$Jc=b;function $(P,F){l?.setParent(P,F)}function e(P,F){if(l)for(const I of P)l.setParent(I,F)}function v(P){return l?.markAsSingleton(P),P}t.$Kc=v;function R(P){return typeof P.dispose=="function"&&P.dispose.length===0}t.$Lc=R;function L(P){if(E.Iterable.is(P)){const F=[];for(const I of P)if(I)try{I.dispose()}catch(q){F.push(q)}if(F.length===1)throw F[0];if(F.length>1)throw new AggregateError(F,"Encountered errors while disposing of store");return Array.isArray(P)?[]:P}else if(P)return P.dispose(),P}t.$Mc=L;function o(P){for(const F of P)R(F)&&F.dispose();return[]}t.$Nc=o;function c(...P){const F=f(()=>L(P));return e(P,F),F}t.$Oc=c;function f(P){const F=A({dispose:(0,h.$cb)(()=>{b(F),P()})});return F}t.$Pc=f;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{L(this.f)}finally{this.f.clear()}}add(F){if(!F)return F;if(F===this)throw new Error("Cannot register a disposable on itself!");return $(F,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(F),F}delete(F){if(F){if(F===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(F),F.dispose()}}deleteAndLeak(F){F&&this.f.has(F)&&(this.f.delete(F),$(F,null))}}t.$Qc=u;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,A(this),$(this.q,this)}dispose(){b(this),this.q.dispose()}B(F){if(F===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(F)}}t.$Rc=i;class a{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(F){this.b||F===this.a||(this.a?.dispose(),F&&$(F,this),this.a=F)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const F=this.a;return this.a=void 0,F&&$(F,null),F}}t.$Sc=a;class N{constructor(F){this.b=F,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Tc=N;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(F){let I=F;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,b(this))},this}}t.$Uc=m;class w{constructor(){this.a=new Map}acquire(F,...I){let q=this.a.get(F);q||(q={counter:0,object:this.b(F,...I)},this.a.set(F,q));const{object:C}=q,T=(0,h.$cb)(()=>{--q.counter===0&&(this.c(F,q.object),this.a.delete(F))});return q.counter++,{object:C,dispose:T}}}t.$Vc=w;class M{constructor(F){this.a=F}async acquire(F,...I){const q=this.a.acquire(F,...I);try{return{object:await q.object,dispose:()=>q.dispose()}}catch(C){throw q.dispose(),C}}}t.$Wc=M;class p{constructor(F){this.object=F}dispose(){}}t.$Xc=p;function y(P){const F=new u;try{P(F)}finally{F.dispose()}}t.$Yc=y;class k{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{L(this.a.values())}finally{this.a.clear()}}has(F){return this.a.has(F)}get size(){return this.a.size}get(F){return this.a.get(F)}set(F,I,q=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),q||this.a.get(F)?.dispose(),this.a.set(F,I)}deleteAndDispose(F){this.a.get(F)?.dispose(),this.a.delete(F)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$Zc=k}),te(ie[23],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Id=void 0;const _=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(h){return new D(h)}constructor(h){this.c=_&&h===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Id=D}),te(ie[11],re([0,1,3,19,10,21,23]),function(O,t,_,D,r,h,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.$Kd=t.Event=void 0;const d=!1,l=!1;var s;(function(k){k.None=()=>r.$Rc.None;function P(G){if(l){const{onDidAddListener:Y}=G,Q=e.create();let K=0;G.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),Y?.()}}}function F(G,Y){return ne(G,()=>{},0,void 0,!0,void 0,Y)}k.defer=F;function I(G){return(Y,Q=null,K)=>{let se=!1,le;return le=G(oe=>{if(!se)return le?le.dispose():se=!0,Y.call(Q,oe)},null,K),se&&le.dispose(),le}}k.once=I;function q(G,Y,Q){return X((K,se=null,le)=>G(oe=>K.call(se,Y(oe)),null,le),Q)}k.map=q;function C(G,Y,Q){return X((K,se=null,le)=>G(oe=>{Y(oe),K.call(se,oe)},null,le),Q)}k.forEach=C;function T(G,Y,Q){return X((K,se=null,le)=>G(oe=>Y(oe)&&K.call(se,oe),null,le),Q)}k.filter=T;function j(G){return G}k.signal=j;function z(...G){return(Y,Q=null,K)=>{const se=(0,r.$Oc)(...G.map(le=>le(oe=>Y.call(Q,oe))));return n(se,K)}}k.any=z;function x(G,Y,Q,K){let se=Q;return q(G,le=>(se=Y(se,le),se),K)}k.reduce=x;function X(G,Y){let Q;const K={onWillAddFirstListener(){Q=G(se.fire,se)},onDidRemoveLastListener(){Q?.dispose()}};Y||P(K);const se=new c(K);return Y?.add(se),se.event}function n(G,Y){return Y instanceof Array?Y.push(G):Y&&Y.add(G),G}function ne(G,Y,Q=100,K=!1,se=!1,le,oe){let me,he,pe,we=0,Fe;const Ue={leakWarningThreshold:le,onWillAddFirstListener(){me=G(je=>{we++,he=Y(he,je),K&&!pe&&(ke.fire(he),he=void 0),Fe=()=>{const Be=he;he=void 0,pe=void 0,(!K||we>1)&&ke.fire(Be),we=0},typeof Q=="number"?(clearTimeout(pe),pe=setTimeout(Fe,Q)):pe===void 0&&(pe=0,queueMicrotask(Fe))})},onWillRemoveListener(){se&&we>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,me.dispose()}};oe||P(Ue);const ke=new c(Ue);return oe?.add(ke),ke.event}k.debounce=ne;function ce(G,Y=0,Q){return k.debounce(G,(K,se)=>K?(K.push(se),K):[se],Y,void 0,!0,void 0,Q)}k.accumulate=ce;function ge(G,Y=(K,se)=>K===se,Q){let K=!0,se;return T(G,le=>{const oe=K||!Y(le,se);return K=!1,se=le,oe},Q)}k.latch=ge;function Le(G,Y,Q){return[k.filter(G,Y,Q),k.filter(G,K=>!Y(K),Q)]}k.split=Le;function ve(G,Y=!1,Q=[],K){let se=Q.slice(),le=G(he=>{se?se.push(he):me.fire(he)});K&&K.add(le);const oe=()=>{se?.forEach(he=>me.fire(he)),se=null},me=new c({onWillAddFirstListener(){le||(le=G(he=>me.fire(he)),K&&K.add(le))},onDidAddFirstListener(){se&&(Y?setTimeout(oe):oe())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return K&&K.add(me),me.event}k.buffer=ve;function $e(G,Y){return(K,se,le)=>{const oe=Y(new _e);return G(function(me){const he=oe.evaluate(me);he!==Ne&&K.call(se,he)},void 0,le)}}k.chain=$e;const Ne=Symbol("HaltChainable");class _e{constructor(){this.f=[]}map(Y){return this.f.push(Y),this}forEach(Y){return this.f.push(Q=>(Y(Q),Q)),this}filter(Y){return this.f.push(Q=>Y(Q)?Q:Ne),this}reduce(Y,Q){let K=Q;return this.f.push(se=>(K=Y(K,se),K)),this}latch(Y=(Q,K)=>Q===K){let Q=!0,K;return this.f.push(se=>{const le=Q||!Y(se,K);return Q=!1,K=se,le?se:Ne}),this}evaluate(Y){for(const Q of this.f)if(Y=Q(Y),Y===Ne)break;return Y}}function Te(G,Y,Q=K=>K){const K=(...me)=>oe.fire(Q(...me)),se=()=>G.on(Y,K),le=()=>G.removeListener(Y,K),oe=new c({onWillAddFirstListener:se,onDidRemoveLastListener:le});return oe.event}k.fromNodeEventEmitter=Te;function Se(G,Y,Q=K=>K){const K=(...me)=>oe.fire(Q(...me)),se=()=>G.addEventListener(Y,K),le=()=>G.removeEventListener(Y,K),oe=new c({onWillAddFirstListener:se,onDidRemoveLastListener:le});return oe.event}k.fromDOMEventEmitter=Se;function Ie(G){return new Promise(Y=>I(G)(Y))}k.toPromise=Ie;function Me(G){const Y=new c;return G.then(Q=>{Y.fire(Q)},()=>{Y.fire(void 0)}).finally(()=>{Y.dispose()}),Y.event}k.fromPromise=Me;function U(G,Y){return Y(void 0),G(Q=>Y(Q))}k.runAndSubscribe=U;function W(G,Y){let Q=null;function K(le){Q?.dispose(),Q=new r.$Qc,Y(le,Q)}K(void 0);const se=G(le=>K(le));return(0,r.$Pc)(()=>{se.dispose(),Q?.dispose()})}k.runAndSubscribeWithStore=W;class V{constructor(Y,Q){this._observable=Y,this.f=0,this.g=!1;const K={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};Q||P(K),this.emitter=new c(K),Q&&Q.add(this.emitter)}beginUpdate(Y){this.f++}handlePossibleChange(Y){}handleChange(Y,Q){this.g=!0}endUpdate(Y){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Z(G,Y){return new V(G,Y).emitter.event}k.fromObservable=Z;function ee(G){return Y=>{let Q=0,K=!1;const se={beginUpdate(){Q++},endUpdate(){Q--,Q===0&&(G.reportChanges(),K&&(K=!1,Y()))},handlePossibleChange(){},handleChange(){K=!0}};return G.addObserver(se),G.reportChanges(),{dispose(){G.removeObserver(se)}}}}k.fromObservableLight=ee})(s||(t.Event=s={}));class g{static{this.all=new Set}static{this.f=0}constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${g.f++}`,g.all.add(this)}start(P){this.g=new E.$Id,this.listenerCount=P}stop(){if(this.g){const P=this.g.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this.g=void 0}}}t.$Kd=g;let A=-1;function b(k){const P=A;return A=k,{dispose(){A=P}}}t.$Ld=b;class ${constructor(P,F=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=F,this.g=0}dispose(){this.f?.clear()}check(P,F){const I=this.threshold;if(I<=0||F<I)return;this.f||(this.f=new Map);const q=this.f.get(P.value)||0;if(this.f.set(P.value,q+1),this.g-=1,this.g<=0){this.g=I*.5;let C,T=0;for(const[j,z]of this.f)(!C||T<z)&&(C=j,T=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${T}):`),console.warn(C)}return()=>{const C=this.f.get(P.value)||0;this.f.set(P.value,C-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class R{constructor(P){this.value=P,this.id=v++}}const L=2,o=(k,P)=>{if(k instanceof R)P(k);else for(let F=0;F<k.length;F++){const I=k[F];I&&P(I)}};class c{constructor(P){this.w=0,this.f=P,this.g=A>0||this.f?.leakWarningThreshold?new $(this.f?.leakWarningThreshold??A):void 0,this.j=this.f?._profName?new g(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(d){const P=this.t;queueMicrotask(()=>{o(P,F=>F.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(P,F,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Rc.None;if(this.m)return r.$Rc.None;F&&(P=P.bind(F));const q=new R(P);let C,T;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(q.stack=e.create(),C=this.g.check(q.stack,this.w+1)),d&&(q.stack=T??e.create()),this.t?this.t instanceof R?(this.u??=new u,this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,r.$Pc)(()=>{C?.(),this.x(q)});return I instanceof r.$Qc?I.add(j):Array.isArray(I)&&I.push(j),j},this.q}x(P){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const F=this.t,I=F.indexOf(P);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,F[I]=void 0;const q=this.u.current===this;if(this.w*L<=F.length){let C=0;for(let T=0;T<F.length;T++)F[T]?F[C++]=F[T]:q&&(this.u.end--,C<this.u.i&&this.u.i--);F.length=C}}y(P,F){if(!P)return;const I=this.f?.onListenerError||_.$Z;if(!I){P.value(F);return}try{P.value(F)}catch(q){I(q)}}z(P){const F=P.current.t;for(;P.i<P.end;)this.y(F[P.i++],P.value);P.reset()}fire(P){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof R)this.y(this.t,P);else{const F=this.u;F.enqueue(this,P,this.t.length),this.z(F)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Md=c;const f=()=>new u;t.$Nd=f;class u{constructor(){this.i=-1,this.end=0}enqueue(P,F,I){this.i=0,this.end=I,this.current=P,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends c{async fireAsync(P,F,I){if(this.t)for(this.h||(this.h=new h.$1c),o(this.t,q=>this.h.push([q.value,P]));this.h.size>0&&!F.isCancellationRequested;){const[q,C]=this.h.shift(),T=[],j={...C,token:F,waitUntil:z=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");I&&(z=I(z,q)),T.push(z)}};try{q(j)}catch(z){(0,_.$Z)(z);continue}Object.freeze(T),await Promise.allSettled(T).then(z=>{for(const x of z)x.status==="rejected"&&(0,_.$Z)(x.reason)})}}}t.$Od=i;class a extends c{get isPaused(){return this.h!==0}constructor(P){super(P),this.h=0,this.s=new h.$1c,this.A=P?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const P=Array.from(this.s);this.s.clear(),super.fire(this.A(P))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(P){this.w&&(this.h!==0?this.s.push(P):super.fire(P))}}t.$Pd=a;class N extends a{constructor(P){super(P),this.k=P.delay??100}fire(P){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(P)}}t.$Qd=N;class m extends c{constructor(P){super(P),this.h=[],this.k=P?.merge}fire(P){this.hasListeners()&&(this.h.push(P),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}t.$Rd=m;class w{constructor(){this.g=!1,this.h=[],this.f=new c({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(P){const F={event:P,listener:null};this.h.push(F),this.g&&this.m(F);const I=()=>{this.g&&this.o(F);const q=this.h.indexOf(F);this.h.splice(q,1)};return(0,r.$Pc)((0,D.$cb)(I))}j(){this.g=!0,this.h.forEach(P=>this.m(P))}k(){this.g=!1,this.h.forEach(P=>this.o(P))}m(P){P.listener=P.event(F=>this.f.fire(F))}o(P){P.listener&&P.listener.dispose(),P.listener=null}dispose(){this.f.dispose()}}t.$Sd=w;class M{constructor(P,F,I,q){this.f=new r.$Qc;const C=this.f.add(new w),T=this.f.add(new r.$Zc);function j(z){T.set(z,C.add(q(z)))}for(const z of P)j(z);this.f.add(F(z=>{j(z)})),this.f.add(I(z=>{T.deleteAndDispose(z)})),this.event=C.event}dispose(){this.f.dispose()}}t.$Td=M;class p{constructor(){this.f=[]}wrapEvent(P){return(F,I,q)=>P(C=>{const T=this.f[this.f.length-1];T?T.push(()=>F.call(I,C)):F.call(I,C)},void 0,q)}bufferEvents(P){const F=[];this.f.push(F);const I=P();return this.f.pop(),F.forEach(q=>q()),I}}t.$Ud=p;class y{constructor(){this.f=!1,this.g=s.None,this.h=r.$Rc.None,this.j=new c({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(P){this.g=P,this.f&&(this.h.dispose(),this.h=P(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Vd=y}),te(ie[24],re([0,1,11]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wd=t.CancellationToken=void 0;const D=Object.freeze(function(d,l){const s=setTimeout(d.bind(l),0);return{dispose(){clearTimeout(s)}}});var r;(function(d){function l(s){return s===d.None||s===d.Cancelled||s instanceof h?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}d.isCancellationToken=l,d.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),d.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(r||(t.CancellationToken=r={}));class h{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?D:(this.b||(this.b=new _.$Md),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class E{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new h),this.f}cancel(){this.f?this.f instanceof h&&this.f.cancel():this.f=r.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof h&&this.f.dispose():this.f=r.None}}t.$Wd=E}),te(ie[39],re([0,1,24]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xe=t.$we=t.$ve=void 0;class D{constructor(d){this.b=d,this.a=null}get(){if(this.a)return this.a;const d=new _.$Wd,l=this.b(d.token);return this.a={promise:l,dispose:()=>{this.a=null,d.cancel(),d.dispose()}},this.a}}t.$ve=D;class r{constructor(d){this.c=d,this.a=void 0,this.b=void 0}get(d){const l=JSON.stringify(d);return this.b!==l&&(this.b=l,this.a=this.c(d)),this.a}}t.$we=r;class h{get cachedValues(){return this.a}constructor(d){this.b=d,this.a=new Map}get(d){if(this.a.has(d))return this.a.get(d);const l=this.b(d);return this.a.set(d,l),l}}t.$xe=h}),te(ie[7],re([0,1,39,38]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wf=t.$vf=t.$uf=t.$tf=t.GraphemeBreakType=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=t.$Ae=void 0;function r(S){return!S||typeof S!="string"?!0:S.trim().length===0}t.$Ae=r;const h=/{(\d+)}/g;function E(S,...B){return B.length===0?S:S.replace(h,function(H,J){const ue=parseInt(J,10);return isNaN(ue)||ue<0||ue>=B.length?H:B[ue]})}t.$Be=E;const d=/{([^}]+)}/g;function l(S,B){return S.replace(d,(H,J)=>B[J]??H)}t.$Ce=l;function s(S){return S.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.$De=s;function g(S){return S.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Ee=g;function A(S,B){let H=0;const J=B.charCodeAt(0);for(let ue=S.length-1;ue>=0;ue--)S.charCodeAt(ue)===J&&H++;return H}t.$Fe=A;function b(S,B,H="\u2026"){return S.length<=B?S:`${S.substr(0,B)}${H}`}t.$Ge=b;function $(S,B=" "){const H=e(S,B);return v(H,B)}t.$He=$;function e(S,B){if(!S||!B)return S;const H=B.length;if(H===0||S.length===0)return S;let J=0;for(;S.indexOf(B,J)===J;)J=J+H;return S.substring(J)}t.$Ie=e;function v(S,B){if(!S||!B)return S;const H=B.length,J=S.length;if(H===0||J===0)return S;let ue=J,ae=-1;for(;ae=S.lastIndexOf(B,ue-1),!(ae===-1||ae+H!==ue);){if(ae===0)return"";ue=ae}return S.substring(0,ue)}t.$Je=v;function R(S){return S.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Ke=R;function L(S){return S.replace(/\*/g,"")}t.$Le=L;function o(S,B,H={}){if(!S)throw new Error("Cannot create regex from empty string");B||(S=g(S)),H.wholeWord&&(/\B/.test(S.charAt(0))||(S="\\b"+S),/\B/.test(S.charAt(S.length-1))||(S=S+"\\b"));let J="";return H.global&&(J+="g"),H.matchCase||(J+="i"),H.multiline&&(J+="m"),H.unicode&&(J+="u"),new RegExp(S,J)}t.$Me=o;function c(S){return S.source==="^"||S.source==="^$"||S.source==="$"||S.source==="^\\s*$"?!1:!!(S.exec("")&&S.lastIndex===0)}t.$Ne=c;function f(S){return S.split(/\r\n|\r|\n/)}t.$Oe=f;function u(S){for(let B=0,H=S.length;B<H;B++){const J=S.charCodeAt(B);if(J!==32&&J!==9)return B}return-1}t.$Pe=u;function i(S,B=0,H=S.length){for(let J=B;J<H;J++){const ue=S.charCodeAt(J);if(ue!==32&&ue!==9)return S.substring(B,J)}return S.substring(B,H)}t.$Qe=i;function a(S,B=S.length-1){for(let H=B;H>=0;H--){const J=S.charCodeAt(H);if(J!==32&&J!==9)return H}return-1}t.$Re=a;function N(S,B,H){const J=[];let ue=0;for(const ae of S.matchAll(B)){if(J.push(S.slice(ue,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");ue=ae.index+ae[0].length,J.push(H(ae[0],...ae.slice(1),ae.index,S,ae.groups))}return J.push(S.slice(ue)),Promise.all(J).then(ae=>ae.join(""))}t.$Se=N;function m(S,B){return S<B?-1:S>B?1:0}t.$Te=m;function w(S,B,H=0,J=S.length,ue=0,ae=B.length){for(;H<J&&ue<ae;H++,ue++){const Ee=S.charCodeAt(H),Ae=B.charCodeAt(ue);if(Ee<Ae)return-1;if(Ee>Ae)return 1}const de=J-H,Pe=ae-ue;return de<Pe?-1:de>Pe?1:0}t.$Ue=w;function M(S,B){return p(S,B,0,S.length,0,B.length)}t.$Ve=M;function p(S,B,H=0,J=S.length,ue=0,ae=B.length){for(;H<J&&ue<ae;H++,ue++){let Ee=S.charCodeAt(H),Ae=B.charCodeAt(ue);if(Ee===Ae)continue;if(Ee>=128||Ae>=128)return w(S.toLowerCase(),B.toLowerCase(),H,J,ue,ae);k(Ee)&&(Ee-=32),k(Ae)&&(Ae-=32);const be=Ee-Ae;if(be!==0)return be}const de=J-H,Pe=ae-ue;return de<Pe?-1:de>Pe?1:0}t.$We=p;function y(S){return S>=48&&S<=57}t.$Xe=y;function k(S){return S>=97&&S<=122}t.$Ye=k;function P(S){return S>=65&&S<=90}t.$Ze=P;function F(S,B){return S.length===B.length&&p(S,B)===0}t.$1e=F;function I(S,B){const H=B.length;return B.length>S.length?!1:p(S,B,0,H)===0}t.$2e=I;function q(S,B){const H=Math.min(S.length,B.length);let J;for(J=0;J<H;J++)if(S.charCodeAt(J)!==B.charCodeAt(J))return J;return H}t.$3e=q;function C(S,B){const H=Math.min(S.length,B.length);let J;const ue=S.length-1,ae=B.length-1;for(J=0;J<H;J++)if(S.charCodeAt(ue-J)!==B.charCodeAt(ae-J))return J;return H}t.$4e=C;function T(S){return 55296<=S&&S<=56319}t.$5e=T;function j(S){return 56320<=S&&S<=57343}t.$6e=j;function z(S,B){return(S-55296<<10)+(B-56320)+65536}t.$7e=z;function x(S,B,H){const J=S.charCodeAt(H);if(T(J)&&H+1<B){const ue=S.charCodeAt(H+1);if(j(ue))return z(J,ue)}return J}t.$8e=x;function X(S,B){const H=S.charCodeAt(B-1);if(j(H)&&B>1){const J=S.charCodeAt(B-2);if(T(J))return z(J,H)}return H}class n{get offset(){return this.e}constructor(B,H=0){this.c=B,this.d=B.length,this.e=H}setOffset(B){this.e=B}prevCodePoint(){const B=X(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=x(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.$9e=n;class ne{get offset(){return this.c.offset}constructor(B,H=0){this.c=new n(B,H)}nextGraphemeLength(){const B=we.getInstance(),H=this.c,J=H.offset;let ue=B.getGraphemeBreakType(H.nextCodePoint());for(;!H.eol();){const ae=H.offset,de=B.getGraphemeBreakType(H.nextCodePoint());if(he(ue,de)){H.setOffset(ae);break}ue=de}return H.offset-J}prevGraphemeLength(){const B=we.getInstance(),H=this.c,J=H.offset;let ue=B.getGraphemeBreakType(H.prevCodePoint());for(;H.offset>0;){const ae=H.offset,de=B.getGraphemeBreakType(H.prevCodePoint());if(he(de,ue)){H.setOffset(ae);break}ue=de}return J-H.offset}eol(){return this.c.eol()}}t.$0e=ne;function ce(S,B){return new ne(S,B).nextGraphemeLength()}t.$$e=ce;function ge(S,B){return new ne(S,B).prevGraphemeLength()}t.$_e=ge;function Le(S,B){B>0&&j(S.charCodeAt(B))&&B--;const H=B+ce(S,B);return[H-ge(S,H),H]}t.$af=Le;function ve(S){const B=new ne(S);let H=0;for(;!B.eol();)H++,B.nextGraphemeLength();return H}t.$bf=ve;let $e;function Ne(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _e(S){return $e||($e=Ne()),$e.test(S)}t.$cf=_e;const Te=/^[\t\n\r\x20-\x7E]*$/;function Se(S){return Te.test(S)}t.$df=Se,t.$ef=/[\u2028\u2029]/;function Ie(S){return t.$ef.test(S)}t.$ff=Ie;function Me(S){return S>=11904&&S<=55215||S>=63744&&S<=64255||S>=65281&&S<=65374}t.$gf=Me;function U(S){return S>=127462&&S<=127487||S===8986||S===8987||S===9200||S===9203||S>=9728&&S<=10175||S===11088||S===11093||S>=127744&&S<=128591||S>=128640&&S<=128764||S>=128992&&S<=129008||S>=129280&&S<=129535||S>=129648&&S<=129782}t.$hf=U;function W(S,B){if(S.length<B)return S;const H=/\b/g;let J=0;for(;H.test(S)&&!(S.length-H.lastIndex<B);)J=H.lastIndex,H.lastIndex+=1;return S.substring(J).replace(/^\s/,"")}t.$if=W;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Z=/\x1b\].*?\x07/g;function ee(S){return S&&(S=S.replace(V,"").replace(Z,"")),S}t.$jf=ee,t.$kf=String.fromCharCode(65279);function G(S){return!!(S&&S.length>0&&S.charCodeAt(0)===65279)}t.$lf=G;function Y(S){return G(S)?S.substr(1):S}t.$mf=Y;function Q(S,B){if(!S||!B||S.length<B.length)return!1;const H=B.length,J=S.toLowerCase();let ue=0,ae=-1;for(;ue<H;){const de=J.indexOf(B[ue],ae+1);if(de<0)return!1;ae=de,ue++}return!0}t.$nf=Q;function K(S,B=!1){return S?(B&&(S=S.replace(/\\./g,"")),S.toLowerCase()!==S):!1}t.$of=K;function se(S){return S.charAt(0).toUpperCase()+S.slice(1)}t.$pf=se;function le(S,B=1){if(B===0)return"";let H=-1;do H=S.indexOf(`
`,H+1),B--;while(B>0&&H>=0);return H===-1?S:(S[H-1]==="\r"&&H--,S.substr(0,H))}t.$qf=le;function oe(S){return S=S%(2*26),S<26?String.fromCharCode(97+S):String.fromCharCode(65+S-26)}t.$rf=oe;function me(S){return we.getInstance().getGraphemeBreakType(S)}t.$sf=me;function he(S,B){return S===0?B!==5&&B!==7:S===2&&B===3?!1:S===4||S===2||S===3||B===4||B===2||B===3?!0:!(S===8&&(B===8||B===9||B===11||B===12)||(S===11||S===9)&&(B===9||B===10)||(S===12||S===10)&&B===10||B===5||B===13||B===7||S===1||S===13&&B===14||S===6&&B===6)}var pe;(function(S){S[S.Other=0]="Other",S[S.Prepend=1]="Prepend",S[S.CR=2]="CR",S[S.LF=3]="LF",S[S.Control=4]="Control",S[S.Extend=5]="Extend",S[S.Regional_Indicator=6]="Regional_Indicator",S[S.SpacingMark=7]="SpacingMark",S[S.L=8]="L",S[S.V=9]="V",S[S.T=10]="T",S[S.LV=11]="LV",S[S.LVT=12]="LVT",S[S.ZWJ=13]="ZWJ",S[S.Extended_Pictographic=14]="Extended_Pictographic"})(pe||(t.GraphemeBreakType=pe={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=Fe()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const H=this.d,J=H.length/3;let ue=1;for(;ue<=J;)if(B<H[3*ue])ue=2*ue;else if(B>H[3*ue+1])ue=2*ue+1;else return H[3*ue+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(S,B){if(S===0)return 0;const H=ke(S,B);if(H!==void 0)return H;const J=new n(B,S);return J.prevCodePoint(),J.offset}t.$tf=Ue;function ke(S,B){const H=new n(B,S);let J=H.prevCodePoint();for(;je(J)||J===65039||J===8419;){if(H.offset===0)return;J=H.prevCodePoint()}if(!U(J))return;let ue=H.offset;return ue>0&&H.prevCodePoint()===8205&&(ue=H.offset),ue}function je(S){return 127995<=S&&S<=127999}var Be;(function(S){S[S.zwj=8205]="zwj",S[S.emojiVariantSelector=65039]="emojiVariantSelector",S[S.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),t.$uf="\xA0";class De{static{this.c=new D.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new _.$we(B=>{function H(be){const ye=new Map;for(let Re=0;Re<be.length;Re+=2)ye.set(be[Re],be[Re+1]);return ye}function J(be,ye){const Re=new Map(be);for(const[Oe,Ve]of ye)Re.set(Oe,Ve);return Re}function ue(be,ye){if(!be)return ye;const Re=new Map;for(const[Oe,Ve]of be)ye.has(Oe)&&Re.set(Oe,Ve);return Re}const ae=this.c.value;let de=B.filter(be=>!be.startsWith("_")&&be in ae);de.length===0&&(de=["_default"]);let Pe;for(const be of de){const ye=H(ae[be]);Pe=ue(Pe,ye)}const Ee=H(ae._common),Ae=J(Ee,Pe);return new De(Ae)})}static getInstance(B){return De.d.get(Array.from(B))}static{this.e=new D.$U(()=>Object.keys(De.c.value).filter(B=>!B.startsWith("_")))}static getLocales(){return De.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$vf=De;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(B){return qe.e().has(B)}static get codePoints(){return qe.e()}}t.$wf=qe}),te(ie[40],re([0,1,7]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hi=t.$Gi=t.$Fi=t.$Ei=t.$Di=t.$Ci=t.$Bi=void 0;function D(L){return r(L,0)}t.$Bi=D;function r(L,o){switch(typeof L){case"object":return L===null?h(349,o):Array.isArray(L)?l(L,o):s(L,o);case"string":return d(L,o);case"boolean":return E(L,o);case"number":return h(L,o);case"undefined":return h(937,o);default:return h(617,o)}}t.$Ci=r;function h(L,o){return(o<<5)-o+L|0}t.$Di=h;function E(L,o){return h(L?433:863,o)}function d(L,o){o=h(149417,o);for(let c=0,f=L.length;c<f;c++)o=h(L.charCodeAt(c),o);return o}t.$Ei=d;function l(L,o){return o=h(104579,o),L.reduce((c,f)=>r(f,c),o)}function s(L,o){return o=h(181387,o),Object.keys(L).sort().reduce((c,f)=>(c=d(f,c),r(L[f],c)),o)}class g{constructor(){this.g=0}get value(){return this.g}hash(o){return this.g=r(o,this.g),this.g}}t.$Fi=g;var A;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function b(L,o,c=32){const f=c-o,u=~((1<<f)-1);return(L<<o|(u&L)>>>f)>>>0}function $(L,o=0,c=L.byteLength,f=0){for(let u=0;u<c;u++)L[o+u]=f}function e(L,o,c="0"){for(;L.length<o;)L=c+L;return L}function v(L,o=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(c=>c.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),o/4)}t.$Gi=v;class R{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(o){const c=o.length;if(c===0)return;const f=this.p;let u=this.r,i=this.u,a,N;for(i!==0?(a=i,N=-1,i=0):(a=o.charCodeAt(0),N=0);;){let m=a;if(_.$5e(a))if(N+1<c){const w=o.charCodeAt(N+1);_.$6e(w)?(N++,m=_.$7e(a,w)):m=65533}else{i=a;break}else _.$6e(a)&&(m=65533);if(u=this.w(f,u,m),N++,N<c)a=o.charCodeAt(N);else break}this.r=u,this.u=i}w(o,c,f){return f<128?o[c++]=f:f<2048?(o[c++]=192|(f&1984)>>>6,o[c++]=128|(f&63)>>>0):f<65536?(o[c++]=224|(f&61440)>>>12,o[c++]=128|(f&4032)>>>6,o[c++]=128|(f&63)>>>0):(o[c++]=240|(f&1835008)>>>18,o[c++]=128|(f&258048)>>>12,o[c++]=128|(f&4032)>>>6,o[c++]=128|(f&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const o=8*this.t;this.q.setUint32(56,Math.floor(o/4294967296),!1),this.q.setUint32(60,o%4294967296,!1),this.y()}y(){const o=R.g,c=this.q;for(let p=0;p<64;p+=4)o.setUint32(p,c.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)o.setUint32(p,b(o.getUint32(p-12,!1)^o.getUint32(p-32,!1)^o.getUint32(p-56,!1)^o.getUint32(p-64,!1),1),!1);let f=this.h,u=this.l,i=this.m,a=this.n,N=this.o,m,w,M;for(let p=0;p<80;p++)p<20?(m=u&i|~u&a,w=1518500249):p<40?(m=u^i^a,w=1859775393):p<60?(m=u&i|u&a|i&a,w=2400959708):(m=u^i^a,w=3395469782),M=b(f,5)+m+N+w+o.getUint32(p*4,!1)&4294967295,N=a,a=i,i=b(u,30),u=f,f=M;this.h=this.h+f&4294967295,this.l=this.l+u&4294967295,this.m=this.m+i&4294967295,this.n=this.n+a&4294967295,this.o=this.o+N&4294967295}}t.$Hi=R}),te(ie[25],re([0,1,36,40]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$us=t.$ts=t.$ss=void 0;class r{constructor(b){this.a=b}getElements(){const b=this.a,$=new Int32Array(b.length);for(let e=0,v=b.length;e<v;e++)$[e]=b.charCodeAt(e);return $}}t.$ss=r;function h(A,b,$){return new g(new r(A),new r(b)).ComputeDiff($).changes}t.$ts=h;class E{static Assert(b,$){if(!b)throw new Error($)}}class d{static Copy(b,$,e,v,R){for(let L=0;L<R;L++)e[v+L]=b[$+L]}static Copy2(b,$,e,v,R){for(let L=0;L<R;L++)e[v+L]=b[$+L]}}var l;(function(A){A[A.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new _.$rs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(b,$){this.b=Math.min(this.b,b),this.c=Math.min(this.c,$),this.d++}AddModifiedElement(b,$){this.b=Math.min(this.b,b),this.c=Math.min(this.c,$),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class g{constructor(b,$,e=null){this.a=e,this.b=b,this.c=$;const[v,R,L]=g.o(b),[o,c,f]=g.o($);this.d=L&&f,this.e=v,this.f=R,this.g=o,this.h=c,this.k=[],this.m=[]}static n(b){return b.length>0&&typeof b[0]=="string"}static o(b){const $=b.getElements();if(g.n($)){const e=new Int32Array($.length);for(let v=0,R=$.length;v<R;v++)e[v]=(0,D.$Ei)($[v],0);return[$,e,!0]}return $ instanceof Int32Array?[[],$,!1]:[[],new Int32Array($),!1]}p(b,$){return this.f[b]!==this.h[$]?!1:this.d?this.e[b]===this.g[$]:!0}q(b,$){if(!this.p(b,$))return!1;const e=g.r(this.b,b),v=g.r(this.c,$);return e===v}static r(b,$){return typeof b.getStrictElement=="function"?b.getStrictElement($):null}s(b,$){return this.f[b]!==this.f[$]?!1:this.d?this.e[b]===this.e[$]:!0}u(b,$){return this.h[b]!==this.h[$]?!1:this.d?this.g[b]===this.g[$]:!0}ComputeDiff(b){return this.v(0,this.f.length-1,0,this.h.length-1,b)}v(b,$,e,v,R){const L=[!1];let o=this.w(b,$,e,v,L);return R&&(o=this.z(o)),{quitEarly:L[0],changes:o}}w(b,$,e,v,R){for(R[0]=!1;b<=$&&e<=v&&this.p(b,e);)b++,e++;for(;$>=b&&v>=e&&this.p($,v);)$--,v--;if(b>$||e>v){let i;return e<=v?(E.Assert(b===$+1,"originalStart should only be one more than originalEnd"),i=[new _.$rs(b,0,e,v-e+1)]):b<=$?(E.Assert(e===v+1,"modifiedStart should only be one more than modifiedEnd"),i=[new _.$rs(b,$-b+1,e,0)]):(E.Assert(b===$+1,"originalStart should only be one more than originalEnd"),E.Assert(e===v+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const L=[0],o=[0],c=this.y(b,$,e,v,L,o,R),f=L[0],u=o[0];if(c!==null)return c;if(!R[0]){const i=this.w(b,f,e,u,R);let a=[];return R[0]?a=[new _.$rs(f+1,$-(f+1)+1,u+1,v-(u+1)+1)]:a=this.w(f+1,$,u+1,v,R),this.H(i,a)}return[new _.$rs(b,$-b+1,e,v-e+1)]}x(b,$,e,v,R,L,o,c,f,u,i,a,N,m,w,M,p,y){let k=null,P=null,F=new s,I=$,q=e,C=N[0]-M[0]-v,T=-1073741824,j=this.k.length-1;do{const z=C+b;z===I||z<q&&f[z-1]<f[z+1]?(i=f[z+1],m=i-C-v,i<T&&F.MarkNextChange(),T=i,F.AddModifiedElement(i+1,m),C=z+1-b):(i=f[z-1]+1,m=i-C-v,i<T&&F.MarkNextChange(),T=i-1,F.AddOriginalElement(i,m+1),C=z-1-b),j>=0&&(f=this.k[j],b=f[0],I=1,q=f.length-1)}while(--j>=-1);if(k=F.getReverseChanges(),y[0]){let z=N[0]+1,x=M[0]+1;if(k!==null&&k.length>0){const X=k[k.length-1];z=Math.max(z,X.getOriginalEnd()),x=Math.max(x,X.getModifiedEnd())}P=[new _.$rs(z,a-z+1,x,w-x+1)]}else{F=new s,I=L,q=o,C=N[0]-M[0]-c,T=1073741824,j=p?this.m.length-1:this.m.length-2;do{const z=C+R;z===I||z<q&&u[z-1]>=u[z+1]?(i=u[z+1]-1,m=i-C-c,i>T&&F.MarkNextChange(),T=i+1,F.AddOriginalElement(i+1,m+1),C=z+1-R):(i=u[z-1],m=i-C-c,i>T&&F.MarkNextChange(),T=i,F.AddModifiedElement(i+1,m+1),C=z-1-R),j>=0&&(u=this.m[j],R=u[0],I=1,q=u.length-1)}while(--j>=-1);P=F.getChanges()}return this.H(k,P)}y(b,$,e,v,R,L,o){let c=0,f=0,u=0,i=0,a=0,N=0;b--,e--,R[0]=0,L[0]=0,this.k=[],this.m=[];const m=$-b+(v-e),w=m+1,M=new Int32Array(w),p=new Int32Array(w),y=v-e,k=$-b,P=b-e,F=$-v,q=(k-y)%2===0;M[y]=b,p[k]=$,o[0]=!1;for(let C=1;C<=m/2+1;C++){let T=0,j=0;u=this.J(y-C,C,y,w),i=this.J(y+C,C,y,w);for(let x=u;x<=i;x+=2){x===u||x<i&&M[x-1]<M[x+1]?c=M[x+1]:c=M[x-1]+1,f=c-(x-y)-P;const X=c;for(;c<$&&f<v&&this.p(c+1,f+1);)c++,f++;if(M[x]=c,c+f>T+j&&(T=c,j=f),!q&&Math.abs(x-k)<=C-1&&c>=p[x])return R[0]=c,L[0]=f,X<=p[x]&&1447>0&&C<=1447+1?this.x(y,u,i,P,k,a,N,F,M,p,c,$,R,f,v,L,q,o):null}const z=(T-b+(j-e)-C)/2;if(this.a!==null&&!this.a(T,z))return o[0]=!0,R[0]=T,L[0]=j,z>0&&1447>0&&C<=1447+1?this.x(y,u,i,P,k,a,N,F,M,p,c,$,R,f,v,L,q,o):(b++,e++,[new _.$rs(b,$-b+1,e,v-e+1)]);a=this.J(k-C,C,k,w),N=this.J(k+C,C,k,w);for(let x=a;x<=N;x+=2){x===a||x<N&&p[x-1]>=p[x+1]?c=p[x+1]-1:c=p[x-1],f=c-(x-k)-F;const X=c;for(;c>b&&f>e&&this.p(c,f);)c--,f--;if(p[x]=c,q&&Math.abs(x-y)<=C&&c<=M[x])return R[0]=c,L[0]=f,X>=M[x]&&1447>0&&C<=1447+1?this.x(y,u,i,P,k,a,N,F,M,p,c,$,R,f,v,L,q,o):null}if(C<=1447){let x=new Int32Array(i-u+2);x[0]=y-u+1,d.Copy2(M,u,x,1,i-u+1),this.k.push(x),x=new Int32Array(N-a+2),x[0]=k-a+1,d.Copy2(p,a,x,1,N-a+1),this.m.push(x)}}return this.x(y,u,i,P,k,a,N,F,M,p,c,$,R,f,v,L,q,o)}z(b){for(let $=0;$<b.length;$++){const e=b[$],v=$<b.length-1?b[$+1].originalStart:this.f.length,R=$<b.length-1?b[$+1].modifiedStart:this.h.length,L=e.originalLength>0,o=e.modifiedLength>0;for(;e.originalStart+e.originalLength<v&&e.modifiedStart+e.modifiedLength<R&&(!L||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!o||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const f=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!f)break;e.originalStart++,e.modifiedStart++}const c=[null];if($<b.length-1&&this.I(b[$],b[$+1],c)){b[$]=c[0],b.splice($+1,1),$--;continue}}for(let $=b.length-1;$>=0;$--){const e=b[$];let v=0,R=0;if($>0){const i=b[$-1];v=i.originalStart+i.originalLength,R=i.modifiedStart+i.modifiedLength}const L=e.originalLength>0,o=e.modifiedLength>0;let c=0,f=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const a=e.originalStart-i,N=e.modifiedStart-i;if(a<v||N<R||L&&!this.s(a,a+e.originalLength)||o&&!this.u(N,N+e.modifiedLength))break;const w=(a===v&&N===R?5:0)+this.G(a,e.originalLength,N,e.modifiedLength);w>f&&(f=w,c=i)}e.originalStart-=c,e.modifiedStart-=c;const u=[null];if($>0&&this.I(b[$-1],b[$],u)){b[$-1]=u[0],b.splice($,1),$++;continue}}if(this.d)for(let $=1,e=b.length;$<e;$++){const v=b[$-1],R=b[$],L=R.originalStart-v.originalStart-v.originalLength,o=v.originalStart,c=R.originalStart+R.originalLength,f=c-o,u=v.modifiedStart,i=R.modifiedStart+R.modifiedLength,a=i-u;if(L<5&&f<20&&a<20){const N=this.A(o,f,u,a,L);if(N){const[m,w]=N;(m!==v.originalStart+v.originalLength||w!==v.modifiedStart+v.modifiedLength)&&(v.originalLength=m-v.originalStart,v.modifiedLength=w-v.modifiedStart,R.originalStart=m+L,R.modifiedStart=w+L,R.originalLength=c-R.originalStart,R.modifiedLength=i-R.modifiedStart)}}}return b}A(b,$,e,v,R){if($<R||v<R)return null;const L=b+$-R+1,o=e+v-R+1;let c=0,f=0,u=0;for(let i=b;i<L;i++)for(let a=e;a<o;a++){const N=this.B(i,a,R);N>0&&N>c&&(c=N,f=i,u=a)}return c>0?[f,u]:null}B(b,$,e){let v=0;for(let R=0;R<e;R++){if(!this.p(b+R,$+R))return 0;v+=this.e[b+R].length}return v}C(b){return b<=0||b>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[b])}D(b,$){if(this.C(b)||this.C(b-1))return!0;if($>0){const e=b+$;if(this.C(e-1)||this.C(e))return!0}return!1}E(b){return b<=0||b>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[b])}F(b,$){if(this.E(b)||this.E(b-1))return!0;if($>0){const e=b+$;if(this.E(e-1)||this.E(e))return!0}return!1}G(b,$,e,v){const R=this.D(b,$)?1:0,L=this.F(e,v)?1:0;return R+L}H(b,$){const e=[];if(b.length===0||$.length===0)return $.length>0?$:b;if(this.I(b[b.length-1],$[0],e)){const v=new Array(b.length+$.length-1);return d.Copy(b,0,v,0,b.length-1),v[b.length-1]=e[0],d.Copy($,1,v,b.length,$.length-1),v}else{const v=new Array(b.length+$.length);return d.Copy(b,0,v,0,b.length),d.Copy($,0,v,b.length,$.length),v}}I(b,$,e){if(E.Assert(b.originalStart<=$.originalStart,"Left change is not less than or equal to right change"),E.Assert(b.modifiedStart<=$.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=$.originalStart||b.modifiedStart+b.modifiedLength>=$.modifiedStart){const v=b.originalStart;let R=b.originalLength;const L=b.modifiedStart;let o=b.modifiedLength;return b.originalStart+b.originalLength>=$.originalStart&&(R=$.originalStart+$.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=$.modifiedStart&&(o=$.modifiedStart+$.modifiedLength-b.modifiedStart),e[0]=new _.$rs(v,R,L,o),!0}else return e[0]=null,!1}J(b,$,e,v){if(b>=0&&b<v)return b;const R=e,L=v-e-1,o=$%2===0;if(b<0){const c=R%2===0;return o===c?0:1}else{const c=L%2===0;return o===c?v-1:v-2}}}t.$us=g}),te(ie[26],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=void 0;function _(u){return typeof u=="string"}t.$xf=_;function D(u){return Array.isArray(u)&&u.every(i=>_(i))}t.$yf=D;function r(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}t.$zf=r;function h(u){const i=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof i}t.$Af=h;function E(u){return typeof u=="number"&&!isNaN(u)}t.$Bf=E;function d(u){return!!u&&typeof u[Symbol.iterator]=="function"}t.$Cf=d;function l(u){return u===!0||u===!1}t.$Df=l;function s(u){return typeof u>"u"}t.$Ef=s;function g(u){return!A(u)}t.$Ff=g;function A(u){return s(u)||u===null}t.$Gf=A;function b(u,i){if(!u)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.$Hf=b;function $(u){if(A(u))throw new Error("Assertion Failed: argument is undefined or null");return u}t.$If=$;function e(...u){const i=[];for(let a=0;a<u.length;a++){const N=u[a];if(A(N))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);i.push(N)}return i}t.$Jf=e;const v=Object.prototype.hasOwnProperty;function R(u){if(!r(u))return!1;for(const i in u)if(v.call(u,i))return!1;return!0}t.$Kf=R;function L(u){return typeof u=="function"}t.$Lf=L;function o(...u){return u.length>0&&u.every(L)}t.$Mf=o;function c(u,i){const a=Math.min(u.length,i.length);for(let N=0;N<a;N++)f(u[N],i[N])}t.$Nf=c;function f(u,i){if(_(i)){if(typeof u!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(L(i)){try{if(u instanceof i)return}catch{}if(!A(u)&&u.constructor===i||i.length===1&&i.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Of=f}),te(ie[41],re([0,1,26]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sj=t.$Rj=t.$Qj=void 0;const D=Object.create(null);function r(d,l){if((0,_.$xf)(l)){const s=D[l];if(s===void 0)throw new Error(`${d} references an unknown codicon: ${l}`);l=s}return D[d]=l,{id:d}}function h(){return D}t.$Qj=h;function E(){return Object.values(t.$Sj)}t.$Rj=E,t.$Sj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),te(ie[14],re([0,1,26]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$an=t.$_m=t.$$m=t.$0m=t.$9m=t.$8m=t.$7m=t.$6m=t.$5m=t.$4m=t.$3m=t.$2m=void 0;function D(L){if(!L||typeof L!="object"||L instanceof RegExp)return L;const o=Array.isArray(L)?[]:{};return Object.entries(L).forEach(([c,f])=>{o[c]=f&&typeof f=="object"?D(f):f}),o}t.$2m=D;function r(L){if(!L||typeof L!="object")return L;const o=[L];for(;o.length>0;){const c=o.shift();Object.freeze(c);for(const f in c)if(h.call(c,f)){const u=c[f];typeof u=="object"&&!Object.isFrozen(u)&&!(0,_.$Af)(u)&&o.push(u)}}return L}t.$3m=r;const h=Object.prototype.hasOwnProperty;function E(L,o){return d(L,o,new Set)}t.$4m=E;function d(L,o,c){if((0,_.$Gf)(L))return L;const f=o(L);if(typeof f<"u")return f;if(Array.isArray(L)){const u=[];for(const i of L)u.push(d(i,o,c));return u}if((0,_.$zf)(L)){if(c.has(L))throw new Error("Cannot clone recursive data-structure");c.add(L);const u={};for(const i in L)h.call(L,i)&&(u[i]=d(L[i],o,c));return c.delete(L),u}return L}function l(L,o,c=!0){return(0,_.$zf)(L)?((0,_.$zf)(o)&&Object.keys(o).forEach(f=>{f in L?c&&((0,_.$zf)(L[f])&&(0,_.$zf)(o[f])?l(L[f],o[f],c):L[f]=o[f]):L[f]=o[f]}),L):o}t.$5m=l;function s(L,o){if(L===o)return!0;if(L==null||o===null||o===void 0||typeof L!=typeof o||typeof L!="object"||Array.isArray(L)!==Array.isArray(o))return!1;let c,f;if(Array.isArray(L)){if(L.length!==o.length)return!1;for(c=0;c<L.length;c++)if(!s(L[c],o[c]))return!1}else{const u=[];for(f in L)u.push(f);u.sort();const i=[];for(f in o)i.push(f);if(i.sort(),!s(u,i))return!1;for(c=0;c<u.length;c++)if(!s(L[u[c]],o[u[c]]))return!1}return!0}t.$6m=s;function g(L){const o=new Set;return JSON.stringify(L,(c,f)=>{if((0,_.$zf)(f)||Array.isArray(f)){if(o.has(f))return"[Circular]";o.add(f)}return f})}t.$7m=g;function A(L,o){const c=Object.create(null);return!L||!o||Object.keys(o).forEach(u=>{const i=L[u],a=o[u];s(i,a)||(c[u]=a)}),c}t.$8m=A;function b(L,o){const c=o.toLowerCase(),f=Object.keys(L).find(u=>u.toLowerCase()===c);return f?L[f]:L[o]}t.$9m=b;function $(L,o){const c=Object.create(null);for(const[f,u]of Object.entries(L))o(f,u)&&(c[f]=u);return c}t.$0m=$;function e(L){let o=[];for(;Object.prototype!==L;)o=o.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return o}t.$$m=e;function v(L){const o=[];for(const c of e(L))typeof L[c]=="function"&&o.push(c);return o}t.$_m=v;function R(L,o){const c=u=>function(){const i=Array.prototype.slice.call(arguments,0);return o(u,i)},f={};for(const u of L)f[u]=c(u);return f}t.$an=R}),te(ie[27],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=t.$ye=t.Constants=void 0;var _;(function(h){h[h.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",h[h.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",h[h.MAX_UINT_8=255]="MAX_UINT_8",h[h.MAX_UINT_16=65535]="MAX_UINT_16",h[h.MAX_UINT_32=4294967295]="MAX_UINT_32",h[h.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_||(t.Constants=_={}));function D(h){return h<0?0:h>255?255:h|0}t.$ye=D;function r(h){return h<0?0:h>4294967295?4294967295:h|0}t.$ze=r}),te(ie[28],re([0,1,27]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ms=t.$Ls=void 0;class D{constructor(d){const l=(0,_.$ye)(d);this.c=l,this.a=D.d(l),this.b=new Map}static d(d){const l=new Uint8Array(256);return l.fill(d),l}set(d,l){const s=(0,_.$ye)(l);d>=0&&d<256?this.a[d]=s:this.b.set(d,s)}get(d){return d>=0&&d<256?this.a[d]:this.b.get(d)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$Ls=D;var r;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(r||(r={}));class h{constructor(){this.a=new D(0)}add(d){this.a.set(d,1)}has(d){return this.a.get(d)===1}clear(){return this.a.clear()}}t.$Ms=h}),te(ie[4],re([0,1,3]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ws=t.$vs=void 0;class D{static addRange(E,d){let l=0;for(;l<d.length&&d[l].endExclusive<E.start;)l++;let s=l;for(;s<d.length&&d[s].start<=E.endExclusive;)s++;if(l===s)d.splice(l,0,E);else{const g=Math.min(E.start,d[l].start),A=Math.max(E.endExclusive,d[s-1].endExclusive);d.splice(l,s-l,new D(g,A))}}static tryCreate(E,d){if(!(E>d))return new D(E,d)}static ofLength(E){return new D(0,E)}constructor(E,d){if(this.start=E,this.endExclusive=d,E>d)throw new _.$bb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(E){return new D(this.start+E,this.endExclusive+E)}deltaStart(E){return new D(this.start+E,this.endExclusive)}deltaEnd(E){return new D(this.start,this.endExclusive+E)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(E){return this.start===E.start&&this.endExclusive===E.endExclusive}containsRange(E){return this.start<=E.start&&E.endExclusive<=this.endExclusive}contains(E){return this.start<=E&&E<this.endExclusive}join(E){return new D(Math.min(this.start,E.start),Math.max(this.endExclusive,E.endExclusive))}intersect(E){const d=Math.max(this.start,E.start),l=Math.min(this.endExclusive,E.endExclusive);if(d<=l)return new D(d,l)}intersectsOrTouches(E){const d=Math.max(this.start,E.start),l=Math.min(this.endExclusive,E.endExclusive);return d<=l}slice(E){return E.slice(this.start,this.endExclusive)}clip(E){if(this.isEmpty)throw new _.$bb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,E))}clipCyclic(E){if(this.isEmpty)throw new _.$bb(`Invalid clipping range: ${this.toString()}`);return E<this.start?this.endExclusive-(this.start-E)%this.length:E>=this.endExclusive?this.start+(E-this.start)%this.length:E}map(E){const d=[];for(let l=this.start;l<this.endExclusive;l++)d.push(E(l));return d}forEach(E){for(let d=this.start;d<this.endExclusive;d++)E(d)}}t.$vs=D;class r{constructor(){this.a=[]}addRange(E){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<E.start;)d++;let l=d;for(;l<this.a.length&&this.a[l].start<=E.endExclusive;)l++;if(d===l)this.a.splice(d,0,E);else{const s=Math.min(E.start,this.a[d].start),g=Math.max(E.endExclusive,this.a[l-1].endExclusive);this.a.splice(d,l-d,new D(s,g))}}toString(){return this.a.map(E=>E.toString()).join(", ")}intersectsStrict(E){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<=E.start;)d++;return d<this.a.length&&this.a[d].start<E.endExclusive}intersectWithRange(E){const d=new r;for(const l of this.a){const s=l.intersect(E);s&&d.addRange(s)}return d}intersectWithRangeLength(E){return this.intersectWithRange(E).length}get length(){return this.a.reduce((E,d)=>E+d.length,0)}}t.$ws=r}),te(ie[5],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ns=void 0;class _{constructor(r,h){this.lineNumber=r,this.column=h}with(r=this.lineNumber,h=this.column){return r===this.lineNumber&&h===this.column?this:new _(r,h)}delta(r=0,h=0){return this.with(this.lineNumber+r,this.column+h)}equals(r){return _.equals(this,r)}static equals(r,h){return!r&&!h?!0:!!r&&!!h&&r.lineNumber===h.lineNumber&&r.column===h.column}isBefore(r){return _.isBefore(this,r)}static isBefore(r,h){return r.lineNumber<h.lineNumber?!0:h.lineNumber<r.lineNumber?!1:r.column<h.column}isBeforeOrEqual(r){return _.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,h){return r.lineNumber<h.lineNumber?!0:h.lineNumber<r.lineNumber?!1:r.column<=h.column}static compare(r,h){const E=r.lineNumber|0,d=h.lineNumber|0;if(E===d){const l=r.column|0,s=h.column|0;return l-s}return E-d}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new _(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}t.$ns=_}),te(ie[2],re([0,1,5]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$os=void 0;class D{constructor(h,E,d,l){h>d||h===d&&E>l?(this.startLineNumber=d,this.startColumn=l,this.endLineNumber=h,this.endColumn=E):(this.startLineNumber=h,this.startColumn=E,this.endLineNumber=d,this.endColumn=l)}isEmpty(){return D.isEmpty(this)}static isEmpty(h){return h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn}containsPosition(h){return D.containsPosition(this,h)}static containsPosition(h,E){return!(E.lineNumber<h.startLineNumber||E.lineNumber>h.endLineNumber||E.lineNumber===h.startLineNumber&&E.column<h.startColumn||E.lineNumber===h.endLineNumber&&E.column>h.endColumn)}static strictContainsPosition(h,E){return!(E.lineNumber<h.startLineNumber||E.lineNumber>h.endLineNumber||E.lineNumber===h.startLineNumber&&E.column<=h.startColumn||E.lineNumber===h.endLineNumber&&E.column>=h.endColumn)}containsRange(h){return D.containsRange(this,h)}static containsRange(h,E){return!(E.startLineNumber<h.startLineNumber||E.endLineNumber<h.startLineNumber||E.startLineNumber>h.endLineNumber||E.endLineNumber>h.endLineNumber||E.startLineNumber===h.startLineNumber&&E.startColumn<h.startColumn||E.endLineNumber===h.endLineNumber&&E.endColumn>h.endColumn)}strictContainsRange(h){return D.strictContainsRange(this,h)}static strictContainsRange(h,E){return!(E.startLineNumber<h.startLineNumber||E.endLineNumber<h.startLineNumber||E.startLineNumber>h.endLineNumber||E.endLineNumber>h.endLineNumber||E.startLineNumber===h.startLineNumber&&E.startColumn<=h.startColumn||E.endLineNumber===h.endLineNumber&&E.endColumn>=h.endColumn)}plusRange(h){return D.plusRange(this,h)}static plusRange(h,E){let d,l,s,g;return E.startLineNumber<h.startLineNumber?(d=E.startLineNumber,l=E.startColumn):E.startLineNumber===h.startLineNumber?(d=E.startLineNumber,l=Math.min(E.startColumn,h.startColumn)):(d=h.startLineNumber,l=h.startColumn),E.endLineNumber>h.endLineNumber?(s=E.endLineNumber,g=E.endColumn):E.endLineNumber===h.endLineNumber?(s=E.endLineNumber,g=Math.max(E.endColumn,h.endColumn)):(s=h.endLineNumber,g=h.endColumn),new D(d,l,s,g)}intersectRanges(h){return D.intersectRanges(this,h)}static intersectRanges(h,E){let d=h.startLineNumber,l=h.startColumn,s=h.endLineNumber,g=h.endColumn;const A=E.startLineNumber,b=E.startColumn,$=E.endLineNumber,e=E.endColumn;return d<A?(d=A,l=b):d===A&&(l=Math.max(l,b)),s>$?(s=$,g=e):s===$&&(g=Math.min(g,e)),d>s||d===s&&l>g?null:new D(d,l,s,g)}equalsRange(h){return D.equalsRange(this,h)}static equalsRange(h,E){return!h&&!E?!0:!!h&&!!E&&h.startLineNumber===E.startLineNumber&&h.startColumn===E.startColumn&&h.endLineNumber===E.endLineNumber&&h.endColumn===E.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(h){return new _.$ns(h.endLineNumber,h.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(h){return new _.$ns(h.startLineNumber,h.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(h,E){return new D(this.startLineNumber,this.startColumn,h,E)}setStartPosition(h,E){return new D(h,E,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(h){return new D(h.startLineNumber,h.startColumn,h.startLineNumber,h.startColumn)}collapseToEnd(){return D.collapseToEnd(this)}static collapseToEnd(h){return new D(h.endLineNumber,h.endColumn,h.endLineNumber,h.endColumn)}delta(h){return new D(this.startLineNumber+h,this.startColumn,this.endLineNumber+h,this.endColumn)}static fromPositions(h,E=h){return new D(h.lineNumber,h.column,E.lineNumber,E.column)}static lift(h){return h?new D(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):null}static isIRange(h){return h&&typeof h.startLineNumber=="number"&&typeof h.startColumn=="number"&&typeof h.endLineNumber=="number"&&typeof h.endColumn=="number"}static areIntersectingOrTouching(h,E){return!(h.endLineNumber<E.startLineNumber||h.endLineNumber===E.startLineNumber&&h.endColumn<E.startColumn||E.endLineNumber<h.startLineNumber||E.endLineNumber===h.startLineNumber&&E.endColumn<h.startColumn)}static areIntersecting(h,E){return!(h.endLineNumber<E.startLineNumber||h.endLineNumber===E.startLineNumber&&h.endColumn<=E.startColumn||E.endLineNumber<h.startLineNumber||E.endLineNumber===h.startLineNumber&&E.endColumn<=h.startColumn)}static compareRangesUsingStarts(h,E){if(h&&E){const s=h.startLineNumber|0,g=E.startLineNumber|0;if(s===g){const A=h.startColumn|0,b=E.startColumn|0;if(A===b){const $=h.endLineNumber|0,e=E.endLineNumber|0;if($===e){const v=h.endColumn|0,R=E.endColumn|0;return v-R}return $-e}return A-b}return s-g}return(h?1:0)-(E?1:0)}static compareRangesUsingEnds(h,E){return h.endLineNumber===E.endLineNumber?h.endColumn===E.endColumn?h.startLineNumber===E.startLineNumber?h.startColumn-E.startColumn:h.startLineNumber-E.startLineNumber:h.endColumn-E.endColumn:h.endLineNumber-E.endLineNumber}static spansMultipleLines(h){return h.endLineNumber>h.startLineNumber}toJSON(){return this}}t.$os=D}),te(ie[42],re([0,1,2]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ps=void 0;class D{static insert(h,E){return{range:new _.$os(h.lineNumber,h.column,h.lineNumber,h.column),text:E,forceMoveMarkers:!0}}static delete(h){return{range:h,text:null}}static replace(h,E){return{range:h,text:E}}static replaceMove(h,E){return{range:h,text:E,forceMoveMarkers:!0}}}t.$ps=D}),te(ie[12],re([0,1,3,4,2,9]),function(O,t,_,D,r,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ys=t.$xs=void 0;class E{static fromRange(s){return new E(s.startLineNumber,s.endLineNumber)}static subtract(s,g){return g?s.startLineNumber<g.startLineNumber&&g.endLineNumberExclusive<s.endLineNumberExclusive?[new E(s.startLineNumber,g.startLineNumber),new E(g.endLineNumberExclusive,s.endLineNumberExclusive)]:g.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=g.endLineNumberExclusive?[]:g.endLineNumberExclusive<s.endLineNumberExclusive?[new E(Math.max(g.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new E(s.startLineNumber,Math.min(g.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let g=new d(s[0].slice());for(let A=1;A<s.length;A++)g=g.getUnion(new d(s[A].slice()));return g.ranges}static ofLength(s,g){return new E(s,s+g)}static deserialize(s){return new E(s[0],s[1])}constructor(s,g){if(s>g)throw new _.$bb(`startLineNumber ${s} cannot be after endLineNumberExclusive ${g}`);this.startLineNumber=s,this.endLineNumberExclusive=g}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new E(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new E(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new E(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const g=Math.max(this.startLineNumber,s.startLineNumber),A=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(g<=A)return new E(g,A)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.$os(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.$os(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const g=[];for(let A=this.startLineNumber;A<this.endLineNumberExclusive;A++)g.push(s(A));return g}forEach(s){for(let g=this.startLineNumber;g<this.endLineNumberExclusive;g++)s(g)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new D.$vs(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$xs=E;class d{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const g=(0,h.$jb)(this.c,b=>b.endLineNumberExclusive>=s.startLineNumber),A=(0,h.$hb)(this.c,b=>b.startLineNumber<=s.endLineNumberExclusive)+1;if(g===A)this.c.splice(g,0,s);else if(g===A-1){const b=this.c[g];this.c[g]=b.join(s)}else{const b=this.c[g].join(this.c[A-1]).join(s);this.c.splice(g,A-g,b)}}contains(s){const g=(0,h.$gb)(this.c,A=>A.startLineNumber<=s);return!!g&&g.endLineNumberExclusive>s}intersects(s){const g=(0,h.$gb)(this.c,A=>A.startLineNumber<s.endLineNumberExclusive);return!!g&&g.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const g=[];let A=0,b=0,$=null;for(;A<this.c.length||b<s.c.length;){let e=null;if(A<this.c.length&&b<s.c.length){const v=this.c[A],R=s.c[b];v.startLineNumber<R.startLineNumber?(e=v,A++):(e=R,b++)}else A<this.c.length?(e=this.c[A],A++):(e=s.c[b],b++);$===null?$=e:$.endLineNumberExclusive>=e.startLineNumber?$=new E($.startLineNumber,Math.max($.endLineNumberExclusive,e.endLineNumberExclusive)):(g.push($),$=e)}return $!==null&&g.push($),new d(g)}subtractFrom(s){const g=(0,h.$jb)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),A=(0,h.$hb)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(g===A)return new d([s]);const b=[];let $=s.startLineNumber;for(let e=g;e<A;e++){const v=this.c[e];v.startLineNumber>$&&b.push(new E($,v.startLineNumber)),$=v.endLineNumberExclusive}return $<s.endLineNumberExclusive&&b.push(new E($,s.endLineNumberExclusive)),new d(b)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const g=[];let A=0,b=0;for(;A<this.c.length&&b<s.c.length;){const $=this.c[A],e=s.c[b],v=$.intersect(e);v&&!v.isEmpty&&g.push(v),$.endLineNumberExclusive<e.endLineNumberExclusive?A++:b++}return new d(g)}getWithDelta(s){return new d(this.c.map(g=>g.delta(s)))}}t.$ys=d}),te(ie[43],re([0,1,5,2]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qs=t.SelectionDirection=void 0;var r;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class h extends D.$os{constructor(d,l,s,g){super(d,l,s,g),this.selectionStartLineNumber=d,this.selectionStartColumn=l,this.positionLineNumber=s,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return h.selectionsEqual(this,d)}static selectionsEqual(d,l){return d.selectionStartLineNumber===l.selectionStartLineNumber&&d.selectionStartColumn===l.selectionStartColumn&&d.positionLineNumber===l.positionLineNumber&&d.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,l){return this.getDirection()===0?new h(this.startLineNumber,this.startColumn,d,l):new h(d,l,this.startLineNumber,this.startColumn)}getPosition(){return new _.$ns(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new _.$ns(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,l){return this.getDirection()===0?new h(d,l,this.endLineNumber,this.endColumn):new h(this.endLineNumber,this.endColumn,d,l)}static fromPositions(d,l=d){return new h(d.lineNumber,d.column,l.lineNumber,l.column)}static fromRange(d,l){return l===0?new h(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new h(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new h(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,l){if(d&&!l||!d&&l)return!1;if(!d&&!l)return!0;if(d.length!==l.length)return!1;for(let s=0,g=d.length;s<g;s++)if(!this.selectionsEqual(d[s],l[s]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,l,s,g,A){return A===0?new h(d,l,s,g):new h(s,g,d,l)}}t.$qs=h}),te(ie[44],re([0,1,28]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Os=t.$Ns=t.WordCharacterClass=void 0;var D;(function(E){E[E.Regular=0]="Regular",E[E.Whitespace=1]="Whitespace",E[E.WordSeparator=2]="WordSeparator"})(D||(t.WordCharacterClass=D={}));class r extends _.$Ls{constructor(d){super(0);for(let l=0,s=d.length;l<s;l++)this.set(d.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}t.$Ns=r;function h(E){const d={};return l=>(d.hasOwnProperty(l)||(d[l]=E(l)),d[l])}t.$Os=h(E=>new r(E))}),te(ie[29],re([0,1,20,10,21]),function(O,t,_,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4r=t.$3r=t.$2r=t.$1r=t.$Zr=void 0,t.$Zr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function h(A=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const $ of t.$Zr)A.indexOf($)>=0||(b+="\\"+$);return b+="\\s]+)",new RegExp(b,"g")}t.$1r=h();function E(A){let b=t.$1r;if(A&&A instanceof RegExp)if(A.global)b=A;else{let $="g";A.ignoreCase&&($+="i"),A.multiline&&($+="m"),A.unicode&&($+="u"),b=new RegExp(A.source,$)}return b.lastIndex=0,b}t.$2r=E;const d=new r.$1c;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(A){const b=d.unshift(A);return(0,D.$Pc)(b)}t.$3r=l;function s(A,b,$,e,v){if(v||(v=_.Iterable.first(d)),$.length>v.maxLen){let f=A-v.maxLen/2;return f<0?f=0:e+=f,$=$.substring(f,A+v.maxLen/2),s(A,b,$,e,v)}const R=Date.now(),L=A-1-e;let o=-1,c=null;for(let f=1;!(Date.now()-R>=v.timeBudget);f++){const u=L-v.windowSize*f;b.lastIndex=Math.max(0,u);const i=g(b,$,L,o);if(!i&&c||(c=i,u<=0))break;o=u}if(c){const f={word:c[0],startColumn:e+1+c.index,endColumn:e+1+c.index+c[0].length};return b.lastIndex=0,f}return null}t.$4r=s;function g(A,b,$,e){let v;for(;v=A.exec(b);){const R=v.index||0;if(R<=$&&A.lastIndex>=$)return v;if(e>0&&R>e)return null}return null}}),te(ie[8],re([0,1,6,3,4]),function(O,t,_,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1Y=t.$ZY=t.$YY=t.$XY=t.$WY=void 0;class h{static trivial(A,b){return new h([new E(r.$vs.ofLength(A.length),r.$vs.ofLength(b.length))],!1)}static trivialTimedOut(A,b){return new h([new E(r.$vs.ofLength(A.length),r.$vs.ofLength(b.length))],!0)}constructor(A,b){this.diffs=A,this.hitTimeout=b}}t.$WY=h;class E{static invert(A,b){const $=[];return(0,_.$Ab)(A,(e,v)=>{$.push(E.fromOffsetPairs(e?e.getEndExclusives():d.zero,v?v.getStarts():new d(b,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+b)))}),$}static fromOffsetPairs(A,b){return new E(new r.$vs(A.offset1,b.offset1),new r.$vs(A.offset2,b.offset2))}constructor(A,b){this.seq1Range=A,this.seq2Range=b}swap(){return new E(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(A){return new E(this.seq1Range.join(A.seq1Range),this.seq2Range.join(A.seq2Range))}delta(A){return A===0?this:new E(this.seq1Range.delta(A),this.seq2Range.delta(A))}deltaStart(A){return A===0?this:new E(this.seq1Range.deltaStart(A),this.seq2Range.deltaStart(A))}deltaEnd(A){return A===0?this:new E(this.seq1Range.deltaEnd(A),this.seq2Range.deltaEnd(A))}intersectsOrTouches(A){return this.seq1Range.intersectsOrTouches(A.seq1Range)||this.seq2Range.intersectsOrTouches(A.seq2Range)}intersect(A){const b=this.seq1Range.intersect(A.seq1Range),$=this.seq2Range.intersect(A.seq2Range);if(!(!b||!$))return new E(b,$)}getStarts(){return new d(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new d(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$XY=E;class d{static{this.zero=new d(0,0)}static{this.max=new d(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(A,b){this.offset1=A,this.offset2=b}toString(){return`${this.offset1} <-> ${this.offset2}`}}t.$YY=d;class l{static{this.instance=new l}isValid(){return!0}}t.$ZY=l;class s{constructor(A){if(this.e=A,this.c=Date.now(),this.d=!0,A<=0)throw new D.$bb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$1Y=s}),te(ie[30],re([0,1,4,8]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6Y=void 0;class r{compute(s,g,A=D.$ZY.instance){if(s.length===0||g.length===0)return D.$WY.trivial(s,g);const b=s,$=g;function e(a,N){for(;a<b.length&&N<$.length&&b.getElement(a)===$.getElement(N);)a++,N++;return a}let v=0;const R=new E;R.set(0,e(0,0));const L=new d;L.set(0,R.get(0)===0?null:new h(null,0,0,R.get(0)));let o=0;e:for(;;){if(v++,!A.isValid())return D.$WY.trivialTimedOut(b,$);const a=-Math.min(v,$.length+v%2),N=Math.min(v,b.length+v%2);for(o=a;o<=N;o+=2){let m=0;const w=o===N?-1:R.get(o+1),M=o===a?-1:R.get(o-1)+1;m++;const p=Math.min(Math.max(w,M),b.length),y=p-o;if(m++,p>b.length||y>$.length)continue;const k=e(p,y);R.set(o,k);const P=p===w?L.get(o+1):L.get(o-1);if(L.set(o,k!==p?new h(P,p,y,k-p):P),R.get(o)===b.length&&R.get(o)-o===$.length)break e}}let c=L.get(o);const f=[];let u=b.length,i=$.length;for(;;){const a=c?c.x+c.length:0,N=c?c.y+c.length:0;if((a!==u||N!==i)&&f.push(new D.$XY(new _.$vs(a,u),new _.$vs(N,i))),!c)break;u=c.x,i=c.y,c=c.prev}return f.reverse(),new D.$WY(f,!1)}}t.$6Y=r;class h{constructor(s,g,A,b){this.prev=s,this.x=g,this.y=A,this.length=b}}class E{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,g){if(s<0){if(s=-s-1,s>=this.b.length){const A=this.b;this.b=new Int32Array(A.length*2),this.b.set(A)}this.b[s]=g}else{if(s>=this.a.length){const A=this.a;this.a=new Int32Array(A.length*2),this.a.set(A)}this.a[s]=g}}}class d{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,g){s<0?(s=-s-1,this.b[s]=g):this.a[s]=g}}}),te(ie[45],re([0,1,6,4,8]),function(O,t,_,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bZ=t.$aZ=t.$_Y=t.$$Y=t.$0Y=void 0;function h(e,v,R){let L=R;return L=E(e,v,L),L=d(e,v,L),L}t.$0Y=h;function E(e,v,R){if(R.length===0)return R;const L=[];L.push(R[0]);for(let c=1;c<R.length;c++){const f=L[L.length-1];let u=R[c];if(u.seq1Range.isEmpty||u.seq2Range.isEmpty){const i=u.seq1Range.start-f.seq1Range.endExclusive;let a;for(a=1;a<=i&&!(e.getElement(u.seq1Range.start-a)!==e.getElement(u.seq1Range.endExclusive-a)||v.getElement(u.seq2Range.start-a)!==v.getElement(u.seq2Range.endExclusive-a));a++);if(a--,a===i){L[L.length-1]=new r.$XY(new D.$vs(f.seq1Range.start,u.seq1Range.endExclusive-i),new D.$vs(f.seq2Range.start,u.seq2Range.endExclusive-i));continue}u=u.delta(-a)}L.push(u)}const o=[];for(let c=0;c<L.length-1;c++){const f=L[c+1];let u=L[c];if(u.seq1Range.isEmpty||u.seq2Range.isEmpty){const i=f.seq1Range.start-u.seq1Range.endExclusive;let a;for(a=0;a<i&&!(!e.isStronglyEqual(u.seq1Range.start+a,u.seq1Range.endExclusive+a)||!v.isStronglyEqual(u.seq2Range.start+a,u.seq2Range.endExclusive+a));a++);if(a===i){L[c+1]=new r.$XY(new D.$vs(u.seq1Range.start+i,f.seq1Range.endExclusive),new D.$vs(u.seq2Range.start+i,f.seq2Range.endExclusive));continue}a>0&&(u=u.delta(a))}o.push(u)}return L.length>0&&o.push(L[L.length-1]),o}function d(e,v,R){if(!e.getBoundaryScore||!v.getBoundaryScore)return R;for(let L=0;L<R.length;L++){const o=L>0?R[L-1]:void 0,c=R[L],f=L+1<R.length?R[L+1]:void 0,u=new D.$vs(o?o.seq1Range.start+1:0,f?f.seq1Range.endExclusive-1:e.length),i=new D.$vs(o?o.seq2Range.start+1:0,f?f.seq2Range.endExclusive-1:v.length);c.seq1Range.isEmpty?R[L]=l(c,e,v,u,i):c.seq2Range.isEmpty&&(R[L]=l(c.swap(),v,e,i,u).swap())}return R}function l(e,v,R,L,o){let f=1;for(;e.seq1Range.start-f>=L.start&&e.seq2Range.start-f>=o.start&&R.isStronglyEqual(e.seq2Range.start-f,e.seq2Range.endExclusive-f)&&f<100;)f++;f--;let u=0;for(;e.seq1Range.start+u<L.endExclusive&&e.seq2Range.endExclusive+u<o.endExclusive&&R.isStronglyEqual(e.seq2Range.start+u,e.seq2Range.endExclusive+u)&&u<100;)u++;if(f===0&&u===0)return e;let i=0,a=-1;for(let N=-f;N<=u;N++){const m=e.seq2Range.start+N,w=e.seq2Range.endExclusive+N,M=e.seq1Range.start+N,p=v.getBoundaryScore(M)+R.getBoundaryScore(m)+R.getBoundaryScore(w);p>a&&(a=p,i=N)}return e.delta(i)}function s(e,v,R){const L=[];for(const o of R){const c=L[L.length-1];if(!c){L.push(o);continue}o.seq1Range.start-c.seq1Range.endExclusive<=2||o.seq2Range.start-c.seq2Range.endExclusive<=2?L[L.length-1]=new r.$XY(c.seq1Range.join(o.seq1Range),c.seq2Range.join(o.seq2Range)):L.push(o)}return L}t.$$Y=s;function g(e,v,R){const L=[];let o;function c(){if(!o)return;const u=o.s1Range.length-o.deleted,i=o.s2Range.length-o.added;Math.max(o.deleted,o.added)+(o.count-1)>u&&L.push(new r.$XY(o.s1Range,o.s2Range)),o=void 0}for(const u of R){let i=function(M,p){if(!o||!o.s1Range.containsRange(M)||!o.s2Range.containsRange(p))if(o&&!(o.s1Range.endExclusive<M.start&&o.s2Range.endExclusive<p.start)){const P=D.$vs.tryCreate(o.s1Range.endExclusive,M.start),F=D.$vs.tryCreate(o.s2Range.endExclusive,p.start);o.deleted+=P?.length??0,o.added+=F?.length??0,o.s1Range=o.s1Range.join(M),o.s2Range=o.s2Range.join(p)}else c(),o={added:0,deleted:0,count:0,s1Range:M,s2Range:p};const y=M.intersect(u.seq1Range),k=p.intersect(u.seq2Range);o.count++,o.deleted+=y?.length??0,o.added+=k?.length??0};const a=e.findWordContaining(u.seq1Range.start-1),N=v.findWordContaining(u.seq2Range.start-1),m=e.findWordContaining(u.seq1Range.endExclusive),w=v.findWordContaining(u.seq2Range.endExclusive);a&&m&&N&&w&&a.equals(m)&&N.equals(w)?i(a,N):(a&&N&&i(a,N),m&&w&&i(m,w))}return c(),A(R,L)}t.$_Y=g;function A(e,v){const R=[];for(;e.length>0||v.length>0;){const L=e[0],o=v[0];let c;L&&(!o||L.seq1Range.start<o.seq1Range.start)?c=e.shift():c=v.shift(),R.length>0&&R[R.length-1].seq1Range.endExclusive>=c.seq1Range.start?R[R.length-1]=R[R.length-1].join(c):R.push(c)}return R}function b(e,v,R){let L=R;if(L.length===0)return L;let o=0,c;do{c=!1;const f=[L[0]];for(let u=1;u<L.length;u++){let N=function(w,M){const p=new D.$vs(a.seq1Range.endExclusive,i.seq1Range.start);return e.getText(p).replace(/\s/g,"").length<=4&&(w.seq1Range.length+w.seq2Range.length>5||M.seq1Range.length+M.seq2Range.length>5)};const i=L[u],a=f[f.length-1];N(a,i)?(c=!0,f[f.length-1]=f[f.length-1].join(i)):f.push(i)}L=f}while(o++<10&&c);return L}t.$aZ=b;function $(e,v,R){let L=R;if(L.length===0)return L;let o=0,c;do{c=!1;const u=[L[0]];for(let i=1;i<L.length;i++){let m=function(M,p){const y=new D.$vs(N.seq1Range.endExclusive,a.seq1Range.start);if(e.countLinesIn(y)>5||y.length>500)return!1;const P=e.getText(y).trim();if(P.length>20||P.split(/\r\n|\r|\n/).length>1)return!1;const F=e.countLinesIn(M.seq1Range),I=M.seq1Range.length,q=v.countLinesIn(M.seq2Range),C=M.seq2Range.length,T=e.countLinesIn(p.seq1Range),j=p.seq1Range.length,z=v.countLinesIn(p.seq2Range),x=p.seq2Range.length,X=2*40+50;function n(ne){return Math.min(ne,X)}return Math.pow(Math.pow(n(F*40+I),1.5)+Math.pow(n(q*40+C),1.5),1.5)+Math.pow(Math.pow(n(T*40+j),1.5)+Math.pow(n(z*40+x),1.5),1.5)>(X**1.5)**1.5*1.3};const a=L[i],N=u[u.length-1];m(N,a)?(c=!0,u[u.length-1]=u[u.length-1].join(a)):u.push(a)}L=u}while(o++<10&&c);const f=[];return(0,_.$Bb)(L,(u,i,a)=>{let N=i;function m(P){return P.length>0&&P.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const w=e.extendToFullLines(i.seq1Range),M=e.getText(new D.$vs(w.start,i.seq1Range.start));m(M)&&(N=N.deltaStart(-M.length));const p=e.getText(new D.$vs(i.seq1Range.endExclusive,w.endExclusive));m(p)&&(N=N.deltaEnd(p.length));const y=r.$XY.fromOffsetPairs(u?u.getEndExclusives():r.$YY.zero,a?a.getStarts():r.$YY.max),k=N.intersect(y);f.push(k)}),f}t.$bZ=$}),te(ie[46],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9Y=void 0;class _{constructor(h,E){this.a=h,this.b=E}getElement(h){return this.a[h]}get length(){return this.a.length}getBoundaryScore(h){const E=h===0?0:D(this.b[h-1]),d=h===this.b.length?0:D(this.b[h]);return 1e3-(E+d)}getText(h){return this.b.slice(h.start,h.endExclusive).join(`
`)}isStronglyEqual(h,E){return this.b[h]===this.b[E]}}t.$9Y=_;function D(r){let h=0;for(;h<r.length&&(r.charCodeAt(h)===32||r.charCodeAt(h)===9);)h++;return h}}),te(ie[15],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4Y=t.$3Y=t.$2Y=void 0;class _{constructor(E,d){this.width=E,this.height=d,this.a=[],this.a=new Array(E*d)}get(E,d){return this.a[E+d*this.width]}set(E,d,l){this.a[E+d*this.width]=l}}t.$2Y=_;function D(h){return h===32||h===9}t.$3Y=D;class r{static{this.a=new Map}static b(E){let d=this.a.get(E);return d===void 0&&(d=this.a.size,this.a.set(E,d)),d}constructor(E,d,l){this.range=E,this.lines=d,this.source=l,this.d=[];let s=0;for(let g=E.startLineNumber-1;g<E.endLineNumberExclusive-1;g++){const A=d[g];for(let $=0;$<A.length;$++){s++;const e=A[$],v=r.b(e);this.d[v]=(this.d[v]||0)+1}s++;const b=r.b(`
`);this.d[b]=(this.d[b]||0)+1}this.c=s}computeSimilarity(E){let d=0;const l=Math.max(this.d.length,E.d.length);for(let s=0;s<l;s++)d+=Math.abs((this.d[s]??0)-(E.d[s]??0));return 1-d/(this.c+E.c)}}t.$4Y=r}),te(ie[47],re([0,1,4,8,15]),function(O,t,_,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5Y=void 0;class h{compute(d,l,s=D.$ZY.instance,g){if(d.length===0||l.length===0)return D.$WY.trivial(d,l);const A=new r.$2Y(d.length,l.length),b=new r.$2Y(d.length,l.length),$=new r.$2Y(d.length,l.length);for(let f=0;f<d.length;f++)for(let u=0;u<l.length;u++){if(!s.isValid())return D.$WY.trivialTimedOut(d,l);const i=f===0?0:A.get(f-1,u),a=u===0?0:A.get(f,u-1);let N;d.getElement(f)===l.getElement(u)?(f===0||u===0?N=0:N=A.get(f-1,u-1),f>0&&u>0&&b.get(f-1,u-1)===3&&(N+=$.get(f-1,u-1)),N+=g?g(f,u):1):N=-1;const m=Math.max(i,a,N);if(m===N){const w=f>0&&u>0?$.get(f-1,u-1):0;$.set(f,u,w+1),b.set(f,u,3)}else m===i?($.set(f,u,0),b.set(f,u,1)):m===a&&($.set(f,u,0),b.set(f,u,2));A.set(f,u,m)}const e=[];let v=d.length,R=l.length;function L(f,u){(f+1!==v||u+1!==R)&&e.push(new D.$XY(new _.$vs(f+1,v),new _.$vs(u+1,R))),v=f,R=u}let o=d.length-1,c=l.length-1;for(;o>=0&&c>=0;)b.get(o,c)===3?(L(o,c),o--,c--):b.get(o,c)===1?o--:c--;return L(-1,-1),e.reverse(),new D.$WY(e,!1)}}t.$5Y=h}),te(ie[31],re([0,1,9,4,5,2,15]),function(O,t,_,D,r,h,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7Y=void 0;class d{constructor(e,v,R){this.lines=e,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[];let L=!1;v.start>0&&v.endExclusive>=e.length&&(v=new D.$vs(v.start-1,v.endExclusive),L=!0),this.lineRange=v,this.c[0]=0;for(let o=this.lineRange.start;o<this.lineRange.endExclusive;o++){let c=e[o],f=0;if(L)f=c.length,c="",L=!1;else if(!R){const u=c.trimStart();f=c.length-u.length,c=u.trimEnd()}this.d.push(f);for(let u=0;u<c.length;u++)this.b.push(c.charCodeAt(u));o<e.length-1&&(this.b.push(`
`.charCodeAt(0)),this.c[o-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new D.$vs(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(v=>String.fromCharCode(v)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const v=b(e>0?this.b[e-1]:-1),R=b(e<this.b.length?this.b[e]:-1);if(v===6&&R===7)return 0;let L=0;return v!==R&&(L+=10,v===0&&R===1&&(L+=1)),L+=A(v),L+=A(R),L}translateOffset(e){if(this.lineRange.isEmpty)return new r.$ns(this.lineRange.start+1,1);const v=(0,_.$hb)(this.c,R=>R<=e);return new r.$ns(this.lineRange.start+v+1,e-this.c[v]+this.d[v]+1)}translateRange(e){return h.$os.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!l(this.b[e]))return;let v=e;for(;v>0&&l(this.b[v-1]);)v--;let R=e;for(;R<this.b.length&&l(this.b[R]);)R++;return new D.$vs(v,R)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,v){return this.b[e]===this.b[v]}extendToFullLines(e){const v=(0,_.$gb)(this.c,L=>L<=e.start)??0,R=(0,_.$ib)(this.c,L=>e.endExclusive<=L)??this.b.length;return new D.$vs(v,R)}}t.$7Y=d;function l($){return $>=97&&$<=122||$>=65&&$<=90||$>=48&&$<=57}var s;(function($){$[$.WordLower=0]="WordLower",$[$.WordUpper=1]="WordUpper",$[$.WordNumber=2]="WordNumber",$[$.End=3]="End",$[$.Other=4]="Other",$[$.Space=5]="Space",$[$.LineBreakCR=6]="LineBreakCR",$[$.LineBreakLF=7]="LineBreakLF"})(s||(s={}));const g={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function A($){return g[$]}function b($){return $===10?7:$===13?6:(0,E.$3Y)($)?5:$>=97&&$<=122?0:$>=65&&$<=90?1:$>=48&&$<=57?2:$===-1?3:4}}),te(ie[32],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ds=t.$Cs=void 0;class _{constructor(h,E,d){this.changes=h,this.moves=E,this.hitTimeout=d}}t.$Cs=_;class D{constructor(h,E){this.lineRangeMapping=h,this.changes=E}flip(){return new D(this.lineRangeMapping.flip(),this.changes.map(h=>h.flip()))}}t.$Ds=D}),te(ie[16],re([0,1,12]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bs=t.$As=t.$zs=void 0;class D{static inverse(d,l,s){const g=[];let A=1,b=1;for(const e of d){const v=new r(new _.$xs(A,e.original.startLineNumber),new _.$xs(b,e.modified.startLineNumber),void 0);v.modified.isEmpty||g.push(v),A=e.original.endLineNumberExclusive,b=e.modified.endLineNumberExclusive}const $=new r(new _.$xs(A,l+1),new _.$xs(b,s+1),void 0);return $.modified.isEmpty||g.push($),g}constructor(d,l){this.original=d,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new D(this.modified,this.original)}join(d){return new D(this.original.join(d.original),this.modified.join(d.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$zs=D;class r extends D{constructor(d,l,s){super(d,l),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(d=>d.flip()))}}t.$As=r;class h{constructor(d,l){this.originalRange=d,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new h(this.modifiedRange,this.originalRange)}}t.$Bs=h}),te(ie[48],re([0,1,8,16,6,9,22,12,4,31,15,30]),function(O,t,_,D,r,h,E,d,l,s,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8Y=void 0;function b(o,c,f,u,i,a){let{moves:N,excludedChanges:m}=$(o,c,f,a);if(!a.isValid())return[];const w=o.filter(p=>!m.has(p)),M=e(w,u,i,c,f,a);return(0,r.$Zb)(N,M),N=R(N),N=N.filter(p=>p.original.toOffsetRange().slice(c).map(k=>k.trim()).join(`
`).length>=10),N=L(o,N),N}t.$8Y=b;function $(o,c,f,u){const i=[],a=o.filter(w=>w.modified.isEmpty&&w.original.length>=3).map(w=>new g.$4Y(w.original,c,w)),N=new Set(o.filter(w=>w.original.isEmpty&&w.modified.length>=3).map(w=>new g.$4Y(w.modified,f,w))),m=new Set;for(const w of a){let M=-1,p;for(const y of N){const k=w.computeSimilarity(y);k>M&&(M=k,p=y)}if(M>.9&&p&&(N.delete(p),i.push(new D.$zs(w.range,p.range)),m.add(w.source),m.add(p.source)),!u.isValid())return{moves:i,excludedChanges:m}}return{moves:i,excludedChanges:m}}function e(o,c,f,u,i,a){const N=[],m=new E.$Fc;for(const k of o)for(let P=k.original.startLineNumber;P<k.original.endLineNumberExclusive-2;P++){const F=`${c[P-1]}:${c[P+1-1]}:${c[P+2-1]}`;m.add(F,{range:new d.$xs(P,P+3)})}const w=[];o.sort((0,r.$6b)(k=>k.modified.startLineNumber,r.$8b));for(const k of o){let P=[];for(let F=k.modified.startLineNumber;F<k.modified.endLineNumberExclusive-2;F++){const I=`${f[F-1]}:${f[F+1-1]}:${f[F+2-1]}`,q=new d.$xs(F,F+3),C=[];m.forEach(I,({range:T})=>{for(const z of P)if(z.originalLineRange.endLineNumberExclusive+1===T.endLineNumberExclusive&&z.modifiedLineRange.endLineNumberExclusive+1===q.endLineNumberExclusive){z.originalLineRange=new d.$xs(z.originalLineRange.startLineNumber,T.endLineNumberExclusive),z.modifiedLineRange=new d.$xs(z.modifiedLineRange.startLineNumber,q.endLineNumberExclusive),C.push(z);return}const j={modifiedLineRange:q,originalLineRange:T};w.push(j),C.push(j)}),P=C}if(!a.isValid())return[]}w.sort((0,r.$0b)((0,r.$6b)(k=>k.modifiedLineRange.length,r.$8b)));const M=new d.$ys,p=new d.$ys;for(const k of w){const P=k.modifiedLineRange.startLineNumber-k.originalLineRange.startLineNumber,F=M.subtractFrom(k.modifiedLineRange),I=p.subtractFrom(k.originalLineRange).getWithDelta(P),q=F.getIntersection(I);for(const C of q.ranges){if(C.length<3)continue;const T=C,j=C.delta(-P);N.push(new D.$zs(j,T)),M.addRange(T),p.addRange(j)}}N.sort((0,r.$6b)(k=>k.original.startLineNumber,r.$8b));const y=new h.$lb(o);for(let k=0;k<N.length;k++){const P=N[k],F=y.findLastMonotonous(X=>X.original.startLineNumber<=P.original.startLineNumber),I=(0,h.$gb)(o,X=>X.modified.startLineNumber<=P.modified.startLineNumber),q=Math.max(P.original.startLineNumber-F.original.startLineNumber,P.modified.startLineNumber-I.modified.startLineNumber),C=y.findLastMonotonous(X=>X.original.startLineNumber<P.original.endLineNumberExclusive),T=(0,h.$gb)(o,X=>X.modified.startLineNumber<P.modified.endLineNumberExclusive),j=Math.max(C.original.endLineNumberExclusive-P.original.endLineNumberExclusive,T.modified.endLineNumberExclusive-P.modified.endLineNumberExclusive);let z;for(z=0;z<q;z++){const X=P.original.startLineNumber-z-1,n=P.modified.startLineNumber-z-1;if(X>u.length||n>i.length||M.contains(n)||p.contains(X)||!v(u[X-1],i[n-1],a))break}z>0&&(p.addRange(new d.$xs(P.original.startLineNumber-z,P.original.startLineNumber)),M.addRange(new d.$xs(P.modified.startLineNumber-z,P.modified.startLineNumber)));let x;for(x=0;x<j;x++){const X=P.original.endLineNumberExclusive+x,n=P.modified.endLineNumberExclusive+x;if(X>u.length||n>i.length||M.contains(n)||p.contains(X)||!v(u[X-1],i[n-1],a))break}x>0&&(p.addRange(new d.$xs(P.original.endLineNumberExclusive,P.original.endLineNumberExclusive+x)),M.addRange(new d.$xs(P.modified.endLineNumberExclusive,P.modified.endLineNumberExclusive+x))),(z>0||x>0)&&(N[k]=new D.$zs(new d.$xs(P.original.startLineNumber-z,P.original.endLineNumberExclusive+x),new d.$xs(P.modified.startLineNumber-z,P.modified.endLineNumberExclusive+x)))}return N}function v(o,c,f){if(o.trim()===c.trim())return!0;if(o.length>300&&c.length>300)return!1;const i=new A.$6Y().compute(new s.$7Y([o],new l.$vs(0,1),!1),new s.$7Y([c],new l.$vs(0,1),!1),f);let a=0;const N=_.$XY.invert(i.diffs,o.length);for(const p of N)p.seq1Range.forEach(y=>{(0,g.$3Y)(o.charCodeAt(y))||a++});function m(p){let y=0;for(let k=0;k<o.length;k++)(0,g.$3Y)(p.charCodeAt(k))||y++;return y}const w=m(o.length>c.length?o:c);return a/w>.6&&w>10}function R(o){if(o.length===0)return o;o.sort((0,r.$6b)(f=>f.original.startLineNumber,r.$8b));const c=[o[0]];for(let f=1;f<o.length;f++){const u=c[c.length-1],i=o[f],a=i.original.startLineNumber-u.original.endLineNumberExclusive,N=i.modified.startLineNumber-u.modified.endLineNumberExclusive;if(a>=0&&N>=0&&a+N<=2){c[c.length-1]=u.join(i);continue}c.push(i)}return c}function L(o,c){const f=new h.$lb(o);return c=c.filter(u=>{const i=f.findLastMonotonous(m=>m.original.endLineNumberExclusive<u.original.endLineNumberExclusive)||new D.$zs(new d.$xs(1,1),new d.$xs(1,1)),a=(0,h.$gb)(o,m=>m.modified.endLineNumberExclusive<u.modified.endLineNumberExclusive);return i!==a}),c}}),te(ie[49],re([0,1,6,13,12,4,2,8,47,30,48,45,32,16,31,46]),function(O,t,_,D,r,h,E,d,l,s,g,A,b,$,e,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eZ=t.$dZ=t.$cZ=void 0;class R{constructor(){this.e=new l.$5Y,this.f=new s.$6Y}computeDiff(f,u,i){if(f.length<=1&&(0,_.$tb)(f,u,(X,n)=>X===n))return new b.$Cs([],[],!1);if(f.length===1&&f[0].length===0||u.length===1&&u[0].length===0)return new b.$Cs([new $.$As(new r.$xs(1,f.length+1),new r.$xs(1,u.length+1),[new $.$Bs(new E.$os(1,1,f.length,f[0].length+1),new E.$os(1,1,u.length,u[0].length+1))])],[],!1);const a=i.maxComputationTimeMs===0?d.$ZY.instance:new d.$1Y(i.maxComputationTimeMs),N=!i.ignoreTrimWhitespace,m=new Map;function w(X){let n=m.get(X);return n===void 0&&(n=m.size,m.set(X,n)),n}const M=f.map(X=>w(X.trim())),p=u.map(X=>w(X.trim())),y=new v.$9Y(M,f),k=new v.$9Y(p,u),P=(()=>y.length+k.length<1700?this.e.compute(y,k,a,(X,n)=>f[X]===u[n]?u[n].length===0?.1:1+Math.log(1+u[n].length):.99):this.f.compute(y,k))();let F=P.diffs,I=P.hitTimeout;F=(0,A.$0Y)(y,k,F),F=(0,A.$aZ)(y,k,F);const q=[],C=X=>{if(N)for(let n=0;n<X;n++){const ne=T+n,ce=j+n;if(f[ne]!==u[ce]){const ge=this.j(f,u,new d.$XY(new h.$vs(ne,ne+1),new h.$vs(ce,ce+1)),a,N);for(const Le of ge.mappings)q.push(Le);ge.hitTimeout&&(I=!0)}}};let T=0,j=0;for(const X of F){(0,D.$5c)(()=>X.seq1Range.start-T===X.seq2Range.start-j);const n=X.seq1Range.start-T;C(n),T=X.seq1Range.endExclusive,j=X.seq2Range.endExclusive;const ne=this.j(f,u,X,a,N);ne.hitTimeout&&(I=!0);for(const ce of ne.mappings)q.push(ce)}C(f.length-T);const z=L(q,f,u);let x=[];return i.computeMoves&&(x=this.h(z,f,u,M,p,a,N)),(0,D.$5c)(()=>{function X(ne,ce){if(ne.lineNumber<1||ne.lineNumber>ce.length)return!1;const ge=ce[ne.lineNumber-1];return!(ne.column<1||ne.column>ge.length+1)}function n(ne,ce){return!(ne.startLineNumber<1||ne.startLineNumber>ce.length+1||ne.endLineNumberExclusive<1||ne.endLineNumberExclusive>ce.length+1)}for(const ne of z){if(!ne.innerChanges)return!1;for(const ce of ne.innerChanges)if(!(X(ce.modifiedRange.getStartPosition(),u)&&X(ce.modifiedRange.getEndPosition(),u)&&X(ce.originalRange.getStartPosition(),f)&&X(ce.originalRange.getEndPosition(),f)))return!1;if(!n(ne.modified,u)||!n(ne.original,f))return!1}return!0}),new b.$Cs(z,x,I)}h(f,u,i,a,N,m,w){return(0,g.$8Y)(f,u,i,a,N,m).map(y=>{const k=this.j(u,i,new d.$XY(y.original.toOffsetRange(),y.modified.toOffsetRange()),m,w),P=L(k.mappings,u,i,!0);return new b.$Ds(y,P)})}j(f,u,i,a,N){const m=new e.$7Y(f,i.seq1Range,N),w=new e.$7Y(u,i.seq2Range,N),M=m.length+w.length<500?this.e.compute(m,w,a):this.f.compute(m,w,a);let p=M.diffs;return p=(0,A.$0Y)(m,w,p),p=(0,A.$_Y)(m,w,p),p=(0,A.$$Y)(m,w,p),p=(0,A.$bZ)(m,w,p),{mappings:p.map(k=>new $.$Bs(m.translateRange(k.seq1Range),w.translateRange(k.seq2Range))),hitTimeout:M.hitTimeout}}}t.$cZ=R;function L(c,f,u,i=!1){const a=[];for(const N of(0,_.$zb)(c.map(m=>o(m,f,u)),(m,w)=>m.original.overlapOrTouch(w.original)||m.modified.overlapOrTouch(w.modified))){const m=N[0],w=N[N.length-1];a.push(new $.$As(m.original.join(w.original),m.modified.join(w.modified),N.map(M=>M.innerChanges[0])))}return(0,D.$5c)(()=>!i&&a.length>0&&a[0].original.startLineNumber!==a[0].modified.startLineNumber?!1:(0,D.$6c)(a,(N,m)=>m.original.startLineNumber-N.original.endLineNumberExclusive===m.modified.startLineNumber-N.modified.endLineNumberExclusive&&N.original.endLineNumberExclusive<m.original.startLineNumber&&N.modified.endLineNumberExclusive<m.modified.startLineNumber)),a}t.$dZ=L;function o(c,f,u){let i=0,a=0;c.modifiedRange.endColumn===1&&c.originalRange.endColumn===1&&c.originalRange.startLineNumber+i<=c.originalRange.endLineNumber&&c.modifiedRange.startLineNumber+i<=c.modifiedRange.endLineNumber&&(a=-1),c.modifiedRange.startColumn-1>=u[c.modifiedRange.startLineNumber-1].length&&c.originalRange.startColumn-1>=f[c.originalRange.startLineNumber-1].length&&c.originalRange.startLineNumber<=c.originalRange.endLineNumber+a&&c.modifiedRange.startLineNumber<=c.modifiedRange.endLineNumber+a&&(i=1);const N=new r.$xs(c.originalRange.startLineNumber+i,c.originalRange.endLineNumber+1+a),m=new r.$xs(c.modifiedRange.startLineNumber+i,c.modifiedRange.endLineNumber+1+a);return new $.$As(N,m,[c])}t.$eZ=o}),te(ie[33],re([0,1,25,32,16,7,2,13,12]),function(O,t,_,D,r,h,E,d,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fs=t.$Es=void 0;const s=3;class g{computeDiff(i,a,N){const w=new L(i,a,{maxComputationTime:N.maxComputationTimeMs,shouldIgnoreTrimWhitespace:N.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),M=[];let p=null;for(const y of w.changes){let k;y.originalEndLineNumber===0?k=new l.$xs(y.originalStartLineNumber+1,y.originalStartLineNumber+1):k=new l.$xs(y.originalStartLineNumber,y.originalEndLineNumber+1);let P;y.modifiedEndLineNumber===0?P=new l.$xs(y.modifiedStartLineNumber+1,y.modifiedStartLineNumber+1):P=new l.$xs(y.modifiedStartLineNumber,y.modifiedEndLineNumber+1);let F=new r.$As(k,P,y.charChanges?.map(I=>new r.$Bs(new E.$os(I.originalStartLineNumber,I.originalStartColumn,I.originalEndLineNumber,I.originalEndColumn),new E.$os(I.modifiedStartLineNumber,I.modifiedStartColumn,I.modifiedEndLineNumber,I.modifiedEndColumn))));p&&(p.modified.endLineNumberExclusive===F.modified.startLineNumber||p.original.endLineNumberExclusive===F.original.startLineNumber)&&(F=new r.$As(p.original.join(F.original),p.modified.join(F.modified),p.innerChanges&&F.innerChanges?p.innerChanges.concat(F.innerChanges):void 0),M.pop()),M.push(F),p=F}return(0,d.$5c)(()=>(0,d.$6c)(M,(y,k)=>k.original.startLineNumber-y.original.endLineNumberExclusive===k.modified.startLineNumber-y.modified.endLineNumberExclusive&&y.original.endLineNumberExclusive<k.original.startLineNumber&&y.modified.endLineNumberExclusive<k.modified.startLineNumber)),new D.$Cs(M,[],w.quitEarly)}}t.$Es=g;function A(u,i,a,N){return new _.$us(u,i,a).ComputeDiff(N)}class b{constructor(i){const a=[],N=[];for(let m=0,w=i.length;m<w;m++)a[m]=o(i[m],1),N[m]=c(i[m],1);this.lines=i,this.a=a,this.b=N}getElements(){const i=[];for(let a=0,N=this.lines.length;a<N;a++)i[a]=this.lines[a].substring(this.a[a]-1,this.b[a]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,a,N){const m=[],w=[],M=[];let p=0;for(let y=a;y<=N;y++){const k=this.lines[y],P=i?this.a[y]:1,F=i?this.b[y]:k.length+1;for(let I=P;I<F;I++)m[p]=k.charCodeAt(I-1),w[p]=y+1,M[p]=I,p++;!i&&y<N&&(m[p]=10,w[p]=y+1,M[p]=k.length+1,p++)}return new $(m,w,M)}}class ${constructor(i,a,N){this.a=i,this.b=a,this.d=N}toString(){return"["+this.a.map((i,a)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this.b[a]},${this.d[a]})`).join(", ")+"]"}e(i,a){if(i<0||i>=a.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(i){return i>0&&i===this.b.length?this.getEndLineNumber(i-1):(this.e(i,this.b),this.b[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this.e(i,this.b),this.a[i]===10?this.b[i]+1:this.b[i])}getStartColumn(i){return i>0&&i===this.d.length?this.getEndColumn(i-1):(this.e(i,this.d),this.d[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this.e(i,this.d),this.a[i]===10?1:this.d[i]+1)}}class e{constructor(i,a,N,m,w,M,p,y){this.originalStartLineNumber=i,this.originalStartColumn=a,this.originalEndLineNumber=N,this.originalEndColumn=m,this.modifiedStartLineNumber=w,this.modifiedStartColumn=M,this.modifiedEndLineNumber=p,this.modifiedEndColumn=y}static createFromDiffChange(i,a,N){const m=a.getStartLineNumber(i.originalStart),w=a.getStartColumn(i.originalStart),M=a.getEndLineNumber(i.originalStart+i.originalLength-1),p=a.getEndColumn(i.originalStart+i.originalLength-1),y=N.getStartLineNumber(i.modifiedStart),k=N.getStartColumn(i.modifiedStart),P=N.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),F=N.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(m,w,M,p,y,k,P,F)}}function v(u){if(u.length<=1)return u;const i=[u[0]];let a=i[0];for(let N=1,m=u.length;N<m;N++){const w=u[N],M=w.originalStart-(a.originalStart+a.originalLength),p=w.modifiedStart-(a.modifiedStart+a.modifiedLength);Math.min(M,p)<s?(a.originalLength=w.originalStart+w.originalLength-a.originalStart,a.modifiedLength=w.modifiedStart+w.modifiedLength-a.modifiedStart):(i.push(w),a=w)}return i}class R{constructor(i,a,N,m,w){this.originalStartLineNumber=i,this.originalEndLineNumber=a,this.modifiedStartLineNumber=N,this.modifiedEndLineNumber=m,this.charChanges=w}static createFromDiffResult(i,a,N,m,w,M,p){let y,k,P,F,I;if(a.originalLength===0?(y=N.getStartLineNumber(a.originalStart)-1,k=0):(y=N.getStartLineNumber(a.originalStart),k=N.getEndLineNumber(a.originalStart+a.originalLength-1)),a.modifiedLength===0?(P=m.getStartLineNumber(a.modifiedStart)-1,F=0):(P=m.getStartLineNumber(a.modifiedStart),F=m.getEndLineNumber(a.modifiedStart+a.modifiedLength-1)),M&&a.originalLength>0&&a.originalLength<20&&a.modifiedLength>0&&a.modifiedLength<20&&w()){const q=N.createCharSequence(i,a.originalStart,a.originalStart+a.originalLength-1),C=m.createCharSequence(i,a.modifiedStart,a.modifiedStart+a.modifiedLength-1);if(q.getElements().length>0&&C.getElements().length>0){let T=A(q,C,w,!0).changes;p&&(T=v(T)),I=[];for(let j=0,z=T.length;j<z;j++)I.push(e.createFromDiffChange(T[j],q,C))}}return new R(y,k,P,F,I)}}class L{constructor(i,a,N){this.a=N.shouldComputeCharChanges,this.b=N.shouldPostProcessCharChanges,this.d=N.shouldIgnoreTrimWhitespace,this.e=N.shouldMakePrettyDiff,this.f=i,this.g=a,this.h=new b(i),this.j=new b(a),this.k=f(N.maxComputationTime),this.l=f(N.maxComputationTime===0?0:Math.min(N.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=A(this.h,this.j,this.k,this.e),a=i.changes,N=i.quitEarly;if(this.d){const p=[];for(let y=0,k=a.length;y<k;y++)p.push(R.createFromDiffResult(this.d,a[y],this.h,this.j,this.l,this.a,this.b));return{quitEarly:N,changes:p}}const m=[];let w=0,M=0;for(let p=-1,y=a.length;p<y;p++){const k=p+1<y?a[p+1]:null,P=k?k.originalStart:this.f.length,F=k?k.modifiedStart:this.g.length;for(;w<P&&M<F;){const I=this.f[w],q=this.g[M];if(I!==q){{let C=o(I,1),T=o(q,1);for(;C>1&&T>1;){const j=I.charCodeAt(C-2),z=q.charCodeAt(T-2);if(j!==z)break;C--,T--}(C>1||T>1)&&this.m(m,w+1,1,C,M+1,1,T)}{let C=c(I,1),T=c(q,1);const j=I.length+1,z=q.length+1;for(;C<j&&T<z;){const x=I.charCodeAt(C-1),X=I.charCodeAt(T-1);if(x!==X)break;C++,T++}(C<j||T<z)&&this.m(m,w+1,C,j,M+1,T,z)}}w++,M++}k&&(m.push(R.createFromDiffResult(this.d,k,this.h,this.j,this.l,this.a,this.b)),w+=k.originalLength,M+=k.modifiedLength)}return{quitEarly:N,changes:m}}m(i,a,N,m,w,M,p){if(this.n(i,a,N,m,w,M,p))return;let y;this.a&&(y=[new e(a,N,a,m,w,M,w,p)]),i.push(new R(a,a,w,w,y))}n(i,a,N,m,w,M,p){const y=i.length;if(y===0)return!1;const k=i[y-1];return k.originalEndLineNumber===0||k.modifiedEndLineNumber===0?!1:k.originalEndLineNumber===a&&k.modifiedEndLineNumber===w?(this.a&&k.charChanges&&k.charChanges.push(new e(a,N,a,m,w,M,w,p)),!0):k.originalEndLineNumber+1===a&&k.modifiedEndLineNumber+1===w?(k.originalEndLineNumber=a,k.modifiedEndLineNumber=w,this.a&&k.charChanges&&k.charChanges.push(new e(a,N,a,m,w,M,w,p)),!0):!1}}t.$Fs=L;function o(u,i){const a=h.$Pe(u);return a===-1?i:a+1}function c(u,i){const a=h.$Re(u);return a===-1?i:a+2}function f(u){if(u===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<u}}),te(ie[50],re([0,1,33,49]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fZ=void 0,t.$fZ={getLegacy:()=>new _.$Es,getDefault:()=>new D.$cZ}}),te(ie[51],re([0,1,35]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gZ=void 0;function D(b){const $=[];for(const e of b){const v=Number(e);(v||v===0&&e.replace(/\s/g,"")!=="")&&$.push(v)}return $}function r(b,$,e,v){return{red:b/255,blue:e/255,green:$/255,alpha:v}}function h(b,$){const e=$.index,v=$[0].length;if(!e)return;const R=b.positionAt(e);return{startLineNumber:R.lineNumber,startColumn:R.column,endLineNumber:R.lineNumber,endColumn:R.column+v}}function E(b,$){if(!b)return;const e=_.$Ss.Format.CSS.parseHex($);if(e)return{range:b,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function d(b,$,e){if(!b||$.length!==1)return;const R=$[0].values(),L=D(R);return{range:b,color:r(L[0],L[1],L[2],e?L[3]:1)}}function l(b,$,e){if(!b||$.length!==1)return;const R=$[0].values(),L=D(R),o=new _.$Ss(new _.$Qs(L[0],L[1]/100,L[2]/100,e?L[3]:1));return{range:b,color:r(o.rgba.r,o.rgba.g,o.rgba.b,o.rgba.a)}}function s(b,$){return typeof b=="string"?[...b.matchAll($)]:b.findMatches($)}function g(b){const $=[],v=s(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(v.length>0)for(const R of v){const L=R.filter(u=>u!==void 0),o=L[1],c=L[2];if(!c)continue;let f;if(o==="rgb"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;f=d(h(b,R),s(c,u),!1)}else if(o==="rgba"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;f=d(h(b,R),s(c,u),!0)}else if(o==="hsl"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;f=l(h(b,R),s(c,u),!1)}else if(o==="hsla"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;f=l(h(b,R),s(c,u),!0)}else o==="#"&&(f=E(h(b,R),o+c));f&&$.push(f)}return $}function A(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:g(b)}t.$gZ=A}),te(ie[52],re([0,1,28]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SY=t.$RY=t.$QY=t.State=void 0;var D;(function($){$[$.Invalid=0]="Invalid",$[$.Start=1]="Start",$[$.H=2]="H",$[$.HT=3]="HT",$[$.HTT=4]="HTT",$[$.HTTP=5]="HTTP",$[$.F=6]="F",$[$.FI=7]="FI",$[$.FIL=8]="FIL",$[$.BeforeColon=9]="BeforeColon",$[$.AfterColon=10]="AfterColon",$[$.AlmostThere=11]="AlmostThere",$[$.End=12]="End",$[$.Accept=13]="Accept",$[$.LastKnownState=14]="LastKnownState"})(D||(t.State=D={}));class r{constructor(e,v,R){const L=new Uint8Array(e*v);for(let o=0,c=e*v;o<c;o++)L[o]=R;this.a=L,this.rows=e,this.cols=v}get(e,v){return this.a[e*this.cols+v]}set(e,v,R){this.a[e*this.cols+v]=R}}class h{constructor(e){let v=0,R=0;for(let o=0,c=e.length;o<c;o++){const[f,u,i]=e[o];u>v&&(v=u),f>R&&(R=f),i>R&&(R=i)}v++,R++;const L=new r(R,v,0);for(let o=0,c=e.length;o<c;o++){const[f,u,i]=e[o];L.set(f,u,i)}this.a=L,this.b=v}nextState(e,v){return v<0||v>=this.b?0:this.a.get(e,v)}}t.$QY=h;let E=null;function d(){return E===null&&(E=new h([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),E}var l;(function($){$[$.None=0]="None",$[$.ForceTermination=1]="ForceTermination",$[$.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let s=null;function g(){if(s===null){s=new _.$Ls(0);const $=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<$.length;v++)s.set($.charCodeAt(v),1);const e=".,;:";for(let v=0;v<e.length;v++)s.set(e.charCodeAt(v),2)}return s}class A{static a(e,v,R,L,o){let c=o-1;do{const f=v.charCodeAt(c);if(e.get(f)!==2)break;c--}while(c>L);if(L>0){const f=v.charCodeAt(L-1),u=v.charCodeAt(c);(f===40&&u===41||f===91&&u===93||f===123&&u===125)&&c--}return{range:{startLineNumber:R,startColumn:L+1,endLineNumber:R,endColumn:c+2},url:v.substring(L,c+1)}}static computeLinks(e,v=d()){const R=g(),L=[];for(let o=1,c=e.getLineCount();o<=c;o++){const f=e.getLineContent(o),u=f.length;let i=0,a=0,N=0,m=1,w=!1,M=!1,p=!1,y=!1;for(;i<u;){let k=!1;const P=f.charCodeAt(i);if(m===13){let F;switch(P){case 40:w=!0,F=0;break;case 41:F=w?0:1;break;case 91:p=!0,M=!0,F=0;break;case 93:p=!1,F=M?0:1;break;case 123:y=!0,F=0;break;case 125:F=y?0:1;break;case 39:case 34:case 96:N===P?F=1:N===39||N===34||N===96?F=0:F=1;break;case 42:F=N===42?1:0;break;case 124:F=N===124?1:0;break;case 32:F=p?0:1;break;default:F=R.get(P)}F===1&&(L.push(A.a(R,f,o,a,i)),k=!0)}else if(m===12){let F;P===91?(M=!0,F=0):F=R.get(P),F===1?k=!0:m=13}else m=v.nextState(m,P),m===0&&(k=!0);k&&(m=1,w=!1,M=!1,y=!1,a=i+1,N=P),i++}m===13&&L.push(A.a(R,f,o,a,u))}return L}}t.$RY=A;function b($){return!$||typeof $.getLineCount!="function"||typeof $.getLineContent!="function"?[]:A.computeLinks($)}t.$SY=b}),te(ie[53],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TY=void 0;class _{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new _}navigateValueSet(r,h,E,d,l){if(r&&h){const s=this.a(h,l);if(s)return{range:r,value:s}}if(E&&d){const s=this.a(d,l);if(s)return{range:E,value:s}}return null}a(r,h){const E=this.b(r,h);return E!==null?E:this.d(r,h)}b(r,h){const E=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let d=Number(r);const l=parseFloat(r);return!isNaN(d)&&!isNaN(l)&&d===l?d===0&&!h?null:(d=Math.floor(d*E),d+=h?E:-E,String(d/E)):null}d(r,h){return this.e(this.c,r,h)}e(r,h,E){let d=null;for(let l=0,s=r.length;d===null&&l<s;l++)d=this.f(r[l],h,E);return d}f(r,h,E){let d=r.indexOf(h);return d>=0?(d+=E?1:-1,d<0?d=r.length-1:d%=r.length,r[d]):null}}t.$TY=_}),te(ie[54],re([0,1,14]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ku=t.$Ju=t.$Iu=t.$Hu=t.ModelConstants=t.PositionAffinity=t.$Gu=t.TrackedRangeStickiness=t.$Fu=t.$Eu=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var D;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(D||(t.OverviewRulerLane=D={}));var r;(function(f){f[f.Left=1]="Left",f[f.Right=2]="Right"})(r||(t.GlyphMarginLane=r={}));var h;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(h||(t.MinimapPosition=h={}));var E;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(E||(t.InjectedTextCursorStops=E={}));var d;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(d||(t.EndOfLinePreference=d={}));var l;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(l||(t.DefaultEndOfLine=l={}));var s;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class g{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(u){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,u.tabSize|0),u.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,u.indentSize|0),this.a=!1),this.insertSpaces=!!u.insertSpaces,this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=!!u.trimAutoWhitespace,this.bracketPairColorizationOptions=u.bracketPairColorizationOptions}equals(u){return this.tabSize===u.tabSize&&this.a===u.a&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace&&(0,_.$6m)(this.bracketPairColorizationOptions,u.bracketPairColorizationOptions)}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}t.$Eu=g;class A{constructor(u,i){this._findMatchBrand=void 0,this.range=u,this.matches=i}}t.$Fu=A;var b;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function $(f){return f&&typeof f.read=="function"}t.$Gu=$;var e;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None",f[f.LeftOfInjectedText=3]="LeftOfInjectedText",f[f.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var v;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(t.ModelConstants=v={}));class R{constructor(u,i,a,N,m,w){this.identifier=u,this.range=i,this.text=a,this.forceMoveMarkers=N,this.isAutoWhitespaceEdit=m,this._isTracked=w}}t.$Hu=R;class L{constructor(u,i,a){this.regex=u,this.wordSeparators=i,this.simpleSearch=a}}t.$Iu=L;class o{constructor(u,i,a){this.reverseEdits=u,this.changes=i,this.trimAutoWhitespaceLineNumbers=a}}t.$Ju=o;function c(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}t.$Ku=c}),te(ie[55],re([0,1,6,27]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pu=t.$Ou=t.$Nu=void 0;class r{constructor(l){this.a=l,this.b=new Uint32Array(l.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(l,s){l=(0,D.$ze)(l);const g=this.a,A=this.b,b=s.length;return b===0?!1:(this.a=new Uint32Array(g.length+b),this.a.set(g.subarray(0,l),0),this.a.set(g.subarray(l),l+b),this.a.set(s,l),l-1<this.c[0]&&(this.c[0]=l-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}setValue(l,s){return l=(0,D.$ze)(l),s=(0,D.$ze)(s),this.a[l]===s?!1:(this.a[l]=s,l-1<this.c[0]&&(this.c[0]=l-1),!0)}removeValues(l,s){l=(0,D.$ze)(l),s=(0,D.$ze)(s);const g=this.a,A=this.b;if(l>=g.length)return!1;const b=g.length-l;return s>=b&&(s=b),s===0?!1:(this.a=new Uint32Array(g.length-s),this.a.set(g.subarray(0,l),0),this.a.set(g.subarray(l+s),l),this.b=new Uint32Array(this.a.length),l-1<this.c[0]&&(this.c[0]=l-1),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(l){return l<0?0:(l=(0,D.$ze)(l),this.d(l))}d(l){if(l<=this.c[0])return this.b[l];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),l>=this.a.length&&(l=this.a.length-1);for(let g=s;g<=l;g++)this.b[g]=this.b[g-1]+this.a[g];return this.c[0]=Math.max(this.c[0],l),this.b[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let s=0,g=this.a.length-1,A=0,b=0,$=0;for(;s<=g;)if(A=s+(g-s)/2|0,b=this.b[A],$=b-this.a[A],l<$)g=A-1;else if(l>=b)s=A+1;else break;return new E(A,l-$)}}t.$Nu=r;class h{constructor(l){this.a=l,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(l){return this.g(),l===0?0:this.d[l-1]}getIndexOf(l){this.g();const s=this.e[l],g=s>0?this.d[s-1]:0;return new E(s,l-g)}removeValues(l,s){this.a.splice(l,s),this.f(l)}insertValues(l,s){this.a=(0,_.$Vb)(this.a,l,s),this.f(l)}f(l){this.b=!1,this.c=Math.min(this.c,l-1)}g(){if(!this.b){for(let l=this.c+1,s=this.a.length;l<s;l++){const g=this.a[l],A=l>0?this.d[l-1]:0;this.d[l]=A+g;for(let b=0;b<g;b++)this.e[A+b]=l}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(l,s){this.a[l]!==s&&(this.a[l]=s,this.f(l))}}t.$Ou=h;class E{constructor(l,s){this.index=l,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=s}}t.$Pu=E}),te(ie[56],re([0,1,7,5,55]),function(O,t,_,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qu=void 0;class h{constructor(d,l,s,g){this.d=d,this.f=l,this.g=s,this.h=g,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(d){d.eol&&d.eol!==this.g&&(this.g=d.eol,this.j=null);const l=d.changes;for(const s of l)this.o(s.range),this.p(new D.$ns(s.range.startLineNumber,s.range.startColumn),s.text);this.h=d.versionId,this.k=null}l(){if(!this.j){const d=this.g.length,l=this.f.length,s=new Uint32Array(l);for(let g=0;g<l;g++)s[g]=this.f[g].length+d;this.j=new r.$Nu(s)}}n(d,l){this.f[d]=l,this.j&&this.j.setValue(d,this.f[d].length+this.g.length)}o(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.startLineNumber-1].substring(d.endColumn-1));return}this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.endLineNumber-1].substring(d.endColumn-1)),this.f.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this.j&&this.j.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}p(d,l){if(l.length===0)return;const s=(0,_.$Oe)(l);if(s.length===1){this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+s[0]+this.f[d.lineNumber-1].substring(d.column-1));return}s[s.length-1]+=this.f[d.lineNumber-1].substring(d.column-1),this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+s[0]);const g=new Uint32Array(s.length-1);for(let A=1;A<s.length;A++)this.f.splice(d.lineNumber+A-1,0,s[A]),g[A-1]=s[A].length+this.g.length;this.j&&this.j.insertValues(d.lineNumber,g)}}t.$Qu=h}),te(ie[57],re([0,1,7,44,5,2,54]),function(O,t,_,D,r,h,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sB=t.$rB=t.$qB=t.$pB=t.$oB=t.$nB=void 0;const d=999;class l{constructor(o,c,f,u){this.searchString=o,this.isRegex=c,this.matchCase=f,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=s(this.searchString):o=this.searchString.indexOf(`
`)>=0;let c=null;try{c=_.$Me(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch{return null}if(!c)return null;let f=!this.isRegex&&!o;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new E.$Iu(c,this.wordSeparators?(0,D.$Os)(this.wordSeparators):null,f?this.searchString:null)}}t.$nB=l;function s(L){if(!L||L.length===0)return!1;for(let o=0,c=L.length;o<c;o++){const f=L.charCodeAt(o);if(f===10)return!0;if(f===92){if(o++,o>=c)break;const u=L.charCodeAt(o);if(u===110||u===114||u===87)return!0}}return!1}t.$oB=s;function g(L,o,c){if(!c)return new E.$Fu(L,null);const f=[];for(let u=0,i=o.length;u<i;u++)f[u]=o[u];return new E.$Fu(L,f)}t.$pB=g;class A{constructor(o){const c=[];let f=0;for(let u=0,i=o.length;u<i;u++)o.charCodeAt(u)===10&&(c[f++]=u);this.a=c}findLineFeedCountBeforeOffset(o){const c=this.a;let f=0,u=c.length-1;if(u===-1||o<=c[0])return 0;for(;f<u;){const i=f+((u-f)/2>>0);c[i]>=o?u=i-1:c[i+1]>=o?(f=i,u=i):f=i+1}return f+1}}class b{static findMatches(o,c,f,u,i){const a=c.parseSearchRequest();return a?a.regex.multiline?this.b(o,f,new R(a.wordSeparators,a.regex),u,i):this.c(o,f,a,u,i):[]}static a(o,c,f,u,i,a){let N,m=0;u?(m=u.findLineFeedCountBeforeOffset(i),N=c+i+m):N=c+i;let w;if(u){const k=u.findLineFeedCountBeforeOffset(i+a.length)-m;w=N+a.length+k}else w=N+a.length;const M=o.getPositionAt(N),p=o.getPositionAt(w);return new h.$os(M.lineNumber,M.column,p.lineNumber,p.column)}static b(o,c,f,u,i){const a=o.getOffsetAt(c.getStartPosition()),N=o.getValueInRange(c,1),m=o.getEOL()===`\r
`?new A(N):null,w=[];let M=0,p;for(f.reset(0);p=f.next(N);)if(w[M++]=g(this.a(o,a,N,m,p.index,p[0]),p,u),M>=i)return w;return w}static c(o,c,f,u,i){const a=[];let N=0;if(c.startLineNumber===c.endLineNumber){const w=o.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return N=this.d(f,w,c.startLineNumber,c.startColumn-1,N,a,u,i),a}const m=o.getLineContent(c.startLineNumber).substring(c.startColumn-1);N=this.d(f,m,c.startLineNumber,c.startColumn-1,N,a,u,i);for(let w=c.startLineNumber+1;w<c.endLineNumber&&N<i;w++)N=this.d(f,o.getLineContent(w),w,0,N,a,u,i);if(N<i){const w=o.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);N=this.d(f,w,c.endLineNumber,0,N,a,u,i)}return a}static d(o,c,f,u,i,a,N,m){const w=o.wordSeparators;if(!N&&o.simpleSearch){const y=o.simpleSearch,k=y.length,P=c.length;let F=-k;for(;(F=c.indexOf(y,F+k))!==-1;)if((!w||v(w,c,P,F,k))&&(a[i++]=new E.$Fu(new h.$os(f,F+1+u,f,F+1+k+u),null),i>=m))return i;return i}const M=new R(o.wordSeparators,o.regex);let p;M.reset(0);do if(p=M.next(c),p&&(a[i++]=g(new h.$os(f,p.index+1+u,f,p.index+1+p[0].length+u),p,N),i>=m))return i;while(p);return i}static findNextMatch(o,c,f,u){const i=c.parseSearchRequest();if(!i)return null;const a=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.e(o,f,a,u):this.f(o,f,a,u)}static e(o,c,f,u){const i=new r.$ns(c.lineNumber,1),a=o.getOffsetAt(i),N=o.getLineCount(),m=o.getValueInRange(new h.$os(i.lineNumber,i.column,N,o.getLineMaxColumn(N)),1),w=o.getEOL()===`\r
`?new A(m):null;f.reset(c.column-1);const M=f.next(m);return M?g(this.a(o,a,m,w,M.index,M[0]),M,u):c.lineNumber!==1||c.column!==1?this.e(o,new r.$ns(1,1),f,u):null}static f(o,c,f,u){const i=o.getLineCount(),a=c.lineNumber,N=o.getLineContent(a),m=this.g(f,N,a,c.column,u);if(m)return m;for(let w=1;w<=i;w++){const M=(a+w-1)%i,p=o.getLineContent(M+1),y=this.g(f,p,M+1,1,u);if(y)return y}return null}static g(o,c,f,u,i){o.reset(u-1);const a=o.next(c);return a?g(new h.$os(f,a.index+1,f,a.index+1+a[0].length),a,i):null}static findPreviousMatch(o,c,f,u){const i=c.parseSearchRequest();if(!i)return null;const a=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.h(o,f,a,u):this.j(o,f,a,u)}static h(o,c,f,u){const i=this.b(o,new h.$os(1,1,c.lineNumber,c.column),f,u,10*d);if(i.length>0)return i[i.length-1];const a=o.getLineCount();return c.lineNumber!==a||c.column!==o.getLineMaxColumn(a)?this.h(o,new r.$ns(a,o.getLineMaxColumn(a)),f,u):null}static j(o,c,f,u){const i=o.getLineCount(),a=c.lineNumber,N=o.getLineContent(a).substring(0,c.column-1),m=this.k(f,N,a,u);if(m)return m;for(let w=1;w<=i;w++){const M=(i+a-w-1)%i,p=o.getLineContent(M+1),y=this.k(f,p,M+1,u);if(y)return y}return null}static k(o,c,f,u){let i=null,a;for(o.reset(0);a=o.next(c);)i=g(new h.$os(f,a.index+1,f,a.index+1+a[0].length),a,u);return i}}t.$qB=b;function $(L,o,c,f,u){if(f===0)return!0;const i=o.charCodeAt(f-1);if(L.get(i)!==0||i===13||i===10)return!0;if(u>0){const a=o.charCodeAt(f);if(L.get(a)!==0)return!0}return!1}function e(L,o,c,f,u){if(f+u===c)return!0;const i=o.charCodeAt(f+u);if(L.get(i)!==0||i===13||i===10)return!0;if(u>0){const a=o.charCodeAt(f+u-1);if(L.get(a)!==0)return!0}return!1}function v(L,o,c,f,u){return $(L,o,c,f,u)&&e(L,o,c,f,u)}t.$rB=v;class R{constructor(o,c){this._wordSeparators=o,this.a=c,this.b=-1,this.c=0}reset(o){this.a.lastIndex=o,this.b=-1,this.c=0}next(o){const c=o.length;let f;do{if(this.b+this.c===c||(f=this.a.exec(o),!f))return null;const u=f.index,i=f[0].length;if(u===this.b&&i===this.c){if(i===0){_.$8e(o,c,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=u,this.c=i,!this._wordSeparators||v(this._wordSeparators,o,c,u,i))return f}while(f);return null}}t.$sB=R}),te(ie[58],re([0,1,2,57,7,13,29]),function(O,t,_,D,r,h,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$PY=void 0;class d{static computeUnicodeHighlights(e,v,R){const L=R?R.startLineNumber:1,o=R?R.endLineNumber:e.getLineCount(),c=new g(v),f=c.getCandidateCodePoints();let u;f==="allNonBasicAscii"?u=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):u=new RegExp(`${l(Array.from(f))}`,"g");const i=new D.$sB(null,u),a=[];let N=!1,m,w=0,M=0,p=0;e:for(let y=L,k=o;y<=k;y++){const P=e.getLineContent(y),F=P.length;i.reset(0);do if(m=i.next(P),m){let I=m.index,q=m.index+m[0].length;if(I>0){const z=P.charCodeAt(I-1);r.$5e(z)&&I--}if(q+1<F){const z=P.charCodeAt(q-1);r.$5e(z)&&q++}const C=P.substring(I,q);let T=(0,E.$4r)(I+1,E.$1r,P,0);T&&T.endColumn<=I+1&&(T=null);const j=c.shouldHighlightNonBasicASCII(C,T?T.word:null);if(j!==0){j===3?w++:j===2?M++:j===1?p++:(0,h.$3c)(j);const z=1e3;if(a.length>=z){N=!0;break e}a.push(new _.$os(y,I+1,y,q+1))}}while(m)}return{ranges:a,hasMore:N,ambiguousCharacterCount:w,invisibleCharacterCount:M,nonBasicAsciiCharacterCount:p}}static computeUnicodeHighlightReason(e,v){const R=new g(v);switch(R.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const o=e.codePointAt(0),c=R.ambiguousCharacters.getPrimaryConfusable(o),f=r.$vf.getLocales().filter(u=>!r.$vf.getInstance(new Set([...v.allowedLocales,u])).isAmbiguous(o));return{kind:0,confusableWith:String.fromCodePoint(c),notAmbiguousInLocales:f}}case 1:return{kind:2}}}}t.$PY=d;function l($,e){return`[${r.$Ee($.map(R=>String.fromCodePoint(R)).join(""))}]`}var s;(function($){$[$.Ambiguous=0]="Ambiguous",$[$.Invisible=1]="Invisible",$[$.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class g{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.$vf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const v of r.$wf.codePoints)A(String.fromCodePoint(v))||e.add(v);if(this.b.ambiguousCharacters)for(const v of this.ambiguousCharacters.getConfusableCodePoints())e.add(v);for(const v of this.a)e.delete(v);return e}shouldHighlightNonBasicASCII(e,v){const R=e.codePointAt(0);if(this.a.has(R))return 0;if(this.b.nonBasicASCII)return 1;let L=!1,o=!1;if(v)for(const c of v){const f=c.codePointAt(0),u=r.$df(c);L=L||u,!u&&!this.ambiguousCharacters.isAmbiguous(f)&&!r.$wf.isInvisibleCharacter(f)&&(o=!0)}return!L&&o?0:this.b.invisibleCharacters&&!A(e)&&r.$wf.isInvisibleCharacter(R)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(R)?3:0}}function A($){return $===" "||$===`
`||$==="	"}var b;(function($){$[$.None=0]="None",$[$.NonBasicASCII=1]="NonBasicASCII",$[$.Invisible=2]="Invisible",$[$.Ambiguous=3]="Ambiguous"})(b||(b={}))}),te(ie[59],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var _;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(_||(t.AccessibilitySupport=_={}));var D;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(D||(t.CodeActionTriggerType=D={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var h;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(h||(t.CompletionItemKind=h={}));var E;(function(n){n[n.Deprecated=1]="Deprecated"})(E||(t.CompletionItemTag=E={}));var d;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(t.CompletionTriggerKind=d={}));var l;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(l||(t.ContentWidgetPositionPreference=l={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var g;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(g||(t.DefaultEndOfLine=g={}));var A;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(A||(t.DocumentHighlightKind=A={}));var b;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(b||(t.EditorAutoIndentStrategy=b={}));var $;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.occurrencesHighlight=80]="occurrencesHighlight",n[n.overviewRulerBorder=81]="overviewRulerBorder",n[n.overviewRulerLanes=82]="overviewRulerLanes",n[n.padding=83]="padding",n[n.pasteAs=84]="pasteAs",n[n.parameterHints=85]="parameterHints",n[n.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",n[n.quickSuggestions=88]="quickSuggestions",n[n.quickSuggestionsDelay=89]="quickSuggestionsDelay",n[n.readOnly=90]="readOnly",n[n.readOnlyMessage=91]="readOnlyMessage",n[n.renameOnType=92]="renameOnType",n[n.renderControlCharacters=93]="renderControlCharacters",n[n.renderFinalNewline=94]="renderFinalNewline",n[n.renderLineHighlight=95]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=97]="renderValidationDecorations",n[n.renderWhitespace=98]="renderWhitespace",n[n.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",n[n.roundedSelection=100]="roundedSelection",n[n.rulers=101]="rulers",n[n.scrollbar=102]="scrollbar",n[n.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=104]="scrollBeyondLastLine",n[n.scrollPredominantAxis=105]="scrollPredominantAxis",n[n.selectionClipboard=106]="selectionClipboard",n[n.selectionHighlight=107]="selectionHighlight",n[n.selectOnLineNumbers=108]="selectOnLineNumbers",n[n.showFoldingControls=109]="showFoldingControls",n[n.showUnused=110]="showUnused",n[n.snippetSuggestions=111]="snippetSuggestions",n[n.smartSelect=112]="smartSelect",n[n.smoothScrolling=113]="smoothScrolling",n[n.stickyScroll=114]="stickyScroll",n[n.stickyTabStops=115]="stickyTabStops",n[n.stopRenderingLineAfter=116]="stopRenderingLineAfter",n[n.suggest=117]="suggest",n[n.suggestFontSize=118]="suggestFontSize",n[n.suggestLineHeight=119]="suggestLineHeight",n[n.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",n[n.suggestSelection=121]="suggestSelection",n[n.tabCompletion=122]="tabCompletion",n[n.tabIndex=123]="tabIndex",n[n.unicodeHighlighting=124]="unicodeHighlighting",n[n.unusualLineTerminators=125]="unusualLineTerminators",n[n.useShadowDOM=126]="useShadowDOM",n[n.useTabStops=127]="useTabStops",n[n.wordBreak=128]="wordBreak",n[n.wordSeparators=129]="wordSeparators",n[n.wordWrap=130]="wordWrap",n[n.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=133]="wordWrapColumn",n[n.wordWrapOverride1=134]="wordWrapOverride1",n[n.wordWrapOverride2=135]="wordWrapOverride2",n[n.wrappingIndent=136]="wrappingIndent",n[n.wrappingStrategy=137]="wrappingStrategy",n[n.showDeprecated=138]="showDeprecated",n[n.inlayHints=139]="inlayHints",n[n.editorClassName=140]="editorClassName",n[n.pixelRatio=141]="pixelRatio",n[n.tabFocusMode=142]="tabFocusMode",n[n.layoutInfo=143]="layoutInfo",n[n.wrappingInfo=144]="wrappingInfo",n[n.defaultColorDecorators=145]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})($||(t.EditorOption=$={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var v;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(v||(t.EndOfLineSequence=v={}));var R;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(R||(t.GlyphMarginLane=R={}));var L;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(L||(t.IndentAction=L={}));var o;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(o||(t.InjectedTextCursorStops=o={}));var c;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(c||(t.InlayHintKind=c={}));var f;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(f||(t.InlineCompletionTriggerKind=f={}));var u;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(u||(t.KeyCode=u={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var a;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(a||(t.MarkerTag=a={}));var N;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(N||(t.MinimapPosition=N={}));var m;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(m||(t.MouseTargetType=m={}));var w;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(w||(t.OverlayWidgetPositionPreference=w={}));var M;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(M||(t.OverviewRulerLane=M={}));var p;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(p||(t.PositionAffinity=p={}));var y;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(y||(t.RenderLineNumbersType=y={}));var k;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(k||(t.RenderMinimap=k={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P||(t.ScrollType=P={}));var F;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(F||(t.ScrollbarVisibility=F={}));var I;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(I||(t.SelectionDirection=I={}));var q;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(q||(t.SignatureHelpTriggerKind=q={}));var C;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(C||(t.SymbolKind=C={}));var T;(function(n){n[n.Deprecated=1]="Deprecated"})(T||(t.SymbolTag=T={}));var j;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(j||(t.TextEditorCursorBlinkingStyle=j={}));var z;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(z||(t.TextEditorCursorStyle=z={}));var x;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(x||(t.TrackedRangeStickiness=x={}));var X;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(X||(t.WrappingIndent=X={}))}),te(ie[60],re([0,1,11,10]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zs=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new _.$Md,this.onDidChange=this.c.event,this.d=null}handleChange(d){this.c.fire({changedLanguages:d,changedColorMap:!1})}register(d,l){return this.a.set(d,l),this.handleChange([d]),(0,D.$Pc)(()=>{this.a.get(d)===l&&(this.a.delete(d),this.handleChange([d]))})}get(d){return this.a.get(d)||null}registerFactory(d,l){this.b.get(d)?.dispose();const s=new h(this,d,l);return this.b.set(d,s),(0,D.$Pc)(()=>{const g=this.b.get(d);!g||g!==s||(this.b.delete(d),g.dispose())})}async getOrCreate(d){const l=this.get(d);if(l)return l;const s=this.b.get(d);return!s||s.isResolved?null:(await s.resolve(),this.get(d))}isResolved(d){if(this.get(d))return!0;const s=this.b.get(d);return!!(!s||s.isResolved)}setColorMap(d){this.d=d,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Zs=r;class h extends D.$Rc{get isResolved(){return this.c}constructor(d,l,s){super(),this.f=d,this.g=l,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const d=await this.h.tokenizationSupport;this.c=!0,d&&!this.a&&this.B(this.f.register(this.g,d))}}}),te(ie[61],re([62,63]),function(O,t){return O.create("vs/base/common/platform",t)}),te(ie[17],re([0,1,61]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$h=t.$g=void 0,t.$g="en";let D=!1,r=!1,h=!1,E=!1,d=!1,l=!1,s=!1,g=!1,A=!1,b=!1,$,e=t.$g,v=t.$g,R,L;t.$h=typeof self=="object"?self:typeof global=="object"?global:{};let o;typeof t.$h.vscode<"u"&&typeof t.$h.vscode.process<"u"?o=t.$h.vscode.process:typeof process<"u"&&(o=process);const c=typeof o?.versions?.electron=="string",f=c&&o?.type==="renderer";if(typeof navigator=="object"&&!f)L=navigator.userAgent,D=L.indexOf("Windows")>=0,r=L.indexOf("Macintosh")>=0,g=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,h=L.indexOf("Linux")>=0,b=L?.indexOf("Mobi")>=0,l=!0,$=_.getConfiguredDefaultLocale(_.localize(0,null))||t.$g,e=$,v=navigator.language;else if(typeof o=="object"){D=o.platform==="win32",r=o.platform==="darwin",h=o.platform==="linux",E=h&&!!o.env.SNAP&&!!o.env.SNAP_REVISION,s=c,A=!!o.env.CI||!!o.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=t.$g,e=t.$g;const y=o.env.VSCODE_NLS_CONFIG;if(y)try{const k=JSON.parse(y),P=k.availableLanguages["*"];$=k.locale,v=k.osLocale,e=P||t.$g,R=k._translationsConfigFile}catch{}d=!0}else console.error("Unable to resolve platform.");var u;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(u||(t.Platform=u={}));function i(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$i=i;let a=0;r?a=1:D?a=3:h&&(a=2),t.$j=D,t.$k=r,t.$l=h,t.$m=E,t.$n=d,t.$o=s,t.$p=l,t.$q=l&&typeof t.$h.importScripts=="function",t.$r=g,t.$s=b,t.$t=A,t.$u=a,t.$v=L,t.$w=e;var N;(function(y){function k(){return t.$w}y.value=k;function P(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}y.isDefaultVariant=P;function F(){return t.$w==="en"}y.isDefault=F})(N||(t.Language=N={})),t.$x=$,t.$y=v,t.$z=R,t.$A=typeof t.$h.postMessage=="function"&&!t.$h.importScripts,t.$B=(()=>{if(t.$A){const y=[];t.$h.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let F=0,I=y.length;F<I;F++){const q=y[F];if(q.id===P.data.vscodeScheduleAsyncWork){y.splice(F,1),q.callback();return}}});let k=0;return P=>{const F=++k;y.push({id:F,callback:P}),t.$h.postMessage({vscodeScheduleAsyncWork:F},"*")}}return y=>setTimeout(y)})();var m;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(m||(t.OperatingSystem=m={})),t.OS=r||g?2:D?1:3;let w=!0,M=!1;function p(){if(!M){M=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,w=new Uint16Array(y.buffer)[0]===(2<<8)+1}return w}t.$D=p,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0)}),te(ie[64],re([0,1,17]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dc=t.$cc=t.env=t.cwd=void 0;let D;if(typeof _.$h.vscode<"u"&&typeof _.$h.vscode.process<"u"){const r=_.$h.vscode.process;D={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return _.$j?"win32":_.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=D.cwd,t.env=D.env,t.$cc=D.platform,t.$dc=D.arch}),te(ie[65],re([0,1,64]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.sep=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=void 0;const D=65,r=97,h=90,E=122,d=46,l=47,s=92,g=58,A=63;class b extends Error{constructor(a,N,m){let w;typeof N=="string"&&N.indexOf("not ")===0?(w="must not be",N=N.replace(/^not /,"")):w="must be";const M=a.indexOf(".")!==-1?"property":"argument";let p=`The "${a}" ${M} ${w} of type ${N}`;p+=`. Received type ${typeof m}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function $(i,a){if(i===null||typeof i!="object")throw new b(a,"Object",i)}function e(i,a){if(typeof i!="string")throw new b(a,"string",i)}const v=_.$cc==="win32";function R(i){return i===l||i===s}function L(i){return i===l}function o(i){return i>=D&&i<=h||i>=r&&i<=E}function c(i,a,N,m){let w="",M=0,p=-1,y=0,k=0;for(let P=0;P<=i.length;++P){if(P<i.length)k=i.charCodeAt(P);else{if(m(k))break;k=l}if(m(k)){if(!(p===P-1||y===1))if(y===2){if(w.length<2||M!==2||w.charCodeAt(w.length-1)!==d||w.charCodeAt(w.length-2)!==d){if(w.length>2){const F=w.lastIndexOf(N);F===-1?(w="",M=0):(w=w.slice(0,F),M=w.length-1-w.lastIndexOf(N)),p=P,y=0;continue}else if(w.length!==0){w="",M=0,p=P,y=0;continue}}a&&(w+=w.length>0?`${N}..`:"..",M=2)}else w.length>0?w+=`${N}${i.slice(p+1,P)}`:w=i.slice(p+1,P),M=P-p-1;p=P,y=0}else k===d&&y!==-1?++y:y=-1}return w}function f(i,a){$(a,"pathObject");const N=a.dir||a.root,m=a.base||`${a.name||""}${a.ext||""}`;return N?N===a.root?`${N}${m}`:`${N}${i}${m}`:m}t.$ec={resolve(...i){let a="",N="",m=!1;for(let w=i.length-1;w>=-1;w--){let M;if(w>=0){if(M=i[w],e(M,"path"),M.length===0)continue}else a.length===0?M=_.cwd():(M=_.env[`=${a}`]||_.cwd(),(M===void 0||M.slice(0,2).toLowerCase()!==a.toLowerCase()&&M.charCodeAt(2)===s)&&(M=`${a}\\`));const p=M.length;let y=0,k="",P=!1;const F=M.charCodeAt(0);if(p===1)R(F)&&(y=1,P=!0);else if(R(F))if(P=!0,R(M.charCodeAt(1))){let I=2,q=I;for(;I<p&&!R(M.charCodeAt(I));)I++;if(I<p&&I!==q){const C=M.slice(q,I);for(q=I;I<p&&R(M.charCodeAt(I));)I++;if(I<p&&I!==q){for(q=I;I<p&&!R(M.charCodeAt(I));)I++;(I===p||I!==q)&&(k=`\\\\${C}\\${M.slice(q,I)}`,y=I)}}}else y=1;else o(F)&&M.charCodeAt(1)===g&&(k=M.slice(0,2),y=2,p>2&&R(M.charCodeAt(2))&&(P=!0,y=3));if(k.length>0)if(a.length>0){if(k.toLowerCase()!==a.toLowerCase())continue}else a=k;if(m){if(a.length>0)break}else if(N=`${M.slice(y)}\\${N}`,m=P,P&&a.length>0)break}return N=c(N,!m,"\\",R),m?`${a}\\${N}`:`${a}${N}`||"."},normalize(i){e(i,"path");const a=i.length;if(a===0)return".";let N=0,m,w=!1;const M=i.charCodeAt(0);if(a===1)return L(M)?"\\":i;if(R(M))if(w=!0,R(i.charCodeAt(1))){let y=2,k=y;for(;y<a&&!R(i.charCodeAt(y));)y++;if(y<a&&y!==k){const P=i.slice(k,y);for(k=y;y<a&&R(i.charCodeAt(y));)y++;if(y<a&&y!==k){for(k=y;y<a&&!R(i.charCodeAt(y));)y++;if(y===a)return`\\\\${P}\\${i.slice(k)}\\`;y!==k&&(m=`\\\\${P}\\${i.slice(k,y)}`,N=y)}}}else N=1;else o(M)&&i.charCodeAt(1)===g&&(m=i.slice(0,2),N=2,a>2&&R(i.charCodeAt(2))&&(w=!0,N=3));let p=N<a?c(i.slice(N),!w,"\\",R):"";return p.length===0&&!w&&(p="."),p.length>0&&R(i.charCodeAt(a-1))&&(p+="\\"),m===void 0?w?`\\${p}`:p:w?`${m}\\${p}`:`${m}${p}`},isAbsolute(i){e(i,"path");const a=i.length;if(a===0)return!1;const N=i.charCodeAt(0);return R(N)||a>2&&o(N)&&i.charCodeAt(1)===g&&R(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,N;for(let M=0;M<i.length;++M){const p=i[M];e(p,"path"),p.length>0&&(a===void 0?a=N=p:a+=`\\${p}`)}if(a===void 0)return".";let m=!0,w=0;if(typeof N=="string"&&R(N.charCodeAt(0))){++w;const M=N.length;M>1&&R(N.charCodeAt(1))&&(++w,M>2&&(R(N.charCodeAt(2))?++w:m=!1))}if(m){for(;w<a.length&&R(a.charCodeAt(w));)w++;w>=2&&(a=`\\${a.slice(w)}`)}return t.$ec.normalize(a)},relative(i,a){if(e(i,"from"),e(a,"to"),i===a)return"";const N=t.$ec.resolve(i),m=t.$ec.resolve(a);if(N===m||(i=N.toLowerCase(),a=m.toLowerCase(),i===a))return"";let w=0;for(;w<i.length&&i.charCodeAt(w)===s;)w++;let M=i.length;for(;M-1>w&&i.charCodeAt(M-1)===s;)M--;const p=M-w;let y=0;for(;y<a.length&&a.charCodeAt(y)===s;)y++;let k=a.length;for(;k-1>y&&a.charCodeAt(k-1)===s;)k--;const P=k-y,F=p<P?p:P;let I=-1,q=0;for(;q<F;q++){const T=i.charCodeAt(w+q);if(T!==a.charCodeAt(y+q))break;T===s&&(I=q)}if(q!==F){if(I===-1)return m}else{if(P>F){if(a.charCodeAt(y+q)===s)return m.slice(y+q+1);if(q===2)return m.slice(y+q)}p>F&&(i.charCodeAt(w+q)===s?I=q:q===2&&(I=3)),I===-1&&(I=0)}let C="";for(q=w+I+1;q<=M;++q)(q===M||i.charCodeAt(q)===s)&&(C+=C.length===0?"..":"\\..");return y+=I,C.length>0?`${C}${m.slice(y,k)}`:(m.charCodeAt(y)===s&&++y,m.slice(y,k))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=t.$ec.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===s){if(a.charCodeAt(1)===s){const N=a.charCodeAt(2);if(N!==A&&N!==d)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(o(a.charCodeAt(0))&&a.charCodeAt(1)===g&&a.charCodeAt(2)===s)return`\\\\?\\${a}`;return i},dirname(i){e(i,"path");const a=i.length;if(a===0)return".";let N=-1,m=0;const w=i.charCodeAt(0);if(a===1)return R(w)?i:".";if(R(w)){if(N=m=1,R(i.charCodeAt(1))){let y=2,k=y;for(;y<a&&!R(i.charCodeAt(y));)y++;if(y<a&&y!==k){for(k=y;y<a&&R(i.charCodeAt(y));)y++;if(y<a&&y!==k){for(k=y;y<a&&!R(i.charCodeAt(y));)y++;if(y===a)return i;y!==k&&(N=m=y+1)}}}}else o(w)&&i.charCodeAt(1)===g&&(N=a>2&&R(i.charCodeAt(2))?3:2,m=N);let M=-1,p=!0;for(let y=a-1;y>=m;--y)if(R(i.charCodeAt(y))){if(!p){M=y;break}}else p=!1;if(M===-1){if(N===-1)return".";M=N}return i.slice(0,M)},basename(i,a){a!==void 0&&e(a,"ext"),e(i,"path");let N=0,m=-1,w=!0,M;if(i.length>=2&&o(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(N=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let p=a.length-1,y=-1;for(M=i.length-1;M>=N;--M){const k=i.charCodeAt(M);if(R(k)){if(!w){N=M+1;break}}else y===-1&&(w=!1,y=M+1),p>=0&&(k===a.charCodeAt(p)?--p===-1&&(m=M):(p=-1,m=y))}return N===m?m=y:m===-1&&(m=i.length),i.slice(N,m)}for(M=i.length-1;M>=N;--M)if(R(i.charCodeAt(M))){if(!w){N=M+1;break}}else m===-1&&(w=!1,m=M+1);return m===-1?"":i.slice(N,m)},extname(i){e(i,"path");let a=0,N=-1,m=0,w=-1,M=!0,p=0;i.length>=2&&i.charCodeAt(1)===g&&o(i.charCodeAt(0))&&(a=m=2);for(let y=i.length-1;y>=a;--y){const k=i.charCodeAt(y);if(R(k)){if(!M){m=y+1;break}continue}w===-1&&(M=!1,w=y+1),k===d?N===-1?N=y:p!==1&&(p=1):N!==-1&&(p=-1)}return N===-1||w===-1||p===0||p===1&&N===w-1&&N===m+1?"":i.slice(N,w)},format:f.bind(null,"\\"),parse(i){e(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const N=i.length;let m=0,w=i.charCodeAt(0);if(N===1)return R(w)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(R(w)){if(m=1,R(i.charCodeAt(1))){let I=2,q=I;for(;I<N&&!R(i.charCodeAt(I));)I++;if(I<N&&I!==q){for(q=I;I<N&&R(i.charCodeAt(I));)I++;if(I<N&&I!==q){for(q=I;I<N&&!R(i.charCodeAt(I));)I++;I===N?m=I:I!==q&&(m=I+1)}}}}else if(o(w)&&i.charCodeAt(1)===g){if(N<=2)return a.root=a.dir=i,a;if(m=2,R(i.charCodeAt(2))){if(N===3)return a.root=a.dir=i,a;m=3}}m>0&&(a.root=i.slice(0,m));let M=-1,p=m,y=-1,k=!0,P=i.length-1,F=0;for(;P>=m;--P){if(w=i.charCodeAt(P),R(w)){if(!k){p=P+1;break}continue}y===-1&&(k=!1,y=P+1),w===d?M===-1?M=P:F!==1&&(F=1):M!==-1&&(F=-1)}return y!==-1&&(M===-1||F===0||F===1&&M===y-1&&M===p+1?a.base=a.name=i.slice(p,y):(a.name=i.slice(p,M),a.base=i.slice(p,y),a.ext=i.slice(M,y))),p>0&&p!==m?a.dir=i.slice(0,p-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(v){const i=/\\/g;return()=>{const a=_.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>_.cwd()})();t.$fc={resolve(...i){let a="",N=!1;for(let m=i.length-1;m>=-1&&!N;m--){const w=m>=0?i[m]:u();e(w,"path"),w.length!==0&&(a=`${w}/${a}`,N=w.charCodeAt(0)===l)}return a=c(a,!N,"/",L),N?`/${a}`:a.length>0?a:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===l,N=i.charCodeAt(i.length-1)===l;return i=c(i,!a,"/",L),i.length===0?a?"/":N?"./":".":(N&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===l},join(...i){if(i.length===0)return".";let a;for(let N=0;N<i.length;++N){const m=i[N];e(m,"path"),m.length>0&&(a===void 0?a=m:a+=`/${m}`)}return a===void 0?".":t.$fc.normalize(a)},relative(i,a){if(e(i,"from"),e(a,"to"),i===a||(i=t.$fc.resolve(i),a=t.$fc.resolve(a),i===a))return"";const N=1,m=i.length,w=m-N,M=1,p=a.length-M,y=w<p?w:p;let k=-1,P=0;for(;P<y;P++){const I=i.charCodeAt(N+P);if(I!==a.charCodeAt(M+P))break;I===l&&(k=P)}if(P===y)if(p>y){if(a.charCodeAt(M+P)===l)return a.slice(M+P+1);if(P===0)return a.slice(M+P)}else w>y&&(i.charCodeAt(N+P)===l?k=P:P===0&&(k=0));let F="";for(P=N+k+1;P<=m;++P)(P===m||i.charCodeAt(P)===l)&&(F+=F.length===0?"..":"/..");return`${F}${a.slice(M+k)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===l;let N=-1,m=!0;for(let w=i.length-1;w>=1;--w)if(i.charCodeAt(w)===l){if(!m){N=w;break}}else m=!1;return N===-1?a?"/":".":a&&N===1?"//":i.slice(0,N)},basename(i,a){a!==void 0&&e(a,"ext"),e(i,"path");let N=0,m=-1,w=!0,M;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let p=a.length-1,y=-1;for(M=i.length-1;M>=0;--M){const k=i.charCodeAt(M);if(k===l){if(!w){N=M+1;break}}else y===-1&&(w=!1,y=M+1),p>=0&&(k===a.charCodeAt(p)?--p===-1&&(m=M):(p=-1,m=y))}return N===m?m=y:m===-1&&(m=i.length),i.slice(N,m)}for(M=i.length-1;M>=0;--M)if(i.charCodeAt(M)===l){if(!w){N=M+1;break}}else m===-1&&(w=!1,m=M+1);return m===-1?"":i.slice(N,m)},extname(i){e(i,"path");let a=-1,N=0,m=-1,w=!0,M=0;for(let p=i.length-1;p>=0;--p){const y=i.charCodeAt(p);if(y===l){if(!w){N=p+1;break}continue}m===-1&&(w=!1,m=p+1),y===d?a===-1?a=p:M!==1&&(M=1):a!==-1&&(M=-1)}return a===-1||m===-1||M===0||M===1&&a===m-1&&a===N+1?"":i.slice(a,m)},format:f.bind(null,"/"),parse(i){e(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const N=i.charCodeAt(0)===l;let m;N?(a.root="/",m=1):m=0;let w=-1,M=0,p=-1,y=!0,k=i.length-1,P=0;for(;k>=m;--k){const F=i.charCodeAt(k);if(F===l){if(!y){M=k+1;break}continue}p===-1&&(y=!1,p=k+1),F===d?w===-1?w=k:P!==1&&(P=1):w!==-1&&(P=-1)}if(p!==-1){const F=M===0&&N?1:M;w===-1||P===0||P===1&&w===p-1&&w===M+1?a.base=a.name=i.slice(F,p):(a.name=i.slice(F,w),a.base=i.slice(F,p),a.ext=i.slice(w,p))}return M>0?a.dir=i.slice(0,M-1):N&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.$fc.win32=t.$ec.win32=t.$ec,t.$fc.posix=t.$ec.posix=t.$fc,t.$gc=v?t.$ec.normalize:t.$fc.normalize,t.$hc=v?t.$ec.isAbsolute:t.$fc.isAbsolute,t.$ic=v?t.$ec.join:t.$fc.join,t.$jc=v?t.$ec.resolve:t.$fc.resolve,t.$kc=v?t.$ec.relative:t.$fc.relative,t.$lc=v?t.$ec.dirname:t.$fc.dirname,t.$mc=v?t.$ec.basename:t.$fc.basename,t.$nc=v?t.$ec.extname:t.$fc.extname,t.$oc=v?t.$ec.format:t.$fc.format,t.$pc=v?t.$ec.parse:t.$fc.parse,t.$qc=v?t.$ec.toNamespacedPath:t.$fc.toNamespacedPath,t.sep=v?t.$ec.sep:t.$fc.sep,t.$sc=v?t.$ec.delimiter:t.$fc.delimiter}),te(ie[18],re([0,1,65,17]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vc=t.$uc=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,h=/^\//,E=/^\/\//;function d(m,w){if(!m.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!r.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!h.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(m,w){return!m&&!w?"file":m}function s(m,w){switch(m){case"https":case"http":case"file":w?w[0]!==A&&(w=A+w):w=A;break}return w}const g="",A="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class ${static isUri(w){return w instanceof $?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,M,p,y,k,P=!1){typeof w=="object"?(this.scheme=w.scheme||g,this.authority=w.authority||g,this.path=w.path||g,this.query=w.query||g,this.fragment=w.fragment||g):(this.scheme=l(w,P),this.authority=M||g,this.path=s(this.scheme,p||g),this.query=y||g,this.fragment=k||g,d(this,P))}get fsPath(){return f(this,!1)}with(w){if(!w)return this;let{scheme:M,authority:p,path:y,query:k,fragment:P}=w;return M===void 0?M=this.scheme:M===null&&(M=g),p===void 0?p=this.authority:p===null&&(p=g),y===void 0?y=this.path:y===null&&(y=g),k===void 0?k=this.query:k===null&&(k=g),P===void 0?P=this.fragment:P===null&&(P=g),M===this.scheme&&p===this.authority&&y===this.path&&k===this.query&&P===this.fragment?this:new R(M,p,y,k,P)}static parse(w,M=!1){const p=b.exec(w);return p?new R(p[2]||g,N(p[4]||g),N(p[5]||g),N(p[7]||g),N(p[9]||g),M):new R(g,g,g,g,g)}static file(w){let M=g;if(D.$j&&(w=w.replace(/\\/g,A)),w[0]===A&&w[1]===A){const p=w.indexOf(A,2);p===-1?(M=w.substring(2),w=A):(M=w.substring(2,p),w=w.substring(p)||A)}return new R("file",M,w,g,g)}static from(w,M){return new R(w.scheme,w.authority,w.path,w.query,w.fragment,M)}static joinPath(w,...M){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return D.$j&&w.scheme==="file"?p=$.file(_.$ec.join(f(w,!0),...M)).path:p=_.$fc.join(w.path,...M),w.with({path:p})}toString(w=!1){return u(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof $)return w;{const M=new R(w);return M._formatted=w.external??null,M._fsPath=w._sep===v?w.fsPath??null:null,M}}else return w}}t.URI=$;function e(m){return!m||typeof m!="object"?!1:typeof m.scheme=="string"&&(typeof m.authority=="string"||typeof m.authority>"u")&&(typeof m.path=="string"||typeof m.path>"u")&&(typeof m.query=="string"||typeof m.query>"u")&&(typeof m.fragment=="string"||typeof m.fragment>"u")}t.$uc=e;const v=D.$j?1:void 0;class R extends ${constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(w=!1){return w?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=v),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const L={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function o(m,w,M){let p,y=-1;for(let k=0;k<m.length;k++){const P=m.charCodeAt(k);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||w&&P===47||M&&P===91||M&&P===93||M&&P===58)y!==-1&&(p+=encodeURIComponent(m.substring(y,k)),y=-1),p!==void 0&&(p+=m.charAt(k));else{p===void 0&&(p=m.substr(0,k));const F=L[P];F!==void 0?(y!==-1&&(p+=encodeURIComponent(m.substring(y,k)),y=-1),p+=F):y===-1&&(y=k)}}return y!==-1&&(p+=encodeURIComponent(m.substring(y))),p!==void 0?p:m}function c(m){let w;for(let M=0;M<m.length;M++){const p=m.charCodeAt(M);p===35||p===63?(w===void 0&&(w=m.substr(0,M)),w+=L[p]):w!==void 0&&(w+=m[M])}return w!==void 0?w:m}function f(m,w){let M;return m.authority&&m.path.length>1&&m.scheme==="file"?M=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===47&&(m.path.charCodeAt(1)>=65&&m.path.charCodeAt(1)<=90||m.path.charCodeAt(1)>=97&&m.path.charCodeAt(1)<=122)&&m.path.charCodeAt(2)===58?w?M=m.path.substr(1):M=m.path[1].toLowerCase()+m.path.substr(2):M=m.path,D.$j&&(M=M.replace(/\//g,"\\")),M}t.$vc=f;function u(m,w){const M=w?c:o;let p="",{scheme:y,authority:k,path:P,query:F,fragment:I}=m;if(y&&(p+=y,p+=":"),(k||y==="file")&&(p+=A,p+=A),k){let q=k.indexOf("@");if(q!==-1){const C=k.substr(0,q);k=k.substr(q+1),q=C.lastIndexOf(":"),q===-1?p+=M(C,!1,!1):(p+=M(C.substr(0,q),!1,!1),p+=":",p+=M(C.substr(q+1),!1,!0)),p+="@"}k=k.toLowerCase(),q=k.lastIndexOf(":"),q===-1?p+=M(k,!1,!0):(p+=M(k.substr(0,q),!1,!0),p+=k.substr(q))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const q=P.charCodeAt(1);q>=65&&q<=90&&(P=`/${String.fromCharCode(q+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const q=P.charCodeAt(0);q>=65&&q<=90&&(P=`${String.fromCharCode(q+32)}:${P.substr(2)}`)}p+=M(P,!0,!1)}return F&&(p+="?",p+=M(F,!1,!1)),I&&(p+="#",p+=w?I:o(I,!1,!1)),p}function i(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+i(m.substr(3)):m}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(m){return m.match(a)?m.replace(a,w=>i(w)):m}}),te(ie[70],re([0,1,3,11,10,14,17,7]),function(O,t,_,D,r,h,E,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const l="$initialize";let s=!1;function g(N){E.$p&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(N.message))}t.logOnceWebWorkerWarning=g;var A;(function(N){N[N.Request=0]="Request",N[N.Reply=1]="Reply",N[N.SubscribeEvent=2]="SubscribeEvent",N[N.Event=3]="Event",N[N.UnsubscribeEvent=4]="UnsubscribeEvent"})(A||(A={}));class b{constructor(m,w,M,p){this.vsWorker=m,this.req=w,this.method=M,this.args=p,this.type=0}}class ${constructor(m,w,M,p){this.vsWorker=m,this.seq=w,this.res=M,this.err=p,this.type=1}}class e{constructor(m,w,M,p){this.vsWorker=m,this.req=w,this.eventName=M,this.arg=p,this.type=2}}class v{constructor(m,w,M){this.vsWorker=m,this.req=w,this.event=M,this.type=3}}class R{constructor(m,w){this.vsWorker=m,this.req=w,this.type=4}}class L{constructor(m){this.a=-1,this.g=m,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(m){this.a=m}sendMessage(m,w){const M=String(++this.b);return new Promise((p,y)=>{this.c[M]={resolve:p,reject:y},this.o(new b(this.a,M,m,w))})}listen(m,w){let M=null;const p=new D.$Md({onWillAddFirstListener:()=>{M=String(++this.b),this.d.set(M,p),this.o(new e(this.a,M,m,w))},onDidRemoveLastListener:()=>{this.d.delete(M),this.o(new R(this.a,M)),M=null}});return p.event}handleMessage(m){!m||!m.vsWorker||this.a!==-1&&m.vsWorker!==this.a||this.h(m)}h(m){switch(m.type){case 1:return this.j(m);case 0:return this.k(m);case 2:return this.l(m);case 3:return this.m(m);case 4:return this.n(m)}}j(m){if(!this.c[m.seq]){console.warn("Got reply to unknown seq");return}const w=this.c[m.seq];if(delete this.c[m.seq],m.err){let M=m.err;m.err.$isError&&(M=new Error,M.name=m.err.name,M.message=m.err.message,M.stack=m.err.stack),w.reject(M);return}w.resolve(m.res)}k(m){const w=m.req;this.g.handleMessage(m.method,m.args).then(p=>{this.o(new $(this.a,w,p,void 0))},p=>{p.detail instanceof Error&&(p.detail=(0,_.$2)(p.detail)),this.o(new $(this.a,w,void 0,(0,_.$2)(p)))})}l(m){const w=m.req,M=this.g.handleEvent(m.eventName,m.arg)(p=>{this.o(new v(this.a,w,p))});this.f.set(w,M)}m(m){if(!this.d.has(m.req)){console.warn("Got event for unknown req");return}this.d.get(m.req).fire(m.event)}n(m){if(!this.f.has(m.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(m.req).dispose(),this.f.delete(m.req)}o(m){const w=[];if(m.type===0)for(let M=0;M<m.args.length;M++)m.args[M]instanceof ArrayBuffer&&w.push(m.args[M]);else m.type===1&&m.res instanceof ArrayBuffer&&w.push(m.res);this.g.sendMessage(m,w)}}class o extends r.$Rc{constructor(m,w,M){super();let p=null;this.a=this.B(m.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{p?.(q)})),this.c=new L({sendMessage:(q,C)=>{this.a.postMessage(q,C)},handleMessage:(q,C)=>{if(typeof M[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(M[q].apply(M,C))}catch(T){return Promise.reject(T)}},handleEvent:(q,C)=>{if(f(q)){const T=M[q].call(M,C);if(typeof T!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return T}if(c(q)){const T=M[q];if(typeof T!="function")throw new Error(`Missing event ${q} on main thread host.`);return T}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let y=null;const k=globalThis.require;typeof k<"u"&&typeof k.getConfig=="function"?y=k.getConfig():typeof globalThis.requirejs<"u"&&(y=globalThis.requirejs.s.contexts._.config);const P=(0,h.$_m)(M);this.b=this.c.sendMessage(l,[this.a.getId(),JSON.parse(JSON.stringify(y)),w,P]);const F=(q,C)=>this.g(q,C),I=(q,C)=>this.c.listen(q,C);this.f=new Promise((q,C)=>{p=C,this.b.then(T=>{q(u(T,F,I))},T=>{C(T),this.h("Worker failed to load "+w,T)})})}getProxyObject(){return this.f}g(m,w){return new Promise((M,p)=>{this.b.then(()=>{this.c.sendMessage(m,w).then(M,p)},p)})}h(m,w){console.error(m),console.info(w)}}t.SimpleWorkerClient=o;function c(N){return N[0]==="o"&&N[1]==="n"&&d.$Ze(N.charCodeAt(2))}function f(N){return/^onDynamic/.test(N)&&d.$Ze(N.charCodeAt(9))}function u(N,m,w){const M=k=>function(){const P=Array.prototype.slice.call(arguments,0);return m(k,P)},p=k=>function(P){return w(k,P)},y={};for(const k of N){if(f(k)){y[k]=p(k);continue}if(c(k)){y[k]=w(k,void 0);continue}y[k]=M(k)}return y}class i{constructor(m,w){this.a=w,this.b=null,this.c=new L({sendMessage:(M,p)=>{m(M,p)},handleMessage:(M,p)=>this.d(M,p),handleEvent:(M,p)=>this.f(M,p)})}onmessage(m){this.c.handleMessage(m)}d(m,w){if(m===l)return this.g(w[0],w[1],w[2],w[3]);if(!this.b||typeof this.b[m]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+m));try{return Promise.resolve(this.b[m].apply(this.b,w))}catch(M){return Promise.reject(M)}}f(m,w){if(!this.b)throw new Error("Missing requestHandler");if(f(m)){const M=this.b[m].call(this.b,w);if(typeof M!="function")throw new Error(`Missing dynamic event ${m} on request handler.`);return M}if(c(m)){const M=this.b[m];if(typeof M!="function")throw new Error(`Missing event ${m} on request handler.`);return M}throw new Error(`Malformed event name ${m}`)}g(m,w,M,p){this.c.setWorkerId(m);const P=u(p,(F,I)=>this.c.sendMessage(F,I),(F,I)=>this.c.listen(F,I));return this.a?(this.b=this.a(P),Promise.resolve((0,h.$_m)(this.b))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy!==void 0&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((F,I)=>{(globalThis.require||O)([M],C=>{if(this.b=C.create(P),!this.b){I(new Error("No RequestHandler!"));return}F((0,h.$_m)(this.b))},I)}))}}t.SimpleWorkerServer=i;function a(N){return new i(N,null)}t.create=a}),te(ie[66],re([62,63]),function(O,t){return O.create("vs/editor/common/languages",t)}),te(ie[67],re([0,1,41,18,42,2,60,66]),function(O,t,_,D,r,h,E,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$ft=t.$et=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$dt=t.$ct=t.SymbolKinds=t.SymbolTag=t.$bt=t.$at=t.SymbolKind=t.$_s=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$$s=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$0s=t.$9s=t.$8s=void 0;class l{constructor(j,z,x){this.offset=j,this.type=z,this.language=x,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$8s=l;class s{constructor(j,z){this.tokens=j,this.endState=z,this._tokenizationResultBrand=void 0}}t.$9s=s;class g{constructor(j,z){this.tokens=j,this.endState=z,this._encodedTokenizationResultBrand=void 0}}t.$0s=g;var A;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(A||(t.CompletionItemKind=A={}));var b;(function(T){const j=new Map;j.set(0,_.$Sj.symbolMethod),j.set(1,_.$Sj.symbolFunction),j.set(2,_.$Sj.symbolConstructor),j.set(3,_.$Sj.symbolField),j.set(4,_.$Sj.symbolVariable),j.set(5,_.$Sj.symbolClass),j.set(6,_.$Sj.symbolStruct),j.set(7,_.$Sj.symbolInterface),j.set(8,_.$Sj.symbolModule),j.set(9,_.$Sj.symbolProperty),j.set(10,_.$Sj.symbolEvent),j.set(11,_.$Sj.symbolOperator),j.set(12,_.$Sj.symbolUnit),j.set(13,_.$Sj.symbolValue),j.set(15,_.$Sj.symbolEnum),j.set(14,_.$Sj.symbolConstant),j.set(15,_.$Sj.symbolEnum),j.set(16,_.$Sj.symbolEnumMember),j.set(17,_.$Sj.symbolKeyword),j.set(27,_.$Sj.symbolSnippet),j.set(18,_.$Sj.symbolText),j.set(19,_.$Sj.symbolColor),j.set(20,_.$Sj.symbolFile),j.set(21,_.$Sj.symbolReference),j.set(22,_.$Sj.symbolCustomColor),j.set(23,_.$Sj.symbolFolder),j.set(24,_.$Sj.symbolTypeParameter),j.set(25,_.$Sj.account),j.set(26,_.$Sj.issues);function z(n){let ne=j.get(n);return ne||(console.info("No codicon found for CompletionItemKind "+n),ne=_.$Sj.symbolProperty),ne}T.toIcon=z;const x=new Map;x.set("method",0),x.set("function",1),x.set("constructor",2),x.set("field",3),x.set("variable",4),x.set("class",5),x.set("struct",6),x.set("interface",7),x.set("module",8),x.set("property",9),x.set("event",10),x.set("operator",11),x.set("unit",12),x.set("value",13),x.set("constant",14),x.set("enum",15),x.set("enum-member",16),x.set("enumMember",16),x.set("keyword",17),x.set("snippet",27),x.set("text",18),x.set("color",19),x.set("file",20),x.set("reference",21),x.set("customcolor",22),x.set("folder",23),x.set("type-parameter",24),x.set("typeParameter",24),x.set("account",25),x.set("issue",26);function X(n,ne){let ce=x.get(n);return typeof ce>"u"&&!ne&&(ce=9),ce}T.fromString=X})(b||(t.CompletionItemKinds=b={}));var $;(function(T){T[T.Deprecated=1]="Deprecated"})($||(t.CompletionItemTag=$={}));var e;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var v;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v||(t.CompletionTriggerKind=v={}));var R;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(R||(t.InlineCompletionTriggerKind=R={}));class L{constructor(j,z,x,X){this.range=j,this.text=z,this.completionKind=x,this.isSnippetText=X}equals(j){return h.$os.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}t.$$s=L;var o;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(o||(t.CodeActionTriggerType=o={}));var c;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(c||(t.SignatureHelpTriggerKind=c={}));var f;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(f||(t.DocumentHighlightKind=f={}));function u(T){return T&&D.URI.isUri(T.uri)&&h.$os.isIRange(T.range)&&(h.$os.isIRange(T.originSelectionRange)||h.$os.isIRange(T.targetSelectionRange))}t.$_s=u;var i;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.$at={[17]:(0,d.localize)(0,null),[16]:(0,d.localize)(1,null),[4]:(0,d.localize)(2,null),[13]:(0,d.localize)(3,null),[8]:(0,d.localize)(4,null),[9]:(0,d.localize)(5,null),[21]:(0,d.localize)(6,null),[23]:(0,d.localize)(7,null),[7]:(0,d.localize)(8,null),[0]:(0,d.localize)(9,null),[11]:(0,d.localize)(10,null),[10]:(0,d.localize)(11,null),[19]:(0,d.localize)(12,null),[5]:(0,d.localize)(13,null),[1]:(0,d.localize)(14,null),[2]:(0,d.localize)(15,null),[20]:(0,d.localize)(16,null),[15]:(0,d.localize)(17,null),[18]:(0,d.localize)(18,null),[24]:(0,d.localize)(19,null),[3]:(0,d.localize)(20,null),[6]:(0,d.localize)(21,null),[14]:(0,d.localize)(22,null),[22]:(0,d.localize)(23,null),[25]:(0,d.localize)(24,null),[12]:(0,d.localize)(25,null)};function a(T,j){return(0,d.localize)(26,null,T,t.$at[j])}t.$bt=a;var N;(function(T){T[T.Deprecated=1]="Deprecated"})(N||(t.SymbolTag=N={}));var m;(function(T){const j=new Map;j.set(0,_.$Sj.symbolFile),j.set(1,_.$Sj.symbolModule),j.set(2,_.$Sj.symbolNamespace),j.set(3,_.$Sj.symbolPackage),j.set(4,_.$Sj.symbolClass),j.set(5,_.$Sj.symbolMethod),j.set(6,_.$Sj.symbolProperty),j.set(7,_.$Sj.symbolField),j.set(8,_.$Sj.symbolConstructor),j.set(9,_.$Sj.symbolEnum),j.set(10,_.$Sj.symbolInterface),j.set(11,_.$Sj.symbolFunction),j.set(12,_.$Sj.symbolVariable),j.set(13,_.$Sj.symbolConstant),j.set(14,_.$Sj.symbolString),j.set(15,_.$Sj.symbolNumber),j.set(16,_.$Sj.symbolBoolean),j.set(17,_.$Sj.symbolArray),j.set(18,_.$Sj.symbolObject),j.set(19,_.$Sj.symbolKey),j.set(20,_.$Sj.symbolNull),j.set(21,_.$Sj.symbolEnumMember),j.set(22,_.$Sj.symbolStruct),j.set(23,_.$Sj.symbolEvent),j.set(24,_.$Sj.symbolOperator),j.set(25,_.$Sj.symbolTypeParameter);function z(x){let X=j.get(x);return X||(console.info("No codicon found for SymbolKind "+x),X=_.$Sj.symbolProperty),X}T.toIcon=z})(m||(t.SymbolKinds=m={}));class w{static asEditOperation(j){return r.$ps.replace(h.$os.lift(j.range),j.text)}}t.$ct=w;class M{static{this.Comment=new M("comment")}static{this.Imports=new M("imports")}static{this.Region=new M("region")}static fromValue(j){switch(j){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(j)}constructor(j){this.value=j}}t.$dt=M;var p;(function(T){function j(z){return!z||typeof z!="object"?!1:typeof z.id=="string"&&typeof z.title=="string"}T.is=j})(p||(t.Command=p={}));var y;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(y||(t.CommentThreadCollapsibleState=y={}));var k;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(k||(t.CommentThreadState=k={}));var P;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(P||(t.CommentMode=P={}));var F;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(F||(t.CommentState=F={}));var I;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(I||(t.InlayHintKind=I={}));class q{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$et=q,t.$ft=new E.$Zs;var C;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(C||(t.ExternalUriOpenerPriority=C={}))}),te(ie[68],re([0,1,24,11,37,18,5,2,43,67,59]),function(O,t,_,D,r,h,E,d,l,s,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VY=t.$UY=void 0;class A{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,v){return(0,r.$Bq)(e,v)}}t.$UY=A;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:_.$Wd,Emitter:D.$Md,KeyCode:g.KeyCode,KeyMod:A,Position:E.$ns,Range:d.$os,Selection:l.$qs,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:h.URI,Token:s.$8s}}t.$VY=b}),te(ie[71],re([0,1,25,18,5,2,56,29,52,53,68,23,58,33,50,14,3,51]),function(O,t,_,D,r,h,E,d,l,s,g,A,b,$,e,v,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class o extends E.$Qu{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(i){const a=[];for(let N=0;N<this.f.length;N++){const m=this.f[N],w=this.offsetAt(new r.$ns(N+1,1)),M=m.matchAll(i);for(const p of M)(p.index||p.index===0)&&(p.index=p.index+w),a.push(p)}return a}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(i){return this.f[i-1]}getWordAtPosition(i,a){const N=(0,d.$4r)(i.column,(0,d.$2r)(a),this.f[i.lineNumber-1],0);return N?new h.$os(i.lineNumber,N.startColumn,i.lineNumber,N.endColumn):null}getWordUntilPosition(i,a){const N=this.getWordAtPosition(i,a);return N?{word:this.f[i.lineNumber-1].substring(N.startColumn-1,i.column-1),startColumn:N.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const a=this.f,N=this.q.bind(this);let m=0,w="",M=0,p=[];return{*[Symbol.iterator](){for(;;)if(M<p.length){const y=w.substring(p[M].start,p[M].end);M+=1,yield y}else if(m<a.length)w=a[m],p=N(w,i),M=0,m+=1;else break}}}getLineWords(i,a){const N=this.f[i-1],m=this.q(N,a),w=[];for(const M of m)w.push({word:N.substring(M.start,M.end),startColumn:M.start+1,endColumn:M.end+1});return w}q(i,a){const N=[];let m;for(a.lastIndex=0;(m=a.exec(i))&&m[0].length!==0;)N.push({start:m.index,end:m.index+m[0].length});return N}getValueInRange(i){if(i=this.r(i),i.startLineNumber===i.endLineNumber)return this.f[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const a=this.g,N=i.startLineNumber-1,m=i.endLineNumber-1,w=[];w.push(this.f[N].substring(i.startColumn-1));for(let M=N+1;M<m;M++)w.push(this.f[M]);return w.push(this.f[m].substring(0,i.endColumn-1)),w.join(a)}offsetAt(i){return i=this.s(i),this.l(),this.j.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this.l();const a=this.j.getIndexOf(i),N=this.f[a.index].length;return{lineNumber:1+a.index,column:1+Math.min(a.remainder,N)}}r(i){const a=this.s({lineNumber:i.startLineNumber,column:i.startColumn}),N=this.s({lineNumber:i.endLineNumber,column:i.endColumn});return a.lineNumber!==i.startLineNumber||a.column!==i.startColumn||N.lineNumber!==i.endLineNumber||N.column!==i.endColumn?{startLineNumber:a.lineNumber,startColumn:a.column,endLineNumber:N.lineNumber,endColumn:N.column}:i}s(i){if(!r.$ns.isIPosition(i))throw new Error("bad position");let{lineNumber:a,column:N}=i,m=!1;if(a<1)a=1,N=1,m=!0;else if(a>this.f.length)a=this.f.length,N=this.f[a-1].length+1,m=!0;else{const w=this.f[a-1].length+1;N<1?(N=1,m=!0):N>w&&(N=w,m=!0)}return m?{lineNumber:a,column:N}:i}}class c{constructor(i,a){this.d=i,this.f=Object.create(null),this.g=a,this.h=null}dispose(){this.f=Object.create(null)}j(i){return this.f[i]}k(){const i=[];return Object.keys(this.f).forEach(a=>i.push(this.f[a])),i}acceptNewModel(i){this.f[i.url]=new o(D.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,a){if(!this.f[i])return;this.f[i].onEvents(a)}acceptRemovedModel(i){this.f[i]&&delete this.f[i]}async computeUnicodeHighlights(i,a,N){const m=this.j(i);return m?b.$PY.computeUnicodeHighlights(m,a,N):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,a,N,m){const w=this.j(i),M=this.j(a);return!w||!M?null:c.l(w,M,N,m)}static l(i,a,N,m){const w=m==="advanced"?e.$fZ.getDefault():e.$fZ.getLegacy(),M=i.getLinesContent(),p=a.getLinesContent(),y=w.computeDiff(M,p,N),k=y.changes.length>0?!1:this.n(i,a);function P(F){return F.map(I=>[I.original.startLineNumber,I.original.endLineNumberExclusive,I.modified.startLineNumber,I.modified.endLineNumberExclusive,I.innerChanges?.map(q=>[q.originalRange.startLineNumber,q.originalRange.startColumn,q.originalRange.endLineNumber,q.originalRange.endColumn,q.modifiedRange.startLineNumber,q.modifiedRange.startColumn,q.modifiedRange.endLineNumber,q.modifiedRange.endColumn])])}return{identical:k,quitEarly:y.hitTimeout,changes:P(y.changes),moves:y.moves.map(F=>[F.lineRangeMapping.original.startLineNumber,F.lineRangeMapping.original.endLineNumberExclusive,F.lineRangeMapping.modified.startLineNumber,F.lineRangeMapping.modified.endLineNumberExclusive,P(F.changes)])}}static n(i,a){const N=i.getLineCount(),m=a.getLineCount();if(N!==m)return!1;for(let w=1;w<=N;w++){const M=i.getLineContent(w),p=a.getLineContent(w);if(M!==p)return!1}return!0}async computeDirtyDiff(i,a,N){const m=this.j(i),w=this.j(a);if(!m||!w)return null;const M=m.getLinesContent(),p=w.getLinesContent();return new $.$Fs(M,p,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:N,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(i,a,N){const m=this.j(i);if(!m)return a;const w=[];let M;a=a.slice(0).sort((y,k)=>{if(y.range&&k.range)return h.$os.compareRangesUsingStarts(y.range,k.range);const P=y.range?0:1,F=k.range?0:1;return P-F});let p=0;for(let y=1;y<a.length;y++)h.$os.getEndPosition(a[p].range).equals(h.$os.getStartPosition(a[y].range))?(a[p].range=h.$os.fromPositions(h.$os.getStartPosition(a[p].range),h.$os.getEndPosition(a[y].range)),a[p].text+=a[y].text):(p++,a[p]=a[y]);a.length=p+1;for(let{range:y,text:k,eol:P}of a){if(typeof P=="number"&&(M=P),h.$os.isEmpty(y)&&!k)continue;const F=m.getValueInRange(y);if(k=k.replace(/\r\n|\n|\r/g,m.eol),F===k)continue;if(Math.max(k.length,F.length)>c.o){w.push({range:y,text:k});continue}const I=(0,_.$ts)(F,k,N),q=m.offsetAt(h.$os.lift(y).getStartPosition());for(const C of I){const T=m.positionAt(q+C.originalStart),j=m.positionAt(q+C.originalStart+C.originalLength),z={text:k.substr(C.modifiedStart,C.modifiedLength),range:{startLineNumber:T.lineNumber,startColumn:T.column,endLineNumber:j.lineNumber,endColumn:j.column}};m.getValueInRange(z.range)!==z.text&&w.push(z)}}return typeof M=="number"&&w.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}computeHumanReadableDiff(i,a,N){const m=this.j(i);if(!m)return a;const w=[];let M;a=a.slice(0).sort((p,y)=>{if(p.range&&y.range)return h.$os.compareRangesUsingStarts(p.range,y.range);const k=p.range?0:1,P=y.range?0:1;return k-P});for(let{range:p,text:y,eol:k}of a){let T=function(z,x){return new r.$ns(z.lineNumber+x.lineNumber-1,x.lineNumber===1?z.column+x.column-1:x.column)},j=function(z,x){const X=[];for(let n=x.startLineNumber;n<=x.endLineNumber;n++){const ne=z[n-1];n===x.startLineNumber&&n===x.endLineNumber?X.push(ne.substring(x.startColumn-1,x.endColumn-1)):n===x.startLineNumber?X.push(ne.substring(x.startColumn-1)):n===x.endLineNumber?X.push(ne.substring(0,x.endColumn-1)):X.push(ne)}return X};if(typeof k=="number"&&(M=k),h.$os.isEmpty(p)&&!y)continue;const P=m.getValueInRange(p);if(y=y.replace(/\r\n|\n|\r/g,m.eol),P===y)continue;if(Math.max(y.length,P.length)>c.o){w.push({range:p,text:y});continue}const F=P.split(/\r\n|\n|\r/),I=y.split(/\r\n|\n|\r/),q=e.$fZ.getDefault().computeDiff(F,I,N),C=h.$os.lift(p).getStartPosition();for(const z of q.changes)if(z.innerChanges)for(const x of z.innerChanges)w.push({range:h.$os.fromPositions(T(C,x.originalRange.getStartPosition()),T(C,x.originalRange.getEndPosition())),text:j(I,x.modifiedRange).join(m.eol)});else throw new R.$bb("The experimental diff algorithm always produces inner changes")}return typeof M=="number"&&w.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(i){const a=this.j(i);return a?(0,l.$SY)(a):null}async computeDefaultDocumentColors(i){const a=this.j(i);return a?(0,L.$gZ)(a):null}static{this.p=1e4}async textualSuggest(i,a,N,m){const w=new A.$Id,M=new RegExp(N,m),p=new Set;e:for(const y of i){const k=this.j(y);if(k){for(const P of k.words(M))if(!(P===a||!isNaN(Number(P)))&&(p.add(P),p.size>c.p))break e}}return{words:Array.from(p),duration:w.elapsed()}}async computeWordRanges(i,a,N,m){const w=this.j(i);if(!w)return Object.create(null);const M=new RegExp(N,m),p=Object.create(null);for(let y=a.startLineNumber;y<a.endLineNumber;y++){const k=w.getLineWords(y,M);for(const P of k){if(!isNaN(Number(P.word)))continue;let F=p[P.word];F||(F=[],p[P.word]=F),F.push({startLineNumber:y,startColumn:P.startColumn,endLineNumber:y,endColumn:P.endColumn})}}return p}async navigateValueSet(i,a,N,m,w){const M=this.j(i);if(!M)return null;const p=new RegExp(m,w);a.startColumn===a.endColumn&&(a={startLineNumber:a.startLineNumber,startColumn:a.startColumn,endLineNumber:a.endLineNumber,endColumn:a.endColumn+1});const y=M.getValueInRange(a),k=M.getWordAtPosition({lineNumber:a.startLineNumber,column:a.startColumn},p);if(!k)return null;const P=M.getValueInRange(k);return s.$TY.INSTANCE.navigateValueSet(a,y,k,P,N)}loadForeignModule(i,a,N){const m=(p,y)=>this.d.fhr(p,y),M={host:(0,v.$an)(N,m),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(M,a),Promise.resolve((0,v.$_m)(this.h))):new Promise((p,y)=>{O([i],k=>{this.h=k.create(M,a),p((0,v.$_m)(this.h))},y)})}fmr(i,a){if(!this.h||typeof this.h[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this.h[i].apply(this.h,a))}catch(N){return Promise.reject(N)}}}t.EditorSimpleWorker=c;function f(u){return new c(u,null)}t.create=f,typeof importScripts=="function"&&(globalThis.monaco=(0,g.$VY)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/df7d3d054020b0775fc2445c25ada7450c508524/core/vs/base/worker/workerMain.js.map
